using System;
using System.Diagnostics;
using com.epson.bank.driver;

namespace TMS_Sample
{
	class COcrAB
	{
		private const int OCR_AB_START_X =  30;
		private const int OCR_AB_START_Y =  56;
		private const int OCR_AB_END_X   = 110;
		private const int OCR_AB_END_Y   =  70;

		private CProperty_1 m_objProperty = null;

		public COcrAB()
		{
		}

		public ErrorCode Init(CProperty_1 objProperty)
		{
			ErrorCode errResult = ErrorCode.SUCCESS;
			m_objProperty = objProperty;

			return errResult;
		}

		public ErrorCode SetOcrABSetting()
		{
			ErrorCode errResult = ErrorCode.SUCCESS;

			m_objProperty.GetMfOcrAB().OcrType       = m_objProperty.GetOcrABFont();
			m_objProperty.GetMfOcrAB().Direction     = MfDirection.MF_OCR_LEFTRIGHT;
			m_objProperty.GetMfOcrAB().SpeceHandling = MfSpeceHandling.OCR_SPACE_ENABLE;
			m_objProperty.GetMfOcrAB().StartX        = OCR_AB_START_X;
			m_objProperty.GetMfOcrAB().StartY        = OCR_AB_START_Y;
			m_objProperty.GetMfOcrAB().EndX          = OCR_AB_END_X;
			m_objProperty.GetMfOcrAB().EndY          = OCR_AB_END_Y;

			return errResult;
		}

		public ErrorCode GetOcrABFunction(ref COcrABResult objOcrABResult)
		{
			ErrorCode errResult = ErrorCode.SUCCESS;

			if (objOcrABResult == null)
			{
				return ErrorCode.ERR_PARAM;
			}

			errResult = m_objProperty.GetMfDevice().SCNSelectScanFace(ScanSide.MF_SCAN_FACE_FRONT);
			Debug.Assert(errResult == ErrorCode.SUCCESS);
			if (errResult != ErrorCode.SUCCESS)
			{
				return errResult;
			}

			errResult = m_objProperty.GetMfDevice().GetOcrABText((uint)m_objProperty.GetTransactionNumber(), OcrImageSource.OCR_SOURCE_TRANSACTION_NUMBER, "", m_objProperty.GetMfOcrAB());
			Debug.Assert(errResult == ErrorCode.SUCCESS || errResult == ErrorCode.ERR_MICR_NODATA);
			if (errResult != ErrorCode.SUCCESS)
			{
				return errResult;
			}

			objOcrABResult.SetTransactionNumber(m_objProperty.GetTransactionNumber());
			objOcrABResult.SetResult(m_objProperty.GetMfOcrAB().Ret);
			objOcrABResult.SetOcrStr(m_objProperty.GetMfOcrAB().OcrStr);
			objOcrABResult.SetOcrReliableInfo(m_objProperty.GetMfOcrAB().OcrReliableInfo);

			return errResult;
		}
	}
}
