// TMS_Sample.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "TMS_Sample.h"
#include "TMS_SampleDlg.h"

// CTMS_SampleApp

BEGIN_MESSAGE_MAP(CTMS_SampleApp, CWinApp)
	ON_COMMAND(ID_HELP, &CWinApp::OnHelp)
END_MESSAGE_MAP()


// CTMS_SampleApp construction

CTMS_SampleApp::CTMS_SampleApp(void)
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

// The one and only CTMS_SampleApp object

CTMS_SampleApp theApp;


// CTMS_SampleApp initialization

BOOL CTMS_SampleApp::InitInstance(void)
{
	// InitCommonControlsEx() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);
	// Set this to include all the common control classes you want to use
	// in your application.
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);

	CWinApp::InitInstance();

	// Prevent launching multiple instances
	if( !CheckOverlapExecute() ){
		MessageBox( NULL, MSG_04_000, CAPTION_04_000, MB_OK | MB_ICONWARNING );
		return FALSE;
	}

	CTMS_SampleDlg dlg;
	m_pMainWnd = &dlg;
	INT_PTR nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

/////////////////////////////////////////////////////////////////////
// EnumWindowCallbackFunc
//
// Comments		EnumWindows callback function
//
// Parameter	hWnd	:Handle of found window
//				lParam	:[Out] Window handle found first
//
// Return		TRUE	:Continue to find
//				FALSE	:Cancel to find
//
// Modify History
//-------------------------------------------------------------------
// 2006/03/20	New
//
BOOL CALLBACK CTMS_SampleApp::EnumWindowCallbackFunc( HWND hWnd, LPARAM lParam )
{
	// Check if a window that has specified mutex name in the property
	HANDLE hHandle = ::GetProp( hWnd, STR_NAME_MUTEX );

	if( hHandle != NULL ){
		// If yes, set return found window handle
		HWND* phWnd = (HWND*)lParam;
		if( phWnd != NULL ){
			*phWnd = hWnd;
		}

		return FALSE;
	}

	return TRUE;
}

/////////////////////////////////////////////////////////////////////
// CheckOverlapExecute
//
// Comments		Check duplicate running
//
// Return		TRUE	:OK to run
//				FALSE	:Unable to contiune (Duplicate running, error)
//
// Note			If the application is already running, the window comes to top most.
//
// Modify History
//-------------------------------------------------------------------
// 2006/08/2	New
//
bool CTMS_SampleApp::CheckOverlapExecute(void)
{
	// Create a mutex

	// Specify security ID
	SECURITY_DESCRIPTOR sd;
	::InitializeSecurityDescriptor(&sd, SECURITY_DESCRIPTOR_REVISION);
	::SetSecurityDescriptorDacl(&sd, TRUE, NULL, FALSE);

	SECURITY_ATTRIBUTES sa;
	sa.nLength = sizeof(SECURITY_ATTRIBUTES);
	sa.lpSecurityDescriptor = &sd;
	sa.bInheritHandle = TRUE;

	// Create mutex with security ID
	m_hMutex = CreateMutex( &sa, TRUE, STR_NAME_MUTEX );

	if( m_hMutex == NULL ){
		return false;
	}

	// Check if already running
	if( GetLastError() == ERROR_ALREADY_EXISTS ){

		// Find window handles of excecutable programs
		HWND hWnd = NULL;
		if( ::EnumWindows( &EnumWindowCallbackFunc, (LPARAM)&hWnd ) != ERROR_SUCCESS ){
			// Release the mutex
			ReleaseMutex( m_hMutex );
			CloseHandle( m_hMutex );
			m_hMutex = NULL;
			return false;
		}

		if( hWnd != NULL ){

			// If iconized, restore to original size
			if( IsIconic( hWnd ) ){
				ShowWindow( hWnd, SW_RESTORE );
			}

			// Go foreground
			SetForegroundWindow( ::GetLastActivePopup( hWnd ) );
		}

		// Release the mutex
		ReleaseMutex( m_hMutex );
		CloseHandle( m_hMutex );
		m_hMutex = NULL;
		return false;
	}

	return true;
}
