// TMS_SampleDlg.h : header file
//

#pragma once
#include "afxwin.h"
#include <shlwapi.h>

// Callback from DriverControl
// Step 1
int CALLBACK CallbackFuncProcessError( short sErrorStatus );


// CTMS_SampleDlg dialog
class CTMS_SampleDlg : public CDialog
{
// Construction
public:
	CTMS_SampleDlg(CWnd* pParent = NULL);	// standard constructor
	virtual ~CTMS_SampleDlg(void);

	// Dialog resouce ID
	enum { IDD = IDD_TMS_SAMPLE_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

	// Generated message map functions
	virtual BOOL OnInitDialog(void);
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint(void);
	afx_msg HCURSOR OnQueryDragIcon(void);
	DECLARE_MESSAGE_MAP()
	virtual BOOL DestroyWindow(void);
public:
	// Step 1
	afx_msg void OnBnClickedButtonScan(void);
	afx_msg void OnBnClickedButtonScanCancel(void);
	afx_msg void OnBnClickedButtonExit(void);

// Control
protected:
	// Step 1
	CButton	m_btnScan;
	CButton	m_btnScanCancel;
	CButton	m_btnExit;

// Processing after received callback from DriverControl
public:
	// Step 1
	void CallbackProcProcessError( short sErrorStatus );

// Member Function
protected:
	// Step 1
	bool	InitializeDriver(void);
	int		TerminateDriver(void);
	void	ShowErrorMessage(int nResult );
	LPCTSTR GetErrorString(int nResultCode);
	void	LoadResourceString(void);

// Implementation
protected:
	HICON m_hIcon;
	bool m_bScanCancelError;

private:
	// Step 1
	CApp *		m_pcDriverControl;
};
