#if !defined(SAMPLE_ADD27880_C955_40d2_9502_3A8148E05B81)
#define SAMPLE_ADD27880_C955_40d2_9502_3A8148E05B81

#pragma once

// Step 1
#include "Scan.h"
#include "Micr.h"
#include "Option.h"

typedef int(__stdcall * PROCESS_ERROR_BACK_FUNC)(short);

// Step 2
#include "ScanParam.h"
#include "Image_1.h"

typedef int(__stdcall * COMPLATE_BACK_FUNC)(int);
typedef int(__stdcall * MICR_IMAGE_BACK_FUNC)(unsigned long ulTransactionNumber);

//#define EXEC_SCAN_CHECK	0
//#define EXEC_SCAN_CARD	1

// Step 3
#include "MicrParam.h"

// Step 5
#include "PrintParam.h"
#include "Print.h"

#define EXEC_SCAN_CHECK					0
#define EXEC_SCAN_CARD					1
#define EXEC_PRINT_CAHSHERSCHECK		2
#define EXEC_PRINT_RECEIPT				3

typedef int(__stdcall * PRINT_CASHERSCHECK_BACK_FUNC)(void);
typedef int(__stdcall * PRINT_RECEIPT_BACK_FUNC)(unsigned long ulTransactionNumber);

class CApp
{
private:
	// Step 1
	CProperty_1								m_CCProperty;
	CScan									m_CCScan;
	CMicr									m_CCMicr;
	COption									m_CCOption;
	PROCESS_ERROR_BACK_FUNC					m_pFuncProcessErrorCB;

	// Step 1
	DLL_BiOpenMonPrinter					BiOpenMonPrinter;
	DLL_BiCloseMonPrinter					BiCloseMonPrinter;
	DLL_BiSCNMICRSetStatusBackFunction		BiSCNMICRSetStatusBackFunction;
	DLL_BiSCNMICRCancelStatusBack			BiSCNMICRCancelStatusBack;
	DLL_BiCancelError						BiCancelError;
	DLL_BiGetStatus							BiGetStatus;
	DLL_BiGetInkStatus						BiGetInkStatus;

	// Step 2
	CImage_1								m_CCImage;
	MICR_IMAGE_BACK_FUNC					m_pFuncImageCB;

	// Step 2
	DLL_BiGetPrnCapability					BiGetPrnCapability;

	// Step 3
	BYTE									m_byExecType;
	MICR_IMAGE_BACK_FUNC					m_pFuncMicrCB;

	// Step 5
	CPrint									m_CCPrint;
	PRINT_CASHERSCHECK_BACK_FUNC			m_pFuncCashierscheckCB;
	PRINT_RECEIPT_BACK_FUNC					m_pFuncReceiptCB;

	// Step 5
	DLL_BiStartEndorsementSetStatusBackFunction	BiStartEndorsementSetStatusBackFunction;
	DLL_BiStartEndorsementCancelStatusBack		BiStartEndorsementCancelStatusBack;
	DLL_BiEndEndorsementSetStatusBackFunction	BiEndEndorsementSetStatusBackFunction;
	DLL_BiEndEndorsementCancelStatusBack		BiEndEndorsementCancelStatusBack;

public:
	// Step 1
	CApp(void);
	virtual ~CApp(void);

	int		InitDevice(void);
	int		ExitDevice(void);
	int		CancelError(void);
	int		CancelScan(void);
	int		ScanCheck(void);
	int		GetDeviceStatus(LPDWORD lpStatus);
	int		GetInkStatus(LPWORD lpStatus);
	void	SetProcessErrorCallback(PROCESS_ERROR_BACK_FUNC pProcessErrorCB);

	// Step 2
	void	SetImageCallback(MICR_IMAGE_BACK_FUNC pImageCB);
	void	SetScanParam(CScanParam* pScanParam);
	void	GetScanParam(CScanParam* pScanParam);
	int		GetScanImage(CImageResult* pImageResult);
	int		ScanCard(void);
	bool	IsScanningCardIR1PassSupported(void);

	// Step 3
	void	SetMicrCallback(MICR_IMAGE_BACK_FUNC pMicrCB);
	void	SetMicrParam(CMicrParam* pMicrParam);
	void	GetMicrParam(CMicrParam* pMicrParam);
	int		GetMicr(CMicrResult* pMicrResult);
	int		CleaningMicr(void);

	// Step 5
	void	SetPrintParam(CPrintParam* pPrintParam);
	void	GetPrintParam(CPrintParam* pPrintParam);
	int		PrintRollpaper(void); // S9000 only
	int		PrintReceipt(void);
	int		PrintCashierscheck(void);
	int		GetCashiersCheckImage(CImageResult* pImageResult);
	int		PrintCacherscheckFunction(void);
	int		PrintReceiptFunction(unsigned long ulTransactionNumber);
	void	SetPrintCashiersCheckCallback(PRINT_CASHERSCHECK_BACK_FUNC pCashierscheckCB);
	void	SetPrintReceiptCallback(PRINT_RECEIPT_BACK_FUNC pReceiptCB);
	bool    IsRollPaperSupported(void);

private:
	// Step 1
	void		GetAPIProcAddress(void);
	static int	CALLBACK cbScanStatus(DWORD dwTransactionNumber, WORD wMainStatus, WORD wSubStatus, LPSTR pPortName);
	int			ScanStatus(DWORD dwTransactionNumber, WORD wMainStatus, WORD wSubStatus, LPSTR pPortName);

	// Step 5
	static int	CALLBACK cbStartEndorsement(unsigned long ulTransactionNumber, LPSTR lpcPortName);
	static int	CALLBACK cbEndEndorsement(unsigned long ulTransactionNumber, LPSTR lpcPortName);
	int			StartEndorsement(unsigned long ulTransactionNumber, LPSTR lpcPortName);
	int			EndEndorsement(unsigned long ulTransactionNumber, LPSTR lpcPortName);
};

#endif  /* !defined(SAMPLE_ADD27880_C955_40d2_9502_3A8148E05B81) */
