// TMS_SampleDlg.h : header file
//

#pragma once
#include "afxwin.h"
#include <shlwapi.h>
// Step 2
#include "ImageBox.h"

// Callback from DriverControl
// Step 1
int CALLBACK CallbackFuncProcessError( short sErrorStatus );
// Step 2
int CALLBACK CallbackFuncImage(unsigned long ulTransactionNumber);
// Step 3
int CALLBACK CallbackFuncMicr(unsigned long ulTransactionNumber);
// Step 5
int CALLBACK CallbackFuncCashierscheck(void);
int CALLBACK CallbackFuncReceipt(void);


// CTMS_SampleDlg dialog
class CTMS_SampleDlg : public CDialog
{
// Construction
public:
	CTMS_SampleDlg(CWnd* pParent = NULL);	// standard constructor
	virtual ~CTMS_SampleDlg(void);

	// Dialog resouce ID
	enum { IDD = IDD_TMS_SAMPLE_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

	// Generated message map functions
	virtual BOOL OnInitDialog(void);
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint(void);
	afx_msg HCURSOR OnQueryDragIcon(void);
	DECLARE_MESSAGE_MAP()
	virtual BOOL DestroyWindow(void);
public:
	// Step 1
	afx_msg void OnBnClickedButtonScan(void);
	afx_msg void OnBnClickedButtonScanCancel(void);
	afx_msg void OnBnClickedButtonExit(void);
	// Step 2
	afx_msg void OnBnClickedButtonConfig(void);
	// Step 3
	afx_msg void OnBnClickedButtonMicrCleaning(void);
	// Step 5
	afx_msg void OnBnClickedButtonPrint(void);

// Control
protected:
	// Step 1
	CButton	m_btnScan;
	CButton	m_btnScanCancel;
	CButton	m_btnExit;

	// Step 2
	CStatic	m_stImage2Front;
	CStatic	m_stImage2Back;
	CStatic	m_stImage4RGBFront;
	CStatic	m_stImage4RGBBack;
	CStatic	m_stImage4IrFront;
	CStatic	m_stImage4IrBack;

	CButton	m_btnConfig;

	// Step 3
	CStatic	m_stMicrText;
	CEdit	m_edtMicrText;

	CButton	m_btnMicrCleaning;

	// Step 5
	CButton m_btnPrint;

// Processing after received callback from DriverControl
public:
	// Step 1
	void CallbackProcProcessError( short sErrorStatus );
	// Step 2
	void CallbackProcImage(void);
	// Step 3
	void CallbackProcMicr(void);
	// Step 5
	void CallbackProcCashierscheck(void);
	void CallbackProcReceipt(unsigned long ulTransactionNumber);

// Member Function
protected:
	// Step 1
	bool	InitializeDriver(void);
	int		TerminateDriver(void);
	void	ShowErrorMessage(int nResult );
	LPCTSTR GetErrorString(int nResultCode);
	void	LoadResourceString(void);
	// Step 2
	void	InitializeConfigData(void);
	void	ConvertScanParamToConfigData( const CScanParam* pcScanParam,  CONFIGDATA* psConfigData ) const;
	void	ConvertConfigDataToScanParam( const CONFIGDATA* psConfigData, CScanParam* pcScanParam  ) const;
	void	UpdateControls(void);
	CString	PrepareFolder(void);
	void	UpdateImageData( BYTE byFace, BYTE byLightSource, short sResolution, BYTE byColorDepth, CImageBox& Image, bool bSave );
	void	ClearImage(void);
	// Step 3
	void	ConvertMicrParamToConfigData( const CMicrParam* pcMicrParam,  CONFIGDATA* psConfigData ) const;
	void	ConvertConfigDataToMicrParam( const CONFIGDATA* psConfigData, CMicrParam* pcMicrParam  ) const;
	void	SaveMicrData(void);
	// Step 5
	void	ConvertPrintParamToConfigData( const CPrintParam* pcPrintParam, CONFIGDATA* psConfigData  ) const;
	void	ConvertConfigDataToPrintParam( const CONFIGDATA* psConfigData,  CPrintParam* pcPrintParam ) const;
	
// Implementation
protected:
	HICON m_hIcon;
	bool m_bScanCancelError;

private:
	// Step 1
	CApp *		m_pcDriverControl;
	// Step 2
	CONFIGDATA	m_sConfigData;
	CImageBox	m_Image2Front;
	CImageBox	m_Image2Back;
	CImageBox	m_Image4RGBFront;
	CImageBox	m_Image4RGBBack;
	CImageBox	m_Image4IrFront;
	CImageBox	m_Image4IrBack;
	// Step 5
	BYTE		m_byExecType;
};
