#include "stdafx.h"
#include "OcrAB.h"

COcrAB::COcrAB(void)
{
	m_pCProperty = NULL;
}

COcrAB::~COcrAB(void)
{
}

int COcrAB::Init(CProperty_1* pProperty)
{
	int nResult = SUCCESS;

	m_pCProperty = pProperty;

	GetAPIProcAddress();

	return nResult;
}

// Set OCR-AB settings
int COcrAB::SetOcrABSetting(void)
{
	int nResult = SUCCESS;

	m_pCProperty->GetMfOcrAB()->iSize			= sizeof(MF_OCR_AB);
	m_pCProperty->GetMfOcrAB()->iVersion		= MF_OCR_AB_VERSION;
	m_pCProperty->GetMfOcrAB()->bOcrType		= m_pCProperty->GetOcrABFont();
	m_pCProperty->GetMfOcrAB()->bDirection		= MF_OCR_LEFTRIGHT;
	m_pCProperty->GetMfOcrAB()->bSpaceHandling	= OCR_SPACE_ENABLE;
	m_pCProperty->GetMfOcrAB()->wStartX			= OCR_AB_START_X;
	m_pCProperty->GetMfOcrAB()->wStartY			= OCR_AB_START_Y;
	m_pCProperty->GetMfOcrAB()->wEndX			= OCR_AB_END_X;
	m_pCProperty->GetMfOcrAB()->wEndY			= OCR_AB_END_Y;
	::ZeroMemory(m_pCProperty->GetMfOcrAB()->szOcrStr, sizeof(m_pCProperty->GetMfOcrAB()->szOcrStr));

	return nResult;
}

// Obtain OCR-AB data
int COcrAB::GetOcrABFunction(COcrABResult* pOcrABResult)
{
	int nResult = SUCCESS;

	if(pOcrABResult == NULL)
	{
		return ERR_UNKNOWN;
	}

	nResult = BiSCNSelectScanFace(m_pCProperty->GetHandle(), MF_SCAN_FACE_FRONT);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	nResult = BiGetOcrABText(m_pCProperty->GetHandle(), m_pCProperty->GetTransactionNumber(), OCR_SOURCE_TRANSACTION_NUMBER, "", m_pCProperty->GetMfOcrAB());
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	pOcrABResult->SetTransactionNumber(m_pCProperty->GetTransactionNumber());
	pOcrABResult->SetResult(m_pCProperty->GetMfOcrAB()->iRet);
	pOcrABResult->SetOcrStr(m_pCProperty->GetMfOcrAB()->szOcrStr);
	pOcrABResult->SetOcrReliableInfo(m_pCProperty->GetMfOcrAB()->stOcrReliableInfo);

	return nResult;
}

// Get functions of the API
void COcrAB::GetAPIProcAddress(void)
{
	HINSTANCE hLibrary = m_pCProperty->GetLibrary();

	BiGetOcrABText		= (DLL_BiGetOcrABText)				GetProcAddress(hLibrary, "BiGetOcrABText");
	BiSCNSelectScanFace	= (DLL_BiSCNSelectScanFace)			GetProcAddress(hLibrary, "BiSCNSelectScanFace");
}
