////////////////
//// Step 7 ////
////////////////

// ConfirmationDlg.cpp : Implementation
//

#include "stdafx.h"
#include "Resource.h"
#include "ConfirmationDlg.h"


// ConfirmationDlg Dialog

IMPLEMENT_DYNAMIC(CConfirmationDlg, CDialog)

CConfirmationDlg::CConfirmationDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConfirmationDlg::IDD, pParent)
{
}

CConfirmationDlg::~CConfirmationDlg(void)
{
}

void CConfirmationDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_BUTTON_CM_OK, m_btnOk);

	DDX_Control(pDX, IDC_GROUP_EJECTPOCKET, m_stGroupCMEjectPocket);
	DDX_Control(pDX, IDC_RADIO_EP_MAINPOCKET, m_btnRadioEPMainPocket);
	DDX_Control(pDX, IDC_RADIO_EP_SUBPOCKET, m_btnRadioEPSubPocket);
	DDX_Control(pDX, IDC_CHECK_CM_CANCEL, m_btnCheckCMCancel);
}

BEGIN_MESSAGE_MAP(CConfirmationDlg, CDialog)

	ON_BN_CLICKED(IDC_BUTTON_CM_OK, &CConfirmationDlg::OnBnClickedOK)

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////
// CConfigureDlg message handlers
/////////////////////////////////////////////////////////////////

BOOL CConfirmationDlg::OnInitDialog(void)
{
	CDialog::OnInitDialog();

	LoadResourceString();

	InitControlData();

	SetControlData();

	return TRUE;  // return TRUE unless you set the focus to a control
}

void CConfirmationDlg::LoadResourceString(void)
{
	m_btnOk.SetWindowText( STR_CONFIRMATIONDLG_BUTTON_OK );

	m_stGroupCMEjectPocket.SetWindowText( STR_CONFIRMATIONDLG_GROUP_EJECTPOCKET );
	m_btnRadioEPMainPocket.SetWindowText( STR_CONFIRMATIONDLG_RADIO_EP_MAINPOCKET );
	m_btnRadioEPSubPocket.SetWindowText( STR_CONFIRMATIONDLG_RADIO_EP_SUBPOCKET );
	m_btnCheckCMCancel.SetWindowText( STR_CONFIRMATIONDLG_CHECK_CANCEL );
}

void CConfirmationDlg::GetControlData(void)
{
	if( m_btnRadioEPMainPocket.GetCheck() == 1 )
	{
		m_sConfirmationData.nRadio_Confirmation_EjectPocket = VAL_CONFIRMATIONDLG_RADIO_EP_MAINPOCKET;
	}
	else if( m_btnRadioEPSubPocket.GetCheck() == 1 )
	{
		m_sConfirmationData.nRadio_Confirmation_EjectPocket = VAL_CONFIRMATIONDLG_RADIO_EP_SUBPOCKET;
	}

	m_sConfirmationData.nCheck_Confirmation_Cancel = m_btnCheckCMCancel.GetCheck();
}

void CConfirmationDlg::InitControlData(void)
{
	m_sConfirmationData.nRadio_Confirmation_EjectPocket = VAL_CONFIRMATIONDLG_RADIO_EP_MAINPOCKET;
	m_sConfirmationData.nCheck_Confirmation_Cancel		= VAL_CONFIRMATIONDLG_CHECK_CM_CANCEL_OFF;
}

void CConfirmationDlg::SetControlData(void)
{
	switch( m_sConfirmationData.nRadio_Confirmation_EjectPocket )
	{
		case VAL_CONFIRMATIONDLG_RADIO_EP_MAINPOCKET:
			m_btnRadioEPMainPocket.SetCheck(1);
			m_btnRadioEPSubPocket.SetCheck(0);
			break;
		case VAL_CONFIRMATIONDLG_RADIO_EP_SUBPOCKET:
			m_btnRadioEPMainPocket.SetCheck(0);
			m_btnRadioEPSubPocket.SetCheck(1);
			break;
		default:
			break;
	}

	switch( m_sConfirmationData.nCheck_Confirmation_Cancel )
	{
		case VAL_CONFIRMATIONDLG_CHECK_CM_CANCEL_OFF:
			m_btnCheckCMCancel.SetCheck(0);
			break;
		case VAL_CONFIRMATIONDLG_CHECK_CM_CANCEL_ON:
			m_btnCheckCMCancel.SetCheck(1);
			break;
		default:
			break;
	}
}

void CConfirmationDlg::GetConfirmationData( LPCONFIRMATIONDATA psConfirmationData )
{
	if( psConfirmationData != NULL )
	{
		psConfirmationData->Copy( m_sConfirmationData );
	}
}

void CConfirmationDlg::OnBnClickedOK(void)
{
	GetControlData();
	OnOK();
}
