
#define STR_NAME_MUTEX	_T("Mutex EPSON TM-S Sample Program Step7")

typedef struct tagConfigData
{
	// Step 2
	int	nRadio_ScanningMedia;
	int	nRadio_LightSourceToScan;
	int	nRadio_RGBColorDepth;
	int	nRadio_IRColorDepth;
	int	nCombo_Resolution;
	int nEdit_NumberOfDocuments;
	int	nCheck_Scan_SaveFile;
	bool bIsScanningCardIR1PassSupported;

	// Step 3
	int	nRadio_MICRFont;
	int	nCheck_MICR_ClearSpace;
	int	nCheck_MICR_SaveFile;

	// Step 7
	int nRadio_ActivationMode;
	int nCheck_ConfirmationByUser;
	int nCombo_WaterfallMode;
	// Step 7
	int nCheck_IQA_Detect;
	int nCheck_IQA_Cancel;
	int nCombo_IqaEjectPocket;
	int nCombo_IqaColorDepth;
	int nCheck_IQA_UnderSize;
	int nCheck_IQA_OverSize;
	int nCheck_IQA_MinCompressed;
	int nCheck_IQA_MaxCompressed;
	int nCheck_IQA_FrontRearMismatch;
	int nCheck_IQA_TooLight;
	int nCheck_IQA_TooDark;
	int nCheck_IQA_HorizontalStreaks;
	int nCheck_IQA_SpotNoise;
	int nCheck_IQA_OutOfFocus;
	int nCheck_IQA_DocCorners;
	int nCheck_IQA_DocEdges;
	int nCheck_IQA_FramingError;
	int nCheck_IQA_Skew;
	int nCheck_IQA_CarbonStrip;
	int nCheck_IQA_Piggyback;

	tagConfigData(void)
	{
		// Step 2
		nRadio_ScanningMedia		= VAL_CONFIGDLG_RADIO_SM_CHECKPAPER;
		nRadio_LightSourceToScan	= VAL_CONFIGDLG_RADIO_IC_RGB;
		nRadio_RGBColorDepth		= VAL_CONFIGDLG_RADIO_RGBCD_COLOR;
		nRadio_IRColorDepth			= VAL_CONFIGDLG_RADIO_IRCD_GRAY;
		nCombo_Resolution			= VAL_CONFIGDLG_COMBO_RE_200200;
		nEdit_NumberOfDocuments		= 0;
		nCheck_Scan_SaveFile		= VAL_CONFIGDLG_CHECK_SC_SAVEFILE_ON;
		bIsScanningCardIR1PassSupported = false;

		// Step 3
		nRadio_MICRFont				= VAL_CONFIGDLG_RADIO_MF_E13B;
		nCheck_MICR_ClearSpace		= VAL_CONFIGDLG_CHECK_MI_CLEARSPACE_OFF;
		nCheck_MICR_SaveFile		= VAL_CONFIGDLG_CHECK_MI_SAVEFILE_OFF;

		// Step 7
		nRadio_ActivationMode			= VAL_CONFIGDLG_RADIO_AM_HIGHSPEED;
		nCheck_ConfirmationByUser		= VAL_CONFIGDLG_CHECK_AM_CONFIRMATION_BY_USER_OFF;
		nCombo_WaterfallMode			= VAL_CONFIGDLG_COMBO_WM_DISABLE;
		// Step 7
		nCheck_IQA_Detect				= VAL_CONFIGDLG_CHECK_IQ_DETECT_OFF;
		nCheck_IQA_Cancel				= VAL_CONFIGDLG_CHECK_IQ_CANCEL_OFF;
		nCombo_IqaEjectPocket			= VAL_CONFIGDLG_COMBO_EP_MAINPOCKET;
		nCombo_IqaColorDepth			= VAL_CONFIGDLG_COMBO_CD_GRAY;
		nCheck_IQA_UnderSize			= VAL_CONFIGDLG_CHECK_IQ_UNDERSIZE_OFF;
		nCheck_IQA_OverSize				= VAL_CONFIGDLG_CHECK_IQ_OVERSIZE_OFF;
		nCheck_IQA_MinCompressed		= VAL_CONFIGDLG_CHECK_IQ_MINCOMPRESSED_OFF;
		nCheck_IQA_MaxCompressed		= VAL_CONFIGDLG_CHECK_IQ_MAXCOMPRESSED_OFF;
		nCheck_IQA_FrontRearMismatch	= VAL_CONFIGDLG_CHECK_IQ_FRONTREARMISMATCH_OFF;
		nCheck_IQA_TooLight				= VAL_CONFIGDLG_CHECK_IQ_TOOLIGHT_OFF;
		nCheck_IQA_TooDark				= VAL_CONFIGDLG_CHECK_IQ_TOODARK_OFF;
		nCheck_IQA_HorizontalStreaks	= VAL_CONFIGDLG_CHECK_IQ_HORIZONTALSTREAK_OFF;
		nCheck_IQA_SpotNoise			= VAL_CONFIGDLG_CHECK_IQ_SPOTNOISE_OFF;
		nCheck_IQA_OutOfFocus			= VAL_CONFIGDLG_CHECK_IQ_OUTOFFOCUS_OFF;
		nCheck_IQA_DocCorners			= VAL_CONFIGDLG_CHECK_IQ_DOCCORNER_OFF;
		nCheck_IQA_DocEdges				= VAL_CONFIGDLG_CHECK_IQ_DOCEDGE_OFF;
		nCheck_IQA_FramingError			= VAL_CONFIGDLG_CHECK_IQ_FRAMINGERROR_OFF;
		nCheck_IQA_Skew					= VAL_CONFIGDLG_CHECK_IQ_SKEW_OFF;
		nCheck_IQA_CarbonStrip			= VAL_CONFIGDLG_CHECK_IQ_CARBONSTRIP_OFF;
		nCheck_IQA_Piggyback			= VAL_CONFIGDLG_CHECK_IQ_PIGGYBACK_OFF;
	}

	void Copy( const tagConfigData & sData )
	{
		// Step 2
		nRadio_ScanningMedia		= sData.nRadio_ScanningMedia;
		nRadio_LightSourceToScan	= sData.nRadio_LightSourceToScan;
		nRadio_RGBColorDepth		= sData.nRadio_RGBColorDepth;
		nRadio_IRColorDepth			= sData.nRadio_IRColorDepth;
		nCombo_Resolution			= sData.nCombo_Resolution;
		nEdit_NumberOfDocuments		= sData.nEdit_NumberOfDocuments;
		nCheck_Scan_SaveFile		= sData.nCheck_Scan_SaveFile;
		bIsScanningCardIR1PassSupported = sData.bIsScanningCardIR1PassSupported;

		// Step 3
		nRadio_MICRFont				= sData.nRadio_MICRFont;
		nCheck_MICR_ClearSpace		= sData.nCheck_MICR_ClearSpace;
		nCheck_MICR_SaveFile		= sData.nCheck_MICR_SaveFile;

		// Step 7
		nRadio_ActivationMode			= sData.nRadio_ActivationMode;
		nCheck_ConfirmationByUser		= sData.nCheck_ConfirmationByUser;
		nCombo_WaterfallMode			= sData.nCombo_WaterfallMode;
		// Step 7
		nCheck_IQA_Detect				= sData.nCheck_IQA_Detect;
		nCheck_IQA_Cancel				= sData.nCheck_IQA_Cancel;
		nCombo_IqaEjectPocket			= sData.nCombo_IqaEjectPocket;
		nCombo_IqaColorDepth			= sData.nCombo_IqaColorDepth;
		nCheck_IQA_UnderSize			= sData.nCheck_IQA_UnderSize;
		nCheck_IQA_OverSize				= sData.nCheck_IQA_OverSize;
		nCheck_IQA_MinCompressed		= sData.nCheck_IQA_MinCompressed;
		nCheck_IQA_MaxCompressed		= sData.nCheck_IQA_MaxCompressed;
		nCheck_IQA_FrontRearMismatch	= sData.nCheck_IQA_FrontRearMismatch;
		nCheck_IQA_TooLight				= sData.nCheck_IQA_TooLight;
		nCheck_IQA_TooDark				= sData.nCheck_IQA_TooDark;
		nCheck_IQA_HorizontalStreaks	= sData.nCheck_IQA_HorizontalStreaks;
		nCheck_IQA_SpotNoise			= sData.nCheck_IQA_SpotNoise;
		nCheck_IQA_OutOfFocus			= sData.nCheck_IQA_OutOfFocus;
		nCheck_IQA_DocCorners			= sData.nCheck_IQA_DocCorners;
		nCheck_IQA_DocEdges				= sData.nCheck_IQA_DocEdges;
		nCheck_IQA_FramingError			= sData.nCheck_IQA_FramingError;
		nCheck_IQA_Skew					= sData.nCheck_IQA_Skew;
		nCheck_IQA_CarbonStrip			= sData.nCheck_IQA_CarbonStrip;
		nCheck_IQA_Piggyback			= sData.nCheck_IQA_Piggyback;
	}
} CONFIGDATA, *LPCONFIGDATA;

// Step 7
typedef struct tagConfirmationData
{
	int nRadio_Confirmation_EjectPocket;
	int nCheck_Confirmation_Cancel;

	tagConfirmationData(void)
	{
		nRadio_Confirmation_EjectPocket	= VAL_CONFIRMATIONDLG_RADIO_EP_MAINPOCKET;
		nCheck_Confirmation_Cancel		= VAL_CONFIRMATIONDLG_CHECK_CM_CANCEL_OFF;
	}

	void Copy( tagConfirmationData sData )
	{
		nRadio_Confirmation_EjectPocket	= sData.nRadio_Confirmation_EjectPocket;
		nCheck_Confirmation_Cancel		= sData.nCheck_Confirmation_Cancel;
	}
} CONFIRMATIONDATA, *LPCONFIRMATIONDATA;
