#include "stdafx.h"
#include "Property_1.h"

CProperty_1::CProperty_1(void)
{
	m_hLibrary				= NULL;
	m_nHandle				= 0;
	::ZeroMemory(&m_Mf_Base01, sizeof(MF_BASE01));
	::ZeroMemory(&m_Mf_Micr01, sizeof(MF_MICR01));
	::ZeroMemory(&m_Mf_ScanFront, sizeof(MF_SCAN));
	::ZeroMemory(&m_Mf_ScanBack, sizeof(MF_SCAN));
	::ZeroMemory(&m_Mf_Process, sizeof(MF_PROCESS01));
	m_byScanMedia			= EPS_BI_SCN_UNIT_CHECKPAPER;
	m_byLightSourceToScan	= EPS_BI_SCN_OPTION_COLOR;
	m_byRGBColorDepth		= EPS_BI_SCN_24BIT;
	m_byIRColorDepth		= EPS_BI_SCN_8BIT;
	m_sResolution			= MF_SCAN_DPI_200;
	m_byFont				= MF_MICR_FONT_E13B;
	m_bParsing				= false;
	m_bClearSpace			= false;
	m_dwTransactionNumber	= 0;

	m_bBuzzerSuccess		= false;
	m_bBuzzerDoubleFeed		= false;
	m_bBuzzerError			= false;

	m_byPaperMisInsertionDetect = MF_ERROR_SELECT_DETECT;
	m_byPaperMisInsertionEject	= MF_EJECT_MAIN_POCKET;
	m_byPaperMisInsertionCancel	= MF_CANCEL_DISABLE;
	m_byNoiseDetect				= MF_ERROR_SELECT_DETECT;
	m_byNoiseEject				= MF_EJECT_MAIN_POCKET;
	m_byNoiseCancel				= MF_CANCEL_DISABLE;
	m_byDoubleFeedDetect		= MF_ERROR_SELECT_DETECT;
	m_byDoubleFeedEject			= MF_EJECT_SUB_POCKET;
	m_byDoubleFeedCancel		= MF_CANCEL_DISABLE;
	m_byBaddataDetect			= MF_ERROR_SELECT_DETECT;
	m_byBaddataEject			= MF_EJECT_MAIN_POCKET;
	m_byBaddataCancel			= MF_CANCEL_DISABLE;
	m_byNodataDetect			= MF_ERROR_SELECT_DETECT;
	m_byNodataEject				= MF_EJECT_MAIN_POCKET;
	m_byNodataCancel			= MF_CANCEL_DISABLE;
	m_byActivation				= MF_ACTIVATE_MODE_HIGH_SPEED;
	m_byConfirmationEject		= MF_EJECT_MAIN_POCKET;
	m_byConfirmationCancel		= MF_PROCESS_CONTINUE_OVERLAP;
	m_byEndorsePrintMode		= MF_ENDORSEPRINT_MODE_HIGHSPEED;
	m_byPrnDataUnreceiveCancel	= MF_CANCEL_DISABLE;

	// Step 2
	m_nNumberOfDocuments = 0;

	// Step 7
	::ZeroMemory(&m_Mf_Iqa, sizeof(MF_IQA));
	::ZeroMemory(&m_Mf_IqaResult, sizeof(MF_IQA_RESULT));
	m_byIqaDetect				= MF_ERROR_SELECT_NODETECT;
	m_byColorDepth				= EPS_BI_SCN_8BIT;
	m_byCancel					= MF_CANCEL_DISABLE;
	m_byEjectPocket				= MF_EJECT_MAIN_POCKET;
	m_byUnderSize				= MF_IQA_TEST_DISABLE;
	m_byOverSize				= MF_IQA_TEST_DISABLE;
	m_byMinCompressed			= MF_IQA_TEST_DISABLE;
	m_byMaxCompressed			= MF_IQA_TEST_DISABLE;
	m_byFrontRearImageMismatch	= MF_IQA_TEST_DISABLE;
	m_byImageTooLight			= MF_IQA_TEST_DISABLE;
	m_byImageTooDark			= MF_IQA_TEST_DISABLE;
	m_byStreaks					= MF_IQA_TEST_DISABLE;
	m_bySpotNosise				= MF_IQA_TEST_DISABLE;
	m_byOutOfFocus				= MF_IQA_TEST_DISABLE;
	m_byFoldedTornCorner		= MF_IQA_TEST_DISABLE;
	m_byFoldedTornEdge			= MF_IQA_TEST_DISABLE;
	m_byFramingError			= MF_IQA_TEST_DISABLE;
	m_byExcessiveSkew			= MF_IQA_TEST_DISABLE;
	m_byCarbon					= MF_IQA_TEST_DISABLE;
	m_byPiggyback				= MF_IQA_TEST_DISABLE;

	// Step 7
	m_byWaterfall				= WATERFALL_MODE_DISABLE;
}

CProperty_1::~CProperty_1(void)
{
}

void CProperty_1::SetLibrary(HINSTANCE hLibrary)
{
	m_hLibrary = hLibrary;
}

HINSTANCE CProperty_1::GetLibrary(void)
{
	return m_hLibrary;
}

void CProperty_1::SetHandle(int nHandle)
{
	m_nHandle = nHandle;
}

int CProperty_1::GetHandle(void)
{
	return m_nHandle;
}

MF_BASE01* CProperty_1::GetMfBase01(void)
{
	return &m_Mf_Base01;
}

MF_MICR01* CProperty_1::GetMfMicr(void)
{
	return &m_Mf_Micr01;
}

MF_SCAN* CProperty_1::GetMfScanFront(void)
{
	return &m_Mf_ScanFront;
}

MF_SCAN* CProperty_1::GetMfScanBack(void)
{
	return &m_Mf_ScanBack;
}

MF_PROCESS01* CProperty_1::GetMfProcess(void)
{
	return &m_Mf_Process;
}

void CProperty_1::SetScanMedia(BYTE byScanMedia)
{
	m_byScanMedia = byScanMedia;
}

BYTE CProperty_1::GetScanMedia(void) const
{
	return m_byScanMedia;
}

void CProperty_1::SetLightSourceToScan(BYTE byLightSourceToScan)
{
	m_byLightSourceToScan = byLightSourceToScan;
}

BYTE CProperty_1::GetLightSourceToScan(void)
{
	return m_byLightSourceToScan;
}

void CProperty_1::SetRGBColorDepth(BYTE byColorDepth)
{
	m_byRGBColorDepth = byColorDepth;
}

BYTE CProperty_1::GetRGBColorDepth(void)
{
	return m_byRGBColorDepth;
}

void CProperty_1::SetIRColorDepth(BYTE byColorDepth)
{
	m_byIRColorDepth = byColorDepth;
}

BYTE CProperty_1::GetIRColorDepth(void)
{
	return m_byIRColorDepth;
}

void CProperty_1::SetResolution(short sResolution)
{
	m_sResolution = sResolution;
}

short CProperty_1::GetResolution(void)
{
	return m_sResolution;
}

void CProperty_1::SetFont(BYTE byFont)
{
	m_byFont = byFont;
}

BYTE CProperty_1::GetFont(void)
{
	return m_byFont;
}

void CProperty_1::SetParsing(bool bParsing)
{
	m_bParsing = bParsing;
}

bool CProperty_1::GetParsing(void)
{
	return m_bParsing;
}

void CProperty_1::SetClearSpace(bool bClearSpace)
{
	m_bClearSpace = bClearSpace;
}

bool CProperty_1::GetClearSpace(void)
{
	return m_bClearSpace;
}

void CProperty_1::SetTransactionNumber(DWORD dwTransactionNumber)
{
	m_dwTransactionNumber = dwTransactionNumber;
}

DWORD CProperty_1::GetTransactionNumber(void)
{
	return m_dwTransactionNumber;
}

void CProperty_1::SetBuzzerSuccess(bool bBuzzerSuccess)
{
	m_bBuzzerSuccess = bBuzzerSuccess;
}

bool CProperty_1::GetBuzzerSuccess(void)
{
	return m_bBuzzerSuccess;
}

void CProperty_1::SetBuzzerDoubleFeed(bool bBuzzerDoubleFeed)
{
	m_bBuzzerDoubleFeed = bBuzzerDoubleFeed;
}

bool CProperty_1::GetBuzzerDoubleFeed(void)
{
	return m_bBuzzerDoubleFeed;
}

void CProperty_1::SetBuzzerError(bool bBuzzerError)
{
	m_bBuzzerError = bBuzzerError;
}

bool CProperty_1::GetBuzzerError(void)
{
	return m_bBuzzerError;
}

// Step 1
void CProperty_1::SetActivation(BYTE byActivation)
{
	m_byActivation = byActivation;
}

BYTE CProperty_1::GetActivation(void)
{
	return m_byActivation;
}

// Step 7
void CProperty_1::SetWaterfall(BYTE byWaterfall)
{
	m_byWaterfall = byWaterfall;
}

BYTE CProperty_1::GetWaterfall(void)
{
	return m_byWaterfall;
}

void CProperty_1::SetConfirmationEject(BYTE byConfirmationEject)
{
	m_byConfirmationEject = byConfirmationEject;
}

BYTE CProperty_1::GetConfirmationEject(void)
{
	return m_byConfirmationEject;
}

void CProperty_1::SetConfirmationCancel(BYTE byConfirmationCancel)
{
	m_byConfirmationCancel = byConfirmationCancel;
}

BYTE CProperty_1::GetConfirmationCancel(void)
{
	return m_byConfirmationCancel;
}

void CProperty_1::SetPaperMisInsertionDetect(BYTE byPaperMisInsertionDetect)
{
	m_byPaperMisInsertionDetect = byPaperMisInsertionDetect;
}

BYTE CProperty_1::GetPaperMisInsertionDetect(void)
{
	return m_byPaperMisInsertionDetect;
}

void CProperty_1::SetPaperMisInsertionEject(BYTE byPaperMisInsertionEject)
{
	m_byPaperMisInsertionEject = byPaperMisInsertionEject;
}

BYTE CProperty_1::GetPaperMisInsertionEject(void)
{
	return m_byPaperMisInsertionEject;
}

void CProperty_1::SetPaperMisInsertionCancel(BYTE byPaperMisInsertionCancel)
{
	m_byPaperMisInsertionCancel = byPaperMisInsertionCancel;
}

BYTE CProperty_1::GetPaperMisInsertionCancel(void)
{
	return m_byPaperMisInsertionCancel;
}

void CProperty_1::SetNoiseDetect(BYTE byNoiseDetect)
{
	m_byNoiseDetect = byNoiseDetect;
}

BYTE CProperty_1::GetNoiseDetect(void)
{
	return m_byNoiseDetect;
}

void CProperty_1::SetNoiseEject(BYTE byNoiseEject)
{
	m_byNoiseEject = byNoiseEject;
}

BYTE CProperty_1::GetNoiseEject(void)
{
	return m_byNoiseEject;
}

void CProperty_1::SetNoiseCancel(BYTE byNoiseCancel)
{
	m_byNoiseCancel = byNoiseCancel;
}

BYTE CProperty_1::GetNoiseCancel(void)
{
	return m_byNoiseCancel;
}

void CProperty_1::SetDoubleFeedDetect(BYTE byDoubleFeedDetect)
{
	m_byDoubleFeedDetect = byDoubleFeedDetect;
}

BYTE CProperty_1::GetDoubleFeedDetect(void)
{
	return m_byDoubleFeedDetect;
}

void CProperty_1::SetDoubleFeedEject(BYTE byDoubleFeedEject)
{
	m_byDoubleFeedEject = byDoubleFeedEject;
}

BYTE CProperty_1::GetDoubleFeedEject(void)
{
	return m_byDoubleFeedEject;
}

void CProperty_1::SetDoubleFeedCancel(BYTE byDoubleFeedCancel)
{
	m_byDoubleFeedCancel = byDoubleFeedCancel;
}

BYTE CProperty_1::GetDoubleFeedCancel(void)
{
	return m_byDoubleFeedCancel;
}

void CProperty_1::SetBaddataDetect(BYTE byBaddataDetect)
{
	m_byBaddataDetect = byBaddataDetect;
}

BYTE CProperty_1::GetBaddataDetect(void)
{
	return m_byBaddataDetect;
}

void CProperty_1::SetBaddataEject(BYTE byBaddataEject)
{
	m_byBaddataEject = byBaddataEject;
}

BYTE CProperty_1::GetBaddataEject(void)
{
	return m_byBaddataEject;
}

void CProperty_1::SetBaddataCancel(BYTE byBaddataCancel)
{
	m_byBaddataCancel = byBaddataCancel;
}

BYTE CProperty_1::GetBaddataCancel(void)
{
	return m_byBaddataCancel;
}

void CProperty_1::SetNodataDetect(BYTE byNodataDetect)
{
	m_byNodataDetect = byNodataDetect;
}

BYTE CProperty_1::GetNodataDetect(void)
{
	return m_byNodataDetect;
}

void CProperty_1::SetNodataEject(BYTE byNodataEject)
{
	m_byNodataEject = byNodataEject;
}

BYTE CProperty_1::GetNodataEject(void)
{
	return m_byNodataEject;
}

void CProperty_1::SetNodataCancel(BYTE byNodataCancel)
{
	m_byNodataCancel = byNodataCancel;
}

BYTE CProperty_1::GetNodataCancel(void)
{
	return m_byNodataCancel;
}

void CProperty_1::SetEndorsePrintMode(BYTE byEndorsePrintMode)
{
	m_byEndorsePrintMode = byEndorsePrintMode;
}

BYTE CProperty_1::GetEndorsePrintMode(void)
{
	return m_byEndorsePrintMode;
}

void CProperty_1::SetPrnDataUnreceiveCancel(BYTE byPrnDataUnreceiveCancel)
{
	m_byPrnDataUnreceiveCancel = byPrnDataUnreceiveCancel;
}

BYTE CProperty_1::GetPrnDataUnreceiveCancel(void)
{
	return m_byPrnDataUnreceiveCancel;
}

////////////////
//// Step 2 ////
////////////////

void CProperty_1::SetNumberOfDocuments(BYTE nNumberOfDocuments)
{
	m_nNumberOfDocuments = nNumberOfDocuments;
}

BYTE CProperty_1::GetNumberOfDocuments(void) const
{
	return m_nNumberOfDocuments;
}

////////////////
//// Step 7 ////
////////////////

MF_IQA*	CProperty_1::GetMfIqa(void)
{
	return &m_Mf_Iqa;
}

MF_IQA_RESULT* CProperty_1::GetMfIqaResult(void)
{
	return &m_Mf_IqaResult;
}

void CProperty_1::SetIqaDetect(BYTE byIqaDetect)
{
	m_byIqaDetect = byIqaDetect;
}

BYTE CProperty_1::GetIqaDetect(void)
{
	return m_byIqaDetect;
}

void CProperty_1::SetIqaColorDepth(BYTE byColorDepth)
{
	m_byColorDepth = byColorDepth;
}

BYTE CProperty_1::GetIqaColorDepth(void)
{
	return m_byColorDepth;
}

void CProperty_1::SetIqaCancel(BYTE byCancel)
{
	m_byCancel = byCancel;
}

BYTE CProperty_1::GetIqaCancel(void)
{
	return m_byCancel;
}

void CProperty_1::SetIqaEjectPocket(BYTE byEjectPocket)
{
	m_byEjectPocket = byEjectPocket;
}

BYTE CProperty_1::GetIqaEjectPocket(void)
{
	return m_byEjectPocket;
}

void CProperty_1::SetUnderSize(BYTE byUnderSize)
{
	m_byUnderSize = byUnderSize;
}

BYTE CProperty_1::GetUnderSize(void)
{
	return m_byUnderSize;
}

void CProperty_1::SetOverSize(BYTE byOverSize)
{
	m_byOverSize = byOverSize;
}

BYTE CProperty_1::GetOverSize(void)
{
	return m_byOverSize;
}

void CProperty_1::SetMinCompressed(BYTE byMinCompressed)
{
	m_byMinCompressed = byMinCompressed;
}

BYTE CProperty_1::GetMinCompressed(void)
{
	return m_byMinCompressed;
}

void CProperty_1::SetMaxCompressed(BYTE byMaxCompressed)
{
	m_byMaxCompressed = byMaxCompressed;
}

BYTE CProperty_1::GetMaxCompressed(void)
{
	return m_byMaxCompressed;
}

void CProperty_1::SetFrontRearImageMismatch(BYTE byFrontRearImageMismatch)
{
	m_byFrontRearImageMismatch = byFrontRearImageMismatch;
}

BYTE CProperty_1::GetFrontRearImageMismatch(void)
{
	return m_byFrontRearImageMismatch;
}

void CProperty_1::SetImageTooLight(BYTE byImageTooLight)
{
	m_byImageTooLight = byImageTooLight;
}

BYTE CProperty_1::GetImageTooLight(void)
{
	return m_byImageTooLight;
}

void CProperty_1::SetImageTooDark(BYTE byImageTooDark)
{
	m_byImageTooDark = byImageTooDark;
}

BYTE CProperty_1::GetImageTooDark(void)
{
	return m_byImageTooDark;
}

void CProperty_1::SetHorizontalStreaksPresent(BYTE byStreaks)
{
	m_byStreaks = byStreaks;
}

BYTE CProperty_1::GetHorizontalStreaksPresent(void)
{
	return m_byStreaks;
}

void CProperty_1::SetSpotNoise(BYTE bySpotNosise)
{
	m_bySpotNosise = bySpotNosise;
}

BYTE CProperty_1::GetSpotNoise(void)
{
	return m_bySpotNosise;
}

void CProperty_1::SetOutOfFocus(BYTE byOutOfFocus)
{
	m_byOutOfFocus = byOutOfFocus;
}

BYTE CProperty_1::GetOutOfFocus(void)
{
	return m_byOutOfFocus;
}

void CProperty_1::SetFoldedTornCorner(BYTE byFoldedTornCorner)
{
	m_byFoldedTornCorner = byFoldedTornCorner;
}

BYTE CProperty_1::GetFoldedTornCorner(void)
{
	return m_byFoldedTornCorner;
}

void CProperty_1::SetFoldedTornEdge(BYTE byFoldedTornEdge)
{
	m_byFoldedTornEdge = byFoldedTornEdge;
}

BYTE CProperty_1::GetFoldedTornEdge(void)
{
	return m_byFoldedTornEdge;
}

void CProperty_1::SetFramingError(BYTE byFramingError)
{
	m_byFramingError = byFramingError;
}

BYTE CProperty_1::GetFramingError(void)
{
	return m_byFramingError;
}

void CProperty_1::SetExcessiveSkew(BYTE byExcessiveSkew)
{
	m_byExcessiveSkew = byExcessiveSkew;
}

BYTE CProperty_1::GetExcessiveSkew(void)
{
	return m_byExcessiveSkew;
}

void CProperty_1::SetCarbonStripDetection(BYTE byCarbon)
{
	m_byCarbon = byCarbon;
}

BYTE CProperty_1::GetCarbonStripDetection(void)
{
	return m_byCarbon;
}

void CProperty_1::SetPiggyback(BYTE byPiggyback)
{
	m_byPiggyback = byPiggyback;
}

BYTE CProperty_1::GetPiggyback(void)
{
	return m_byPiggyback;
}
