// TMS_SampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TMS_Sample.h"
#include "TMS_SampleDlg.h"
#include "ConfigureDlg.h"
#include <shlwapi.h>
// Step 7
#include "ConfirmationDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

/////////////////////////////////////////////////////////////////
// Functions for Callback from DriverControl
/////////////////////////////////////////////////////////////////

////////////////
//// Step 1 ////
////////////////

int CALLBACK CallbackFuncProcessError( short sErrorStatus )
{
	CTMS_SampleDlg* pDlg = dynamic_cast<CTMS_SampleDlg*>( AfxGetApp()->GetMainWnd() );
	if( pDlg != NULL )
	{
		pDlg->CallbackProcProcessError( sErrorStatus );
	}

	return 0;
}

////////////////
//// Step 2 ////
////////////////

int CALLBACK CallbackFuncImage(unsigned long ulTransactionNumber)
{
	CTMS_SampleDlg* pDlg = dynamic_cast<CTMS_SampleDlg*>( AfxGetApp()->GetMainWnd() );
	if( pDlg != NULL )
	{
		pDlg->CallbackProcImage();
	}

	return 0;
}

////////////////
//// Step 3 ////
////////////////

int CALLBACK CallbackFuncMicr(unsigned long ulTransactionNumber)
{
	CTMS_SampleDlg* pDlg = dynamic_cast<CTMS_SampleDlg*>( AfxGetApp()->GetMainWnd() );
	if( pDlg != NULL )
	{
		pDlg->CallbackProcMicr();
	}

	return 0;
}

////////////////
//// Step 7 ////
////////////////

int CALLBACK CallbackFuncIqa(void)
{
	CTMS_SampleDlg* pDlg = dynamic_cast<CTMS_SampleDlg*>( AfxGetApp()->GetMainWnd() );
	if( pDlg != NULL )
	{
		pDlg->CallbackProcIqa();
	}

	return 0;
}

int CALLBACK CallbackFuncConfirmation(void)
{
	CTMS_SampleDlg* pDlg = dynamic_cast<CTMS_SampleDlg*>( AfxGetApp()->GetMainWnd() );
	if( pDlg != NULL )
	{
		pDlg->CallbackProcConfirmation();
	}

	return 0;
}

// CTMS_SampleDlg dialog

CTMS_SampleDlg::CTMS_SampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTMS_SampleDlg::IDD, pParent)
// Step 2
, m_Image2Front(m_stImage2Front)
, m_Image2Back(m_stImage2Back)
, m_Image4RGBFront(m_stImage4RGBFront)
, m_Image4RGBBack(m_stImage4RGBBack)
, m_Image4IrFront(m_stImage4IrFront)
, m_Image4IrBack(m_stImage4IrBack)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bScanCancelError = false;

	////////////////
	//// Step 1 ////
	////////////////

	m_pcDriverControl = new CApp;
}

CTMS_SampleDlg::~CTMS_SampleDlg(void)
{
	if( m_pcDriverControl != NULL )
	{
		delete m_pcDriverControl;
		m_pcDriverControl = NULL;
	}
}

void CTMS_SampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	// Step 1
	DDX_Control(pDX, IDC_BUTTON_SCAN, m_btnScan);
	DDX_Control(pDX, IDC_BUTTON_SCANCANCEL, m_btnScanCancel);
	DDX_Control(pDX, IDC_BUTTON_EXIT, m_btnExit);
	// Step 2
	DDX_Control(pDX, IDC_STATIC_IMAGE2_FRONT, m_stImage2Front);
	DDX_Control(pDX, IDC_STATIC_IMAGE2_BACK, m_stImage2Back);
	DDX_Control(pDX, IDC_STATIC_IMAGE4_RGBFRONT, m_stImage4RGBFront);
	DDX_Control(pDX, IDC_STATIC_IMAGE4_RGBBACK, m_stImage4RGBBack);
	DDX_Control(pDX, IDC_STATIC_IMAGE4_IRFRONT, m_stImage4IrFront);
	DDX_Control(pDX, IDC_STATIC_IMAGE4_IRBACK, m_stImage4IrBack);
	DDX_Control(pDX, IDC_BUTTON_CONFIG, m_btnConfig);
	// Step 3
	DDX_Control(pDX, IDC_BUTTON_MICRCLEANING, m_btnMicrCleaning);
	DDX_Control(pDX, IDC_STATIC_MICRTEXT, m_stMicrText);
	DDX_Control(pDX, IDC_EDIT_MICRTEXT, m_edtMicrText);
	// Step 7
	DDX_Control(pDX, IDC_BUTTON_IQARESULT, m_btnIqaResult);
}

BEGIN_MESSAGE_MAP(CTMS_SampleDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	// Step 1
	ON_BN_CLICKED(IDC_BUTTON_SCAN, &CTMS_SampleDlg::OnBnClickedButtonScan)
	ON_BN_CLICKED(IDC_BUTTON_SCANCANCEL, &CTMS_SampleDlg::OnBnClickedButtonScanCancel)
	ON_BN_CLICKED(IDC_BUTTON_EXIT, &CTMS_SampleDlg::OnBnClickedButtonExit)
	// Step 2
	ON_BN_CLICKED(IDC_BUTTON_CONFIG, &CTMS_SampleDlg::OnBnClickedButtonConfig)
	// Step 3
	ON_BN_CLICKED(IDC_BUTTON_MICRCLEANING, &CTMS_SampleDlg::OnBnClickedButtonMicrCleaning)
	// Step 7
	ON_BN_CLICKED(IDC_BUTTON_IQARESULT, &CTMS_SampleDlg::OnBnClickedButtonIqaResult)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////
// CTMS_SampleDlg message handlers
/////////////////////////////////////////////////////////////////

BOOL CTMS_SampleDlg::OnInitDialog(void)
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	// Initialize driver
	if( InitializeDriver() != true )
	{
		EndDialog(0);
		return FALSE;
	}

	// Initialize data
	InitializeConfigData();

	// Initialize controls
	LoadResourceString();

	// Step 7
	// Create IQAResult dialog
	m_IqaResultDlg.Create(IDD_DIALOG_IQARESULT, NULL);

	UpdateControls();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

BOOL CTMS_SampleDlg::DestroyWindow(void)
{
	int nResult = TerminateDriver();
	if( nResult != 0 )
	{
		ShowErrorMessage( nResult );
	}

	return CDialog::DestroyWindow();
}

void CTMS_SampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	CDialog::OnSysCommand(nID, lParam);
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTMS_SampleDlg::OnPaint(void)
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();

		m_Image2Front.Draw();
		m_Image2Back.Draw();
		m_Image4RGBFront.Draw();
		m_Image4RGBBack.Draw();
		m_Image4IrFront.Draw();
		m_Image4IrBack.Draw();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTMS_SampleDlg::OnQueryDragIcon(void)
{
	return static_cast<HCURSOR>(m_hIcon);
}

/////////////////////////////////////////////////////////////////
// Procedure of DriveControl Callback
/////////////////////////////////////////////////////////////////

////////////////
//// Step 1 ////
////////////////

void CTMS_SampleDlg::CallbackProcProcessError( short sErrorStatus )
{
	// Member check
	ASSERT(m_pcDriverControl != NULL);
	if( m_pcDriverControl == NULL )
	{
		return;
	}

	DWORD  dwStatus = 0;
	// Display message box correspondent to error
	switch( sErrorStatus )
	{
		case ERR_COVER_OPEN:
			do
			{
				MessageBox( MSG_01_001, CAPTION_01_001, MB_OK | MB_ICONERROR );
				m_pcDriverControl->GetDeviceStatus(&dwStatus);
			}while( (dwStatus & ASB_COVER_OPEN) == ASB_COVER_OPEN );
			m_pcDriverControl->CancelError();
			break;

		case ERR_PAPER_JAM:
			if(m_sConfigData.nRadio_ScanningMedia == VAL_CONFIGDLG_RADIO_SM_CHECKPAPER)
			{
				do{
					MessageBox( MSG_02_000, CAPTION_02_000, MB_OK | MB_ICONERROR );
					m_pcDriverControl->GetDeviceStatus(&dwStatus);
				}while( ((dwStatus & ASB_PAPER_INTERMEDIATE) != ASB_PAPER_INTERMEDIATE)
							|| ((dwStatus & ASB_SLIP_PAPER_SIZE) != ASB_SLIP_PAPER_SIZE)
							|| ((dwStatus & ASB_EJECT_SENSOR_NO_PAPER) != ASB_EJECT_SENSOR_NO_PAPER));
				m_pcDriverControl->CancelError();
			}
			else
			{
				MessageBox( MSG_02_000, CAPTION_02_000, MB_OK | MB_ICONERROR );
				m_pcDriverControl->CancelError();
			}
			break;

		case ERR_ACCESS:
			ShowErrorMessage( (int)sErrorStatus );
			m_pcDriverControl->CancelError();
			break;

		case ERR_MICR_NODATA:
		case ERR_MICR_BADDATA:
		case ERR_PRINT_DATA_UNRECEIVE:
			break;

		// Step 7
		case ERR_SCN_IQA:
			MessageBox( MSG_03_046, CAPTION_03_046, MB_OK | MB_ICONERROR );
			break;

		default:
			ShowErrorMessage( (int)sErrorStatus );
			m_pcDriverControl->CancelError();
			break;
	}
}

////////////////
//// Step 2 ////
////////////////

void CTMS_SampleDlg::CallbackProcImage(void)
{
	// Member check
	ASSERT(m_pcDriverControl != NULL);
	if( m_pcDriverControl == NULL )
	{
		return;
	}

	// Save image if necessary
	bool bSave = ( m_sConfigData.nCheck_Scan_SaveFile == VAL_CONFIGDLG_CHECK_SC_SAVEFILE_ON );

	CScanParam stScanParam;
	m_pcDriverControl->GetScanParam( &stScanParam );

	// Configure display data for each scanning side and light source
	if( m_sConfigData.nRadio_LightSourceToScan == VAL_CONFIGDLG_RADIO_IC_RGB )
	{
		// Configure 2 plane data for RGB image
		UpdateImageData( MF_SCAN_FACE_FRONT, MF_SCAN_IMAGE_VISIBLE, stScanParam.GetResolution(), stScanParam.GetRGBColorDepth(), m_Image2Front, bSave );
		UpdateImageData( MF_SCAN_FACE_BACK,  MF_SCAN_IMAGE_VISIBLE, stScanParam.GetResolution(), stScanParam.GetRGBColorDepth(), m_Image2Back,  bSave );
	}
	else if( m_sConfigData.nRadio_LightSourceToScan == VAL_CONFIGDLG_RADIO_IC_IR )
	{
		// Configure 2 plane data for IR image
		UpdateImageData( MF_SCAN_FACE_FRONT, MF_SCAN_IMAGE_INFRARED, stScanParam.GetResolution(), stScanParam.GetIRColorDepth(), m_Image2Front, bSave );
		UpdateImageData( MF_SCAN_FACE_BACK,  MF_SCAN_IMAGE_INFRARED, stScanParam.GetResolution(), stScanParam.GetIRColorDepth(), m_Image2Back,  bSave );
	}
	else if( m_sConfigData.nRadio_LightSourceToScan == VAL_CONFIGDLG_RADIO_IC_RGBIR )
	{
		// Configure 4 plane image
		UpdateImageData( MF_SCAN_FACE_FRONT, MF_SCAN_IMAGE_VISIBLE,  stScanParam.GetResolution(), stScanParam.GetRGBColorDepth(), m_Image4RGBFront, bSave );
		UpdateImageData( MF_SCAN_FACE_BACK,  MF_SCAN_IMAGE_VISIBLE,  stScanParam.GetResolution(), stScanParam.GetRGBColorDepth(), m_Image4RGBBack,  bSave );
		UpdateImageData( MF_SCAN_FACE_FRONT, MF_SCAN_IMAGE_INFRARED, stScanParam.GetResolution(), stScanParam.GetIRColorDepth(),  m_Image4IrFront,  bSave );
		UpdateImageData( MF_SCAN_FACE_BACK,  MF_SCAN_IMAGE_INFRARED, stScanParam.GetResolution(), stScanParam.GetIRColorDepth(),  m_Image4IrBack,   bSave );
	}
	else
	{
		ASSERT(FALSE);
	}
}

////////////////
//// Step 3 ////
////////////////

void CTMS_SampleDlg::CallbackProcMicr(void)
{
	// Member check
	ASSERT(m_pcDriverControl != NULL);
	if( m_pcDriverControl == NULL )
	{
		return;
	}

	// Obtain MICR data
	CMicrResult cMicrResult;
	int nResult = m_pcDriverControl->GetMicr( &cMicrResult );
	if( nResult == SUCCESS )
	{
		m_edtMicrText.SetWindowText( cMicrResult.GetMicrStr() );
	}
	else
	{
		m_edtMicrText.SetWindowText( GetErrorString( nResult ) );
	}

	// Save MICR data if necessary
	if( m_sConfigData.nCheck_MICR_SaveFile == VAL_CONFIGDLG_CHECK_MI_SAVEFILE_ON )
	{
		SaveMicrData();
	}
}

////////////////
//// Step 7 ////
////////////////

void CTMS_SampleDlg::CallbackProcIqa(void)
{
	// Member check
	ASSERT(m_pcDriverControl != NULL);
	if( m_pcDriverControl == NULL )
	{
		return;
	}

	// Obtain IQA test result
	if( m_sConfigData.nCheck_IQA_Detect == VAL_CONFIGDLG_CHECK_IQ_DETECT_ON)
	{
		CIqaResult cIqaResult;
		int nResult = m_pcDriverControl->GetIqaResult( &cIqaResult );
		if( nResult == SUCCESS )
		{
			m_IqaResultDlg.DisplayIqaResult( &cIqaResult );
		}
		else
		{
			ShowErrorMessage(nResult);
		}
	}
}

void CTMS_SampleDlg::CallbackProcConfirmation(void)
{
	// Member check
	ASSERT(m_pcDriverControl != NULL);
	if( m_pcDriverControl == NULL )
	{
		return;
	}

	if( m_sConfigData.nCheck_ConfirmationByUser == VAL_CONFIGDLG_CHECK_AM_CONFIRMATION_BY_USER_ON &&
		m_sConfigData.nCombo_WaterfallMode      == VAL_CONFIGDLG_COMBO_WM_DISABLE )
	{
		CConfirmationDlg cConfirmationDlg;

		if( cConfirmationDlg.DoModal() == IDOK )
		{
			COptionParam cOptionParam;
			cOptionParam.SetConfirmationEject( MF_EJECT_MAIN_POCKET );
			cOptionParam.SetConfirmationCancel( MF_PROCESS_CONTINUE_OVERLAP );

			CONFIRMATIONDATA sConfirmationData;
			cConfirmationDlg.GetConfirmationData( &sConfirmationData );
			ConvertConfirmationDataToOptionParam( &sConfirmationData, &cOptionParam );
			m_pcDriverControl->SetConfirmationParam( &cOptionParam );

			int nResult = m_pcDriverControl->ConfirmationFunction();
			if( nResult != SUCCESS )
			{
				ShowErrorMessage(nResult);
			}
		}
	}

	// In the Confirmation mode, if BiSetBehaviorToScnResult is not invoked in the
	// MF_DATARECEIVE_DONE callback notification, paper is ejected into the pocket in
	// accordance with this setting value.
}

/////////////////////////////////////////////////////////////////
// Button Event
/////////////////////////////////////////////////////////////////

////////////////
//// Step 1 ////
////////////////

void CTMS_SampleDlg::OnBnClickedButtonScan(void)
{
	// Member check
	ASSERT(m_pcDriverControl != NULL);
	if( m_pcDriverControl == NULL )
	{
		return;
	}

	////////////////////////////////////////
	// Reset controls before to start scaning

	// Step 2
	ClearImage();

	// Step 3
	m_edtMicrText.SetWindowText(_T(""));

	////////////////////////////////////////
	// Start scanning image

	// Step 2
	if( m_sConfigData.nRadio_ScanningMedia == VAL_CONFIGDLG_RADIO_SM_CHECKPAPER )
	{
		// Step 1
		int nRet = m_pcDriverControl->ScanCheck();
		if( nRet != SUCCESS )
		{
			ShowErrorMessage( nRet );
			m_pcDriverControl->CancelError();
			return;
		}
	}
	else if( m_sConfigData.nRadio_ScanningMedia == VAL_CONFIGDLG_RADIO_SM_CARD )
	{
		int nRet = m_pcDriverControl->ScanCard();
		if( nRet != SUCCESS )
		{
			ShowErrorMessage( nRet );
			m_pcDriverControl->CancelError();
			return;
		}
	}
}

void CTMS_SampleDlg::OnBnClickedButtonScanCancel(void)
{
	// Member check
	ASSERT(m_pcDriverControl != NULL);
	if( m_pcDriverControl == NULL )
	{
		return;
	}

	int nRet = m_pcDriverControl->CancelScan();
	if( nRet != SUCCESS )
	{
		m_bScanCancelError = true;
		ShowErrorMessage( nRet );
		m_pcDriverControl->CancelError();
	}
}

void CTMS_SampleDlg::OnBnClickedButtonExit(void)
{
	OnCancel();
}

////////////////
//// Step 2 ////
////////////////

void CTMS_SampleDlg::OnBnClickedButtonConfig(void)
{
	CConfigureDlg cConfigureDlg;

	cConfigureDlg.SetConfigData( m_sConfigData );

	if( cConfigureDlg.DoModal() == IDOK )
	{
		cConfigureDlg.GetConfigData( &m_sConfigData );

		////////////////
		//// Step 2 ////
		////////////////

		CScanParam stScanParam;
		ConvertConfigDataToScanParam( &m_sConfigData, &stScanParam );
		if( m_pcDriverControl != NULL )
		{
			m_pcDriverControl->SetScanParam( &stScanParam );
		}

		////////////////
		//// Step 3 ////
		////////////////

		CMicrParam cMicrParam;
		ConvertConfigDataToMicrParam( &m_sConfigData, &cMicrParam );
		if( m_pcDriverControl != NULL )
		{
			m_pcDriverControl->SetMicrParam( &cMicrParam );
		}

		////////////////
		//// Step 7 ////
		////////////////

		CIqaParam cIqaParam;
		ConvertConfigDataToIqaParam( &m_sConfigData, &cIqaParam );
		if( m_pcDriverControl != NULL )
		{
			m_pcDriverControl->SetIqaParam( &cIqaParam );
		}

		COptionParam cOptionParam;
		ConvertConfigDataToOptionParam( &m_sConfigData, &cOptionParam );
		if( m_pcDriverControl != NULL )
		{
			m_pcDriverControl->SetOptionParam( &cOptionParam );
		}

		UpdateControls();
	}
}

////////////////
//// Step 3 ////
////////////////

void CTMS_SampleDlg::OnBnClickedButtonMicrCleaning(void)
{
	// Member check
	ASSERT(m_pcDriverControl != NULL);
	if( m_pcDriverControl == NULL )
	{
		return;
	}

	int nRet = m_pcDriverControl->CleaningMicr();
	if( nRet != SUCCESS )
	{
		ShowErrorMessage( nRet );
		m_pcDriverControl->CancelError();
	}
}

////////////////
//// Step 7 ////
////////////////

void CTMS_SampleDlg::OnBnClickedButtonIqaResult(void)
{
	// Member check
	ASSERT(m_pcDriverControl != NULL);
	if( m_pcDriverControl == NULL )
	{
		return;
	}

	if ( ! m_IqaResultDlg.IsWindowVisible() )
	{
		CRect rcMain;
		GetWindowRect(&rcMain);

		CRect rcSub;
		m_IqaResultDlg.GetWindowRect(&rcSub);

		m_IqaResultDlg.SetWindowPos(NULL, rcMain.right, (rcMain.top + rcMain.bottom)/2 - rcSub.Height()/2, 0, 0, SWP_NOSIZE | SWP_SHOWWINDOW);
	}
	else
	{
		m_IqaResultDlg.ShowWindow(SW_HIDE);
	}
}

/////////////////////////////////////////////////////////////////
// Member functions
/////////////////////////////////////////////////////////////////

bool CTMS_SampleDlg::InitializeDriver(void)
{
	// Member check
	ASSERT(m_pcDriverControl != NULL);
	if( m_pcDriverControl == NULL )
	{
		return false;
	}

	int nResult = 0;
	int nRet	= 0;
	CString strResult = NULL;

	// Open device and register callback functions
	nResult = m_pcDriverControl->InitDevice();
	while( nResult != SUCCESS )
	{
		if( nResult == ERR_LOAD_MODULE )
		{
			nRet = MessageBox( MSG_06_000, CAPTION_06_000, MB_OKCANCEL | MB_ICONERROR );
		}
		else
		{
			strResult = GetErrorString( nResult );
			nRet = MessageBox( MSG_00_000, strResult, MB_OKCANCEL | MB_ICONERROR );
		}

		if( nRet == IDOK )
		{
			nResult = m_pcDriverControl->InitDevice();
		}
		else
		{
			return false;
		}
	}

	// Specify callback function from DriverControl
	// Step 1
	m_pcDriverControl->SetProcessErrorCallback(&CallbackFuncProcessError);
	// Step 2
	m_pcDriverControl->SetImageCallback(&CallbackFuncImage);
	// Step 3
	m_pcDriverControl->SetMicrCallback(&CallbackFuncMicr);
	// Step 7
	m_pcDriverControl->SetIqaCallback(&CallbackFuncIqa);
	m_pcDriverControl->SetConfirmationCallback(&CallbackFuncConfirmation);

	// Obtain connected device option
	// Step 2
	m_sConfigData.bIsScanningCardIR1PassSupported = m_pcDriverControl->IsScanningCardIR1PassSupported();

	return true;
}

int CTMS_SampleDlg::TerminateDriver(void)
{
	// Member check
	ASSERT(m_pcDriverControl != NULL);
	if( m_pcDriverControl == NULL )
	{
		return ERR_NO_MEMORY;
	}

	int nRet = m_pcDriverControl->ExitDevice();
	if( nRet != SUCCESS )
	{
		return nRet;
	}

	return 0;
}

void CTMS_SampleDlg::ShowErrorMessage( int nResult )
{
	switch( nResult )
	{
		case ERR_TYPE:
			MessageBox( MSG_03_000, CAPTION_03_000, MB_OK | MB_ICONWARNING );
			break;
		case ERR_OPENED:
			MessageBox( MSG_03_001, CAPTION_03_001, MB_OK | MB_ICONWARNING );
			break;
		case ERR_NO_PRINTER:
			MessageBox( MSG_03_002, CAPTION_03_002, MB_OK | MB_ICONWARNING );
			break;
		case ERR_NO_TARGET:
			MessageBox( MSG_03_003, CAPTION_03_003, MB_OK | MB_ICONWARNING );
			break;
		case ERR_NO_MEMORY:
			MessageBox( MSG_03_004, CAPTION_03_004, MB_OK | MB_ICONWARNING );
			break;
		case ERR_HANDLE:
			MessageBox( MSG_03_005, CAPTION_03_005, MB_OK | MB_ICONWARNING );
			break;
		case ERR_TIMEOUT:
			MessageBox( MSG_03_006, CAPTION_03_006, MB_OK | MB_ICONWARNING );
			break;
		case ERR_ACCESS:
			MessageBox( MSG_03_007, CAPTION_03_007, MB_OK | MB_ICONWARNING );
			break;
		case ERR_PARAM:
			MessageBox( MSG_03_008, CAPTION_03_008, MB_OK | MB_ICONWARNING );
			break;
		case ERR_NOT_SUPPORT:
			MessageBox( MSG_03_009, CAPTION_03_009, MB_OK | MB_ICONWARNING );
			break;
		case ERR_OFFLINE:
			MessageBox( MSG_03_010, CAPTION_03_010, MB_OK | MB_ICONWARNING );
			break;
		case ERR_NOT_EPSON:
			MessageBox( MSG_03_011, CAPTION_03_011, MB_OK | MB_ICONWARNING );
			break;
		case ERR_WITHOUT_CB:
			if( m_bScanCancelError == true )
			{
				MessageBox( MSG_03_012_01, CAPTION_03_012, MB_OK | MB_ICONWARNING );
				m_bScanCancelError = false;
			}
			else
			{
				MessageBox( MSG_03_012_00, CAPTION_03_012, MB_OK | MB_ICONWARNING );
			}
			break;
		case ERR_BUFFER_OVER_FLOW:
			MessageBox( MSG_03_013, CAPTION_03_013, MB_OK | MB_ICONWARNING );
			break;
		case ERR_REGISTRY:
			MessageBox( MSG_03_014, CAPTION_03_014, MB_OK | MB_ICONWARNING );
			break;
		case ERR_PAPERINSERT_TIMEOUT:
			MessageBox( MSG_03_015, CAPTION_03_015, MB_OK | MB_ICONWARNING );
			break;
		case ERR_EXEC_FUNCTION:
			MessageBox( MSG_03_016, CAPTION_03_016, MB_OK | MB_ICONWARNING );
			break;
		case ERR_EXEC_MICR:
			MessageBox( MSG_03_017, CAPTION_03_017, MB_OK | MB_ICONWARNING );
			break;
		case ERR_EXEC_SCAN:
			MessageBox( MSG_03_018, CAPTION_03_018, MB_OK | MB_ICONWARNING );
			break;
		case ERR_RESET:
			MessageBox( MSG_03_019, CAPTION_03_019, MB_OK | MB_ICONWARNING );
			break;
		case ERR_ABORT:
			MessageBox( MSG_03_020, CAPTION_03_020, MB_OK | MB_ICONWARNING );
			break;
		case ERR_MICR:
			MessageBox( MSG_03_021, CAPTION_03_021, MB_OK | MB_ICONWARNING );
			break;
		case ERR_SCAN:
			MessageBox( MSG_03_022, CAPTION_03_022, MB_OK | MB_ICONWARNING );
			break;
		case ERR_LINE_OVERFLOW:
			MessageBox( MSG_03_023, CAPTION_03_023, MB_OK | MB_ICONWARNING );
			break;
		case ERR_PAPER_PILED:
			MessageBox( MSG_03_024, CAPTION_03_024, MB_OK | MB_ICONWARNING );
			break;
		case ERR_PAPER_JAM:
			MessageBox( MSG_03_025, CAPTION_03_025, MB_OK | MB_ICONWARNING );
			break;
		case ERR_COVER_OPEN:
			MessageBox( MSG_03_026, CAPTION_03_026, MB_OK | MB_ICONWARNING );
			break;
		case ERR_MICR_NODATA:
			MessageBox( MSG_03_027, CAPTION_03_027, MB_OK | MB_ICONWARNING );
			break;
		case ERR_MICR_BADDATA:
			MessageBox( MSG_03_028, CAPTION_03_028, MB_OK | MB_ICONWARNING );
			break;
		case ERR_MICR_NOISE:
			MessageBox( MSG_03_029, CAPTION_03_029, MB_OK | MB_ICONWARNING );
			break;
		case ERR_SCN_COMPRESS:
			MessageBox( MSG_03_030, CAPTION_03_030, MB_OK | MB_ICONWARNING );
			break;
		case ERR_PAPER_EXIST:
			MessageBox( MSG_03_031, CAPTION_03_031, MB_OK | MB_ICONWARNING );
			break;
		case ERR_PAPER_INSERT:
			MessageBox( MSG_03_032, CAPTION_03_032, MB_OK | MB_ICONWARNING );
			break;
		case ERR_EXEC_SCAN_CHECK_CONTINUOUS:
			MessageBox( MSG_03_033, CAPTION_03_033, MB_OK | MB_ICONWARNING );
			break;
		case ERR_EXEC_SCAN_CHECK_ONEBYONE:
			MessageBox( MSG_03_034, CAPTION_03_034, MB_OK | MB_ICONWARNING );
			break;
		case ERR_EXEC_SCAN_IDCARD:
			MessageBox( MSG_03_035, CAPTION_03_035, MB_OK | MB_ICONWARNING );
			break;
		case ERR_EXEC_PRINT_ROLLPAPER:
			MessageBox( MSG_03_036, CAPTION_03_036, MB_OK | MB_ICONWARNING );
			break;
		case ERR_EXEC_PRINT_VALIDATION:
			MessageBox( MSG_03_037, CAPTION_03_037, MB_OK | MB_ICONWARNING );
			break;
		case ERR_THREAD:
			MessageBox( MSG_03_038, CAPTION_03_038, MB_OK | MB_ICONWARNING );
			break;
		case ERR_IMAGE_FILEOPEN:
			MessageBox( MSG_03_039, CAPTION_03_039, MB_OK | MB_ICONWARNING );
			break;
		case ERR_IMAGE_UNKNOWNFORMAT:
			MessageBox( MSG_03_040, CAPTION_03_040, MB_OK | MB_ICONWARNING );
			break;
		case ERR_SIZE:
			MessageBox( MSG_03_041, CAPTION_03_041, MB_OK | MB_ICONWARNING );
			break;
		case ERR_NOT_FOUND:
			MessageBox( MSG_03_042, CAPTION_03_042, MB_OK | MB_ICONWARNING );
			break;
		case ERR_NOT_EXEC:
			MessageBox( MSG_03_043, CAPTION_03_043, MB_OK | MB_ICONWARNING );
			break;
		case ERR_BARCODE_NODATA:
			MessageBox( MSG_03_044, CAPTION_03_044, MB_OK | MB_ICONWARNING );
			break;
		case ERR_MICR_PARSE:
			MessageBox( MSG_03_045, CAPTION_03_045, MB_OK | MB_ICONWARNING );
			break;
		case ERR_SCN_IQA:
			MessageBox( MSG_03_046, CAPTION_03_046, MB_OK | MB_ICONWARNING );
			break;
		case ERR_PRINT_DATA_LENGTH_EXCEED:
			MessageBox( MSG_03_047, CAPTION_03_047, MB_OK | MB_ICONWARNING );
			break;
		case ERR_PRINT_DATA_UNRECEIVE:
			MessageBox( MSG_03_048, CAPTION_03_048, MB_OK | MB_ICONWARNING );
			break;
		case ERR_INK_STATUS:
			MessageBox( MSG_03_050, CAPTION_03_051, MB_OK | MB_ICONWARNING );
			break;
		case ERR_IMAGE_FILEREAD:
			MessageBox( MSG_03_049, CAPTION_03_049, MB_OK | MB_ICONWARNING );
			break;
		default:
			static CString strResult;
			strResult.Format( _T("%d"), nResult );
			MessageBox( strResult, _T("ERR"), MB_OK | MB_ICONWARNING );
			break;
	}
}

LPCTSTR CTMS_SampleDlg::GetErrorString( int nResultCode )
{
	switch( nResultCode )
	{
			case SUCCESS:
				return CAPTION_00_000;
			case ERR_TYPE:
				return CAPTION_03_000;
			case ERR_OPENED:
				return CAPTION_03_001;
			case ERR_NO_PRINTER:
				return CAPTION_03_002;
			case ERR_NO_TARGET:
				return CAPTION_03_003;
			case ERR_NO_MEMORY:
				return CAPTION_03_004;
			case ERR_HANDLE:
				return CAPTION_03_005;
			case ERR_TIMEOUT:
				return CAPTION_03_006;
			case ERR_ACCESS:
				return CAPTION_03_007;
			case ERR_PARAM:
				return CAPTION_03_008;
			case ERR_NOT_SUPPORT:
				return CAPTION_03_009;
			case ERR_OFFLINE:
				return CAPTION_03_010;
			case ERR_NOT_EPSON:
				return CAPTION_03_011;
			case ERR_WITHOUT_CB:
				return CAPTION_03_012;
			case ERR_BUFFER_OVER_FLOW:
				return CAPTION_03_013;
			case ERR_REGISTRY:
				return CAPTION_03_014;
			case ERR_PAPERINSERT_TIMEOUT:
				return CAPTION_03_015;
			case ERR_EXEC_FUNCTION:
				return CAPTION_03_016;
			case ERR_EXEC_MICR:
				return CAPTION_03_017;
			case ERR_EXEC_SCAN:
				return CAPTION_03_018;
			case ERR_RESET:
				return CAPTION_03_019;
			case ERR_ABORT:
				return CAPTION_03_020;
			case ERR_MICR:
				return CAPTION_03_021;
			case ERR_SCAN:
				return CAPTION_03_022;
			case ERR_LINE_OVERFLOW:
				return CAPTION_03_023;
			case ERR_PAPER_PILED:
				return CAPTION_03_024;
			case ERR_PAPER_JAM:
				return CAPTION_03_025;
			case ERR_COVER_OPEN:
				return CAPTION_03_026;
			case ERR_MICR_NODATA:
				return CAPTION_03_027;
			case ERR_MICR_BADDATA:
				return CAPTION_03_028;
			case ERR_MICR_NOISE:
				return CAPTION_03_029;
			case ERR_SCN_COMPRESS:
				return CAPTION_03_030;
			case ERR_PAPER_EXIST:
				return CAPTION_03_031;
			case ERR_PAPER_INSERT:
				return CAPTION_03_032;
			case ERR_EXEC_SCAN_CHECK_CONTINUOUS:
				return CAPTION_03_033;
			case ERR_EXEC_SCAN_CHECK_ONEBYONE:
				return CAPTION_03_034;
			case ERR_EXEC_SCAN_IDCARD:
				return CAPTION_03_035;
			case ERR_EXEC_PRINT_ROLLPAPER:
				return CAPTION_03_036;
			case ERR_EXEC_PRINT_VALIDATION:
				return CAPTION_03_037;
			case ERR_THREAD:
				return CAPTION_03_038;
			case ERR_IMAGE_FILEOPEN:
				return CAPTION_03_039;
			case ERR_IMAGE_UNKNOWNFORMAT:
				return CAPTION_03_040;
			case ERR_SIZE:
				return CAPTION_03_041;
			case ERR_NOT_FOUND:
				return CAPTION_03_042;
			case ERR_NOT_EXEC:
				return CAPTION_03_043;
			case ERR_BARCODE_NODATA:
				return CAPTION_03_044;
			case ERR_MICR_PARSE:
				return CAPTION_03_045;
			case ERR_SCN_IQA:
				return CAPTION_03_046;
			case ERR_PRINT_DATA_LENGTH_EXCEED:
				return CAPTION_03_047;
			case ERR_PRINT_DATA_UNRECEIVE:
				return CAPTION_03_048;
			case ERR_INK_STATUS:
				return CAPTION_03_051;
			case ERR_IMAGE_FILEREAD:
				return CAPTION_03_049;
			default:
				static CString strResult;
				strResult.Format( _T("%d"), nResultCode );
				return strResult;
	}
}

void CTMS_SampleDlg::InitializeConfigData(void)
{
	// Member check
	ASSERT(m_pcDriverControl != NULL);
	if( m_pcDriverControl == NULL )
	{
		return;
	}

	////////////////
	//// Step 2 ////
	////////////////

	CScanParam stScanParam;
	m_pcDriverControl->GetScanParam( &stScanParam );
	ConvertScanParamToConfigData( &stScanParam, &m_sConfigData );

	////////////////
	//// Step 3 ////
	////////////////

	CMicrParam cMicrParam;
	m_pcDriverControl->GetMicrParam( &cMicrParam );
	ConvertMicrParamToConfigData( &cMicrParam, &m_sConfigData );

	////////////////
	//// Step 7 ////
	////////////////

	CIqaParam cIqaParam;
	m_pcDriverControl->GetIqaParam( &cIqaParam );
	ConvertIqaParamToConfigData( &cIqaParam, &m_sConfigData );

	COptionParam cOptionParam;
	m_pcDriverControl->GetOptionParam( &cOptionParam );
	ConvertOptionParamToConfigData( &cOptionParam, &m_sConfigData );
}

void CTMS_SampleDlg::LoadResourceString(void)
{
	////////////////
	//// Step 1 ////
	////////////////

	// Title
	this->SetWindowText( STR_SAMPLEDLG_TITLE );

	// Scan Button
	m_btnScan.SetWindowText( STR_SAMPLEDLG_BUTTON_SCAN );

	// ScanCancel Button
	m_btnScanCancel.SetWindowText( STR_SAMPLEDLG_BUTTON_SCANCANCEL );

	// Exit Button
	m_btnExit.SetWindowText( STR_SAMPLEDLG_BUTTON_EXIT );

	////////////////
	//// Step 2 ////
	////////////////

	// Config Button
	m_btnConfig.SetWindowText( STR_SAMPLEDLG_BUTTON_CONFIG );

	////////////////
	//// Step 3 ////
	////////////////

	// MICR Text Static
	m_stMicrText.SetWindowText( STR_SAMPLEDLG_STATIC_MICRTEXT );

	// Micr Cleaning Button
	m_btnMicrCleaning.SetWindowText( STR_SAMPLEDLG_BUTTON_MICRCLEANING );

	////////////////
	//// Step 7 ////
	////////////////

	// IQA Result Button
	m_btnIqaResult.SetWindowText( STR_SAMPLEDLG_BUTTON_IQARESULT );
}

void CTMS_SampleDlg::UpdateControls(void)
{
	////////////////
	//// Step 2 ////
	////////////////

	if( m_sConfigData.nRadio_LightSourceToScan == VAL_CONFIGDLG_RADIO_IC_RGBIR )
	{
		m_stImage2Front.ShowWindow( SW_HIDE );
		m_stImage2Back.ShowWindow( SW_HIDE );
		m_stImage4RGBFront.ShowWindow( SW_SHOW );
		m_stImage4RGBBack.ShowWindow( SW_SHOW );
		m_stImage4IrFront.ShowWindow( SW_SHOW );
		m_stImage4IrBack.ShowWindow( SW_SHOW );
	}
	else
	{
		m_stImage2Front.ShowWindow( SW_SHOW );
		m_stImage2Back.ShowWindow( SW_SHOW );
		m_stImage4RGBFront.ShowWindow( SW_HIDE );
		m_stImage4RGBBack.ShowWindow( SW_HIDE );
		m_stImage4IrFront.ShowWindow( SW_HIDE );
		m_stImage4IrBack.ShowWindow( SW_HIDE );
	}

	////////////////
	//// Step 7 ////
	////////////////

	if( m_pcDriverControl != NULL )
	{
		CIqaParam cIqaParam;
		m_pcDriverControl->GetIqaParam( &cIqaParam );
		m_IqaResultDlg.UpdateControls( &cIqaParam );
	}
}

// Step 2
void CTMS_SampleDlg::ConvertConfigDataToScanParam( const CONFIGDATA* psConfigData, CScanParam* pcScanParam ) const
{
	if( pcScanParam == NULL || psConfigData == NULL )
	{
		ASSERT(0);
		return;
	}

	switch( psConfigData->nRadio_ScanningMedia )
	{
		case VAL_CONFIGDLG_RADIO_SM_CHECKPAPER:
			pcScanParam->SetScanMedia( EPS_BI_SCN_UNIT_CHECKPAPER );
			break;
		case VAL_CONFIGDLG_RADIO_SM_CARD:
			pcScanParam->SetScanMedia( EPS_BI_SCN_UNIT_CARD );
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( psConfigData->nRadio_LightSourceToScan )
	{
		case VAL_CONFIGDLG_RADIO_IC_RGB:
			if( psConfigData->nRadio_RGBColorDepth == VAL_CONFIGDLG_RADIO_RGBCD_COLOR )
			{
				pcScanParam->SetLightSourceToScan( EPS_BI_SCN_OPTION_COLOR );
			}
			else
			{
				pcScanParam->SetLightSourceToScan( EPS_BI_SCN_OPTION_GRAYSCALE );
			}
			break;
		case VAL_CONFIGDLG_RADIO_IC_IR:
			pcScanParam->SetLightSourceToScan( EPS_BI_SCN_OPTION_IR );
			break;
		case VAL_CONFIGDLG_RADIO_IC_RGBIR:
			if( psConfigData->nRadio_RGBColorDepth == VAL_CONFIGDLG_RADIO_RGBCD_COLOR )
			{
				pcScanParam->SetLightSourceToScan( EPS_BI_SCN_OPTION_COLOR_IR );
			}
			else
			{
				pcScanParam->SetLightSourceToScan( EPS_BI_SCN_OPTION_GRAYSCALE_IR );
			}
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( psConfigData->nRadio_RGBColorDepth )
	{
		case VAL_CONFIGDLG_RADIO_RGBCD_COLOR:
			pcScanParam->SetRGBColorDepth( EPS_BI_SCN_24BIT );
			break;
		case VAL_CONFIGDLG_RADIO_RGBCD_GRAY:
			pcScanParam->SetRGBColorDepth( EPS_BI_SCN_8BIT );
			break;
		case VAL_CONFIGDLG_RADIO_RGBCD_BW:
			pcScanParam->SetRGBColorDepth( EPS_BI_SCN_1BIT );
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( psConfigData->nRadio_IRColorDepth )
	{
		case VAL_CONFIGDLG_RADIO_IRCD_GRAY:
			pcScanParam->SetIRColorDepth( EPS_BI_SCN_8BIT );
			break;
		case VAL_CONFIGDLG_RADIO_IRCD_BW:
			pcScanParam->SetIRColorDepth( EPS_BI_SCN_1BIT );
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( psConfigData->nCombo_Resolution )
	{
		case VAL_CONFIGDLG_COMBO_RE_600600:
			pcScanParam->SetResolution( MF_SCAN_DPI_600 );
			break;
		case VAL_CONFIGDLG_COMBO_RE_300300:
			pcScanParam->SetResolution( MF_SCAN_DPI_300 );
			break;
		case VAL_CONFIGDLG_COMBO_RE_240240:
			pcScanParam->SetResolution( MF_SCAN_DPI_240 );
			break;
		case VAL_CONFIGDLG_COMBO_RE_200200:
			pcScanParam->SetResolution( MF_SCAN_DPI_200 );
			break;
		case VAL_CONFIGDLG_COMBO_RE_120120:
			pcScanParam->SetResolution( MF_SCAN_DPI_120 );
			break;
		case VAL_CONFIGDLG_COMBO_RE_100100:
			pcScanParam->SetResolution( MF_SCAN_DPI_100 );
			break;
		default:
			ASSERT(0);
			break;
	}

	pcScanParam->SetNumberOfDocuments( psConfigData->nEdit_NumberOfDocuments );
}

// Step 3
void CTMS_SampleDlg::ConvertConfigDataToMicrParam( const CONFIGDATA* psConfigData, CMicrParam* pcMicrParam ) const
{
	if( pcMicrParam == NULL || psConfigData == NULL )
	{
		ASSERT(0);
		return;
	}

	switch( psConfigData->nRadio_MICRFont )
	{
		case VAL_CONFIGDLG_RADIO_MF_E13B:
			pcMicrParam->SetFont( MF_MICR_FONT_E13B );
			break;
		case VAL_CONFIGDLG_RADIO_MF_CMC7:
			pcMicrParam->SetFont( MF_MICR_FONT_CMC7 );
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( psConfigData->nCheck_MICR_ClearSpace )
	{
		case VAL_CONFIGDLG_CHECK_MI_CLEARSPACE_ON:
			pcMicrParam->SetClearSpace( true );
			break;
		case VAL_CONFIGDLG_CHECK_MI_CLEARSPACE_OFF:
			pcMicrParam->SetClearSpace( false );
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( psConfigData->nCheck_MICR_SaveFile )
	{
		case VAL_CONFIGDLG_CHECK_MI_SAVEFILE_ON:
			pcMicrParam->SetParsing( true );
			break;
		case VAL_CONFIGDLG_CHECK_MI_SAVEFILE_OFF:
			pcMicrParam->SetParsing( false );
			break;
		default:
			ASSERT(0);
			break;
	}
}

// Step 2
void CTMS_SampleDlg::ConvertScanParamToConfigData( const CScanParam* pcScanParam, CONFIGDATA* psConfigData ) const
{
	if( pcScanParam == NULL || psConfigData == NULL )
	{
		ASSERT(0);
		return;
	}

	switch( pcScanParam->GetScanMedia() )
	{
		case EPS_BI_SCN_UNIT_CHECKPAPER:
			psConfigData->nRadio_ScanningMedia = VAL_CONFIGDLG_RADIO_SM_CHECKPAPER;
			break;
		case EPS_BI_SCN_UNIT_CARD:
			psConfigData->nRadio_ScanningMedia = VAL_CONFIGDLG_RADIO_SM_CARD;
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( pcScanParam->GetLightSourceToScan() )
	{
		case EPS_BI_SCN_OPTION_COLOR:
		case EPS_BI_SCN_OPTION_GRAYSCALE:
		case EPS_BI_SCN_OPTION_DROPOUT_RED:
		case EPS_BI_SCN_OPTION_DROPOUT_GREEN:
		case EPS_BI_SCN_OPTION_DROPOUT_BLUE:
			psConfigData->nRadio_LightSourceToScan = VAL_CONFIGDLG_RADIO_IC_RGB;
			break;
		case EPS_BI_SCN_OPTION_IR:
			psConfigData->nRadio_LightSourceToScan = VAL_CONFIGDLG_RADIO_IC_IR;
			break;
		case EPS_BI_SCN_OPTION_COLOR_IR:
		case EPS_BI_SCN_OPTION_GRAYSCALE_IR:
		case EPS_BI_SCN_OPTION_DROPOUT_RED_IR:
		case EPS_BI_SCN_OPTION_DROPOUT_GREEN_IR:
		case EPS_BI_SCN_OPTION_DROPOUT_BLUE_IR:
			psConfigData->nRadio_LightSourceToScan = VAL_CONFIGDLG_RADIO_IC_RGBIR;
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( pcScanParam->GetRGBColorDepth() )
	{
		case EPS_BI_SCN_24BIT:
			psConfigData->nRadio_RGBColorDepth = VAL_CONFIGDLG_RADIO_RGBCD_COLOR;
			break;
		case EPS_BI_SCN_8BIT:
			psConfigData->nRadio_RGBColorDepth = VAL_CONFIGDLG_RADIO_RGBCD_GRAY;
			break;
		case EPS_BI_SCN_1BIT:
			psConfigData->nRadio_RGBColorDepth = VAL_CONFIGDLG_RADIO_RGBCD_BW;
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( pcScanParam->GetIRColorDepth() )
	{
		case EPS_BI_SCN_8BIT:
			psConfigData->nRadio_IRColorDepth = VAL_CONFIGDLG_RADIO_IRCD_GRAY;
			break;
		case EPS_BI_SCN_1BIT:
			psConfigData->nRadio_IRColorDepth = VAL_CONFIGDLG_RADIO_IRCD_BW;
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( pcScanParam->GetResolution() )
	{
		case MF_SCAN_DPI_600:
			psConfigData->nCombo_Resolution = VAL_CONFIGDLG_COMBO_RE_600600;
			break;
		case MF_SCAN_DPI_300:
			psConfigData->nCombo_Resolution = VAL_CONFIGDLG_COMBO_RE_300300;
			break;
		case MF_SCAN_DPI_240:
			psConfigData->nCombo_Resolution = VAL_CONFIGDLG_COMBO_RE_240240;
			break;
		case MF_SCAN_DPI_200:
			psConfigData->nCombo_Resolution = VAL_CONFIGDLG_COMBO_RE_200200;
			break;
		case MF_SCAN_DPI_120:
			psConfigData->nCombo_Resolution = VAL_CONFIGDLG_COMBO_RE_120120;
			break;
		case MF_SCAN_DPI_100:
			psConfigData->nCombo_Resolution = VAL_CONFIGDLG_COMBO_RE_100100;
			break;
		default:
			ASSERT(0);
			break;
	}

	psConfigData->nEdit_NumberOfDocuments = pcScanParam->GetNumberOfDocuments();
}

// Step 3
void CTMS_SampleDlg::ConvertMicrParamToConfigData( const CMicrParam* pcMicrParam, CONFIGDATA* psConfigData ) const
{
	if( pcMicrParam == NULL || psConfigData == NULL )
	{
		ASSERT(0);
		return;
	}

	switch( pcMicrParam->GetFont() )
	{
		case MF_MICR_FONT_E13B:
			psConfigData->nRadio_MICRFont = VAL_CONFIGDLG_RADIO_MF_E13B;
			break;
		case MF_MICR_FONT_CMC7:
			psConfigData->nRadio_MICRFont = VAL_CONFIGDLG_RADIO_MF_CMC7;
			break;
		default:
			ASSERT(0);
			break;
	}

	if( pcMicrParam->GetClearSpace() == true )
	{
		psConfigData->nCheck_MICR_ClearSpace = VAL_CONFIGDLG_CHECK_MI_CLEARSPACE_ON;
	}
	else
	{
		psConfigData->nCheck_MICR_ClearSpace = VAL_CONFIGDLG_CHECK_MI_CLEARSPACE_OFF;
	}
}

// Step 2
CString CTMS_SampleDlg::PrepareFolder(void)
{
	// Compose path
	TCHAR szPath[_MAX_PATH] = {0};
	(void)::GetModuleFileName (NULL, szPath, _countof(szPath));
	(void)::PathRemoveFileSpec(szPath);
	(void)::PathAppend        (szPath, _T("ScanResult"));

	CString strPath = CString(szPath);

	// Check if the folder is already exist.
	if(::PathIsDirectory(strPath) == FALSE)
	{
		// Create a folder
		if(::CreateDirectory( strPath, NULL ) == FALSE)
		{
			return CString();
		}
	}

	return strPath;
}

void CTMS_SampleDlg::UpdateImageData( BYTE byFace, BYTE byLightSource, short sResolution, BYTE byColorDepth, CImageBox& Image, bool bSave )
{
	// Member check
	ASSERT(m_pcDriverControl != NULL);
	if( m_pcDriverControl == NULL )
	{
		return;
	}

	CImageResult cImageResult;

	// Obtain image data
	cImageResult.SetFace( byFace );
	cImageResult.SetLightSource( byLightSource );
	cImageResult.SetResolution( sResolution );
	cImageResult.SetColorDepth( byColorDepth );

	// Show image on the window
	{
		cImageResult.SetFormat( EPS_BI_SCN_BITMAP );
		int nResult = m_pcDriverControl->GetScanImage( &cImageResult );
		if( nResult != SUCCESS )
		{
			ShowErrorMessage( nResult );
			return;
		}

		if( ! Image.SetImage( cImageResult.GetImage(), cImageResult.GetImageSize(), cImageResult.GetImageWidth(), cImageResult.GetImageHeight() ) )
		{
			ShowErrorMessage( ERR_UNKNOWN );
			return;
		}
		Image.Draw();
	}
	// Save image
	if ( bSave )
	{
		// Specify image data format
		CString strExt;
		if( byColorDepth == EPS_BI_SCN_1BIT )
		{
			cImageResult.SetFormat( EPS_BI_SCN_TIFF );
			strExt = _T("tif");
		}
		else
		{
			cImageResult.SetFormat( EPS_BI_SCN_JPEGNORMAL );
			strExt = _T("jpg");
		}

		// Obtain image data
		int nResult = m_pcDriverControl->GetScanImage( &cImageResult );
		if( nResult != SUCCESS )
		{
			ShowErrorMessage( nResult );
			return;
		}

		if ( cImageResult.GetImage() != NULL )
		{
			LPBYTE lpImage = cImageResult.GetImage();
			DWORD dwImageSize = cImageResult.GetImageSize();
			DWORD dwTransactionNumber = cImageResult.GetTransactionNumber();

			// Prepare folder to store data
			CString strPath = PrepareFolder();
			if(strPath.IsEmpty())
			{
				MessageBox( MSG_05_000, CAPTION_05_000, MB_OK | MB_ICONERROR );
				return;
			}

			// Compose file name
			CString strFileName;
			strFileName.Format(
					_T("%03d_%sImage%s.%s"),
					dwTransactionNumber,
					byLightSource == MF_SCAN_IMAGE_2ND_LIGHTSOURCE ? _T("IR_") : _T(""),
					byFace == MF_SCAN_FACE_BACK ? _T("Back") : _T("Front"),
					strExt );
			(void)::PathAppend( CStrBuf(strPath, MAX_PATH), strFileName );

			FILE* pFile = NULL;
			errno_t err = fopen_s( &pFile, strPath, _T("wb") );
			if( err != 0 )
			{
				MessageBox( MSG_05_001, CAPTION_05_001, MB_OK | MB_ICONERROR );
				return;
			}

			if( lpImage != NULL )
			{
				fwrite( lpImage, 1, dwImageSize, pFile );
			}

			if( fclose( pFile ) == EOF )
			{
				MessageBox( MSG_05_001, CAPTION_05_001, MB_OK | MB_ICONERROR );
			}
		}
	}
}

void CTMS_SampleDlg::ClearImage(void)
{
	m_Image2Front.ClearImage();
	m_Image2Back.ClearImage();
	m_Image4RGBFront.ClearImage();
	m_Image4RGBBack.ClearImage();
	m_Image4IrFront.ClearImage();
	m_Image4IrBack.ClearImage();

	RedrawWindow();
}

// Step 3
void CTMS_SampleDlg::SaveMicrData(void)
{
	// Member check
	ASSERT(m_pcDriverControl != NULL);
	if( m_pcDriverControl == NULL )
	{
		return;
	}

	// Obtain MICR data
	CMicrResult cMicrResult;
	int nResult = m_pcDriverControl->GetMicr( &cMicrResult );
	DWORD dwTransactionNumber = cMicrResult.GetTransactionNumber();

	if( nResult != SUCCESS )
	{
		ShowErrorMessage( nResult );
		return;
	}

	// Prepare folder to store data
	CString strPath = PrepareFolder();
	if(strPath.IsEmpty())
	{
		MessageBox( MSG_05_000, CAPTION_05_000, MB_OK | MB_ICONERROR );
		return;
	}

	// Compose file name
	CString strFileName;
	strFileName.Format( _T("%03d.Micr.txt"), dwTransactionNumber );
	(void)::PathAppend( CStrBuf(strPath, MAX_PATH), strFileName );

	FILE* pFile = NULL;
	errno_t err = fopen_s( &pFile, strPath, _T("wt") );
	if( err != 0 )
	{
		MessageBox( MSG_05_001, CAPTION_05_001, MB_OK | MB_ICONERROR );
		return;
	}

	// Transaction number
	fprintf( pFile, "# General Transaction Information:\n" );
	fprintf( pFile, "TransactionNumber = %d\n", dwTransactionNumber );

	// MICR reading status
	fprintf( pFile, "\n" );
	fprintf( pFile, "# Magnetic Character Results:\n" );
	fprintf( pFile, "Status = %d\n", cMicrResult.GetStatus() );

	// Detail MICR reading status
	fprintf( pFile, "Detail = %d\n", cMicrResult.GetDetail() );

	// Return value of MICR function
	fprintf( pFile, "MicrResult = %s\n", GetErrorString( cMicrResult.GetResult() ) );

	// Obtained MICR strings
	fprintf( pFile, "MicrString = %s\n", cMicrResult.GetMicrStr() != NULL ? cMicrResult.GetMicrStr() : "" );

	// MicrAccountNumber
	fprintf( pFile, "MicrAccountNumber = %s\n", cMicrResult.GetAccountNumber() != NULL ? cMicrResult.GetAccountNumber() : "" );

	// MicrAmount
	fprintf( pFile, "MicrAmount        = %s\n", cMicrResult.GetAmount() != NULL ? cMicrResult.GetAmount() : "" );

	// MicrBankNumber
	fprintf( pFile, "MicrBankNumber    = %s\n", cMicrResult.GetBankNumber() != NULL ? cMicrResult.GetBankNumber() : "" );

	// MicrSerialNumber
	fprintf( pFile, "MicrSerialNumber  = %s\n",  cMicrResult.GetSerialNumber() != NULL ? cMicrResult.GetSerialNumber() : "" );

	// MicrEPC
	fprintf( pFile, "MicrEPC           = %s\n", cMicrResult.GetEPC() != NULL ? cMicrResult.GetEPC() : "" );

	// MicrTransitNumber
	fprintf( pFile, "MicrTransitNumber = %s\n",  cMicrResult.GetTransitNumber() != NULL ? cMicrResult.GetTransitNumber() : "" );

	// MicrCheckType
	fprintf( pFile, "MicrCheckType     = %d\n",  cMicrResult.GetCheckType() );

	// MicrCountryCode
	fprintf( pFile, "MicrCountryCode     = %d\n", cMicrResult.GetCountryCode() );

	// MicrOnUSField
	fprintf( pFile, "MicrOnUSField = %s\n",  cMicrResult.GetOnUSField() != NULL ? cMicrResult.GetOnUSField() : "" );

	// MicrAuxiliatyOnUSField
	fprintf( pFile, "MicrAuxiliatyOnUSField = %s\n",  cMicrResult.GetAuxiliatyOnUSField() != NULL ? cMicrResult.GetAuxiliatyOnUSField() : "" );

	if( fclose( pFile ) == EOF )
	{
		MessageBox( MSG_05_001, CAPTION_05_001, MB_OK | MB_ICONERROR );
	}
}

// Step 7
void CTMS_SampleDlg::ConvertConfigDataToIqaParam( const CONFIGDATA* psConfigData, CIqaParam* pcIqaParam ) const
{
	if( pcIqaParam == NULL || psConfigData == NULL )
	{
		ASSERT(0);
		return;
	}

	switch( psConfigData->nCheck_IQA_Detect )
	{
		case VAL_CONFIGDLG_CHECK_IQ_DETECT_OFF:
			pcIqaParam->SetIqaDetect( MF_ERROR_SELECT_NODETECT );
			break;
		case VAL_CONFIGDLG_CHECK_IQ_DETECT_ON:
			pcIqaParam->SetIqaDetect( MF_ERROR_SELECT_DETECT );
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( psConfigData->nCombo_IqaColorDepth )	// IqaColorDepth
	{
		case VAL_CONFIGDLG_COMBO_CD_GRAY:
			pcIqaParam->SetIqaColorDepth( EPS_BI_SCN_8BIT );
			break;
		case VAL_CONFIGDLG_COMBO_CD_BW:
			pcIqaParam->SetIqaColorDepth( EPS_BI_SCN_1BIT );
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( psConfigData->nCheck_IQA_Cancel )	// IqaCancel
	{
		case VAL_CONFIGDLG_CHECK_IQ_CANCEL_OFF:
			pcIqaParam->SetIqaCancel( MF_CANCEL_DISABLE );
			break;
		case VAL_CONFIGDLG_CHECK_IQ_CANCEL_ON:
			pcIqaParam->SetIqaCancel( MF_CANCEL_ENABLE );
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( psConfigData->nCombo_IqaEjectPocket )	// IqaEjectPocket
	{
		case VAL_CONFIGDLG_COMBO_EP_MAINPOCKET:
			pcIqaParam->SetIqaEjectPocket( MF_EJECT_MAIN_POCKET );
			break;
		case VAL_CONFIGDLG_COMBO_EP_SUBPOCKET:
			pcIqaParam->SetIqaEjectPocket( MF_EJECT_SUB_POCKET );
			break;
		case VAL_CONFIGDLG_COMBO_EP_NOEJECT:
			pcIqaParam->SetIqaEjectPocket( MF_EJECT_NOEJECT );
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( psConfigData->nCheck_IQA_UnderSize )	// UnderSizeDetect
	{
		case VAL_CONFIGDLG_CHECK_IQ_UNDERSIZE_OFF:
			pcIqaParam->SetUnderSize( MF_IQA_TEST_DISABLE );
			break;
		case VAL_CONFIGDLG_CHECK_IQ_UNDERSIZE_ON:
			pcIqaParam->SetUnderSize( MF_IQA_TEST_ENABLE );
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( psConfigData->nCheck_IQA_OverSize )	// OverSizeDetect
	{
		case VAL_CONFIGDLG_CHECK_IQ_OVERSIZE_OFF:
			pcIqaParam->SetOverSize( MF_IQA_TEST_DISABLE );
			break;
		case VAL_CONFIGDLG_CHECK_IQ_OVERSIZE_ON:
			pcIqaParam->SetOverSize( MF_IQA_TEST_ENABLE );
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( psConfigData->nCheck_IQA_MinCompressed )	// MinCompressedDetect
	{
		case VAL_CONFIGDLG_CHECK_IQ_MINCOMPRESSED_OFF:
			pcIqaParam->SetMinCompressed( MF_IQA_TEST_DISABLE );
			break;
		case VAL_CONFIGDLG_CHECK_IQ_MINCOMPRESSED_ON:
			pcIqaParam->SetMinCompressed( MF_IQA_TEST_ENABLE );
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( psConfigData->nCheck_IQA_MaxCompressed )	// MaxCompressedDetect
	{
		case VAL_CONFIGDLG_CHECK_IQ_MAXCOMPRESSED_OFF:
			pcIqaParam->SetMaxCompressed( MF_IQA_TEST_DISABLE );
			break;
		case VAL_CONFIGDLG_CHECK_IQ_MAXCOMPRESSED_ON:
			pcIqaParam->SetMaxCompressed( MF_IQA_TEST_ENABLE );
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( psConfigData->nCheck_IQA_FrontRearMismatch )	// FrontRearMismatchDetect
	{
		case VAL_CONFIGDLG_CHECK_IQ_FRONTREARMISMATCH_OFF:
			pcIqaParam->SetFrontRearImageMismatch( MF_IQA_TEST_DISABLE );
			break;
		case VAL_CONFIGDLG_CHECK_IQ_FRONTREARMISMATCH_ON:
			pcIqaParam->SetFrontRearImageMismatch( MF_IQA_TEST_ENABLE );
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( psConfigData->nCheck_IQA_TooLight )	// TooLightDetect
	{
		case VAL_CONFIGDLG_CHECK_IQ_TOOLIGHT_OFF:
			pcIqaParam->SetImageTooLight( MF_IQA_TEST_DISABLE );
			break;
		case VAL_CONFIGDLG_CHECK_IQ_TOOLIGHT_ON:
			pcIqaParam->SetImageTooLight( MF_IQA_TEST_ENABLE );
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( psConfigData->nCheck_IQA_TooDark )	// TooDarkDetect
	{
		case VAL_CONFIGDLG_CHECK_IQ_TOODARK_OFF:
			pcIqaParam->SetImageTooDark( MF_IQA_TEST_DISABLE );
			break;
		case VAL_CONFIGDLG_CHECK_IQ_TOODARK_ON:
			pcIqaParam->SetImageTooDark( MF_IQA_TEST_ENABLE );
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( psConfigData->nCheck_IQA_HorizontalStreaks )	// HorizontalStreaksDetect
	{
		case VAL_CONFIGDLG_CHECK_IQ_HORIZONTALSTREAK_OFF:
			pcIqaParam->SetHorizontalStreaksPresent( MF_IQA_TEST_DISABLE );
			break;
		case VAL_CONFIGDLG_CHECK_IQ_HORIZONTALSTREAK_ON:
			pcIqaParam->SetHorizontalStreaksPresent( MF_IQA_TEST_ENABLE );
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( psConfigData->nCheck_IQA_SpotNoise )	// SpotNoiseDetect
	{
		case VAL_CONFIGDLG_CHECK_IQ_SPOTNOISE_OFF:
			pcIqaParam->SetSpotNoise( MF_IQA_TEST_DISABLE );
			break;
		case VAL_CONFIGDLG_CHECK_IQ_SPOTNOISE_ON:
			pcIqaParam->SetSpotNoise( MF_IQA_TEST_ENABLE );
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( psConfigData->nCheck_IQA_OutOfFocus )	// OutOfFocusDetect
	{
		case VAL_CONFIGDLG_CHECK_IQ_OUTOFFOCUS_OFF:
			pcIqaParam->SetOutOfFocus( MF_IQA_TEST_DISABLE );
			break;
		case VAL_CONFIGDLG_CHECK_IQ_OUTOFFOCUS_ON:
			pcIqaParam->SetOutOfFocus( MF_IQA_TEST_ENABLE );
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( psConfigData->nCheck_IQA_DocCorners )	// DocCornersDetect
	{
		case VAL_CONFIGDLG_CHECK_IQ_DOCCORNER_OFF:
			pcIqaParam->SetFoldedTornCorner( MF_IQA_TEST_DISABLE );
			break;
		case VAL_CONFIGDLG_CHECK_IQ_DOCCORNER_ON:
			pcIqaParam->SetFoldedTornCorner( MF_IQA_TEST_ENABLE );
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( psConfigData->nCheck_IQA_DocEdges )	// DocEdgesDetect
	{
		case VAL_CONFIGDLG_CHECK_IQ_DOCEDGE_OFF:
			pcIqaParam->SetFoldedTornEdge( MF_IQA_TEST_DISABLE );
			break;
		case VAL_CONFIGDLG_CHECK_IQ_DOCEDGE_ON:
			pcIqaParam->SetFoldedTornEdge( MF_IQA_TEST_ENABLE );
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( psConfigData->nCheck_IQA_FramingError )	// FramingErrorDetect
	{
		case VAL_CONFIGDLG_CHECK_IQ_FRAMINGERROR_OFF:
			pcIqaParam->SetFramingError( MF_IQA_TEST_DISABLE );
			break;
		case VAL_CONFIGDLG_CHECK_IQ_FRAMINGERROR_ON:
			pcIqaParam->SetFramingError( MF_IQA_TEST_ENABLE );
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( psConfigData->nCheck_IQA_Skew )	// SkewDetect
	{
		case VAL_CONFIGDLG_CHECK_IQ_SKEW_OFF:
			pcIqaParam->SetExcessiveSkew( MF_IQA_TEST_DISABLE );
			break;
		case VAL_CONFIGDLG_CHECK_IQ_SKEW_ON:
			pcIqaParam->SetExcessiveSkew( MF_IQA_TEST_ENABLE );
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( psConfigData->nCheck_IQA_CarbonStrip )	// CarbonStripDetect
	{
		case VAL_CONFIGDLG_CHECK_IQ_CARBONSTRIP_OFF:
			pcIqaParam->SetCarbonStripDetection( MF_IQA_TEST_DISABLE );
			break;
		case VAL_CONFIGDLG_CHECK_IQ_CARBONSTRIP_ON:
			pcIqaParam->SetCarbonStripDetection( MF_IQA_TEST_ENABLE );
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( psConfigData->nCheck_IQA_Piggyback )	// PiggybackDetect
	{
		case VAL_CONFIGDLG_CHECK_IQ_PIGGYBACK_OFF:
			pcIqaParam->SetPiggyback( MF_IQA_TEST_DISABLE );
			break;
		case VAL_CONFIGDLG_CHECK_IQ_PIGGYBACK_ON:
			pcIqaParam->SetPiggyback( MF_IQA_TEST_ENABLE );
			break;
		default:
			ASSERT(0);
			break;
	}
}

// Step 7
void CTMS_SampleDlg::ConvertConfigDataToOptionParam( const CONFIGDATA* psConfigData, COptionParam* pcOptionParam ) const
{
	if( pcOptionParam == NULL || psConfigData == NULL )
	{
		ASSERT(0);
		return;
	}

	switch( psConfigData->nCombo_WaterfallMode )
	{
		case VAL_CONFIGDLG_COMBO_WM_DISABLE:
			pcOptionParam->SetWaterfall( WATERFALL_MODE_DISABLE );
			break;
		case VAL_CONFIGDLG_COMBO_WM_STANDARD:
			pcOptionParam->SetWaterfall( WATERFALL_MODE_STANDARD );
			break;
		case VAL_CONFIGDLG_COMBO_WM_INHERIT:
			pcOptionParam->SetWaterfall( WATERFALL_MODE_INHERIT_POCKET );
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( psConfigData->nRadio_ActivationMode )
	{
		case VAL_CONFIGDLG_RADIO_AM_HIGHSPEED:
			pcOptionParam->SetActivation( MF_ACTIVATE_MODE_HIGH_SPEED );
			break;
		case VAL_CONFIGDLG_RADIO_AM_CONFIRMATION:
			pcOptionParam->SetActivation( MF_ACTIVATE_MODE_CONFIRMATION );
			break;
		default:
			ASSERT(0);
			break;
	}
}

void CTMS_SampleDlg::ConvertConfirmationDataToOptionParam( const CONFIRMATIONDATA* psConfirmationData, COptionParam* pcOptionParam ) const
{
	if( pcOptionParam == NULL || psConfirmationData == NULL )
	{
		ASSERT(0);
		return;
	}

	switch( psConfirmationData->nRadio_Confirmation_EjectPocket )
	{
		case VAL_CONFIRMATIONDLG_RADIO_EP_MAINPOCKET:
			pcOptionParam->SetConfirmationEject( MF_EJECT_MAIN_POCKET );
			break;
		case VAL_CONFIRMATIONDLG_RADIO_EP_SUBPOCKET:
			pcOptionParam->SetConfirmationEject( MF_EJECT_SUB_POCKET );
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( psConfirmationData->nCheck_Confirmation_Cancel )
	{
		case VAL_CONFIRMATIONDLG_CHECK_CM_CANCEL_OFF:
			pcOptionParam->SetConfirmationCancel( MF_PROCESS_CONTINUE_OVERLAP );
			break;
		case VAL_CONFIRMATIONDLG_CHECK_CM_CANCEL_ON:
			pcOptionParam->SetConfirmationCancel( MF_PROCESS_CONTINUE_CANCEL );
			break;
		default:
			ASSERT(0);
			break;
	}
}

void CTMS_SampleDlg::ConvertIqaParamToConfigData( const CIqaParam* pcIqaParam, CONFIGDATA* psConfigData ) const
{
	if( pcIqaParam == NULL || psConfigData == NULL )
	{
		ASSERT(0);
		return;
	}

	switch( pcIqaParam->GetIqaDetect() )
	{
		case MF_ERROR_SELECT_NODETECT:
			psConfigData->nCheck_IQA_Detect = VAL_CONFIGDLG_CHECK_IQ_DETECT_OFF;
			break;
		case MF_ERROR_SELECT_DETECT:
			psConfigData->nCheck_IQA_Detect = VAL_CONFIGDLG_CHECK_IQ_DETECT_ON;
			break;
		default:
			ASSERT(0);
	}

	switch( pcIqaParam->GetIqaColorDepth() )
	{
		case EPS_BI_SCN_1BIT:
			psConfigData->nCombo_IqaColorDepth = VAL_CONFIGDLG_COMBO_CD_BW;
			break;
		case EPS_BI_SCN_8BIT:
			psConfigData->nCombo_IqaColorDepth = VAL_CONFIGDLG_COMBO_CD_GRAY;
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( pcIqaParam->GetIqaCancel() )
	{
		case MF_CANCEL_DISABLE:
			psConfigData->nCheck_IQA_Cancel = VAL_CONFIGDLG_CHECK_IQ_CANCEL_OFF;
			break;
		case MF_CANCEL_ENABLE:
			psConfigData->nCheck_IQA_Cancel = VAL_CONFIGDLG_CHECK_IQ_CANCEL_ON;
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( pcIqaParam->GetIqaEjectPocket() )
	{
		case MF_EJECT_MAIN_POCKET:
			psConfigData->nCombo_IqaEjectPocket = VAL_CONFIGDLG_COMBO_EP_MAINPOCKET;
			break;
		case MF_EJECT_SUB_POCKET:
			psConfigData->nCombo_IqaEjectPocket = VAL_CONFIGDLG_COMBO_EP_SUBPOCKET;
			break;
		case MF_EJECT_NOEJECT:
			psConfigData->nCombo_IqaEjectPocket = VAL_CONFIGDLG_COMBO_EP_NOEJECT;
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( pcIqaParam->GetUnderSize() )
	{
		case MF_IQA_TEST_DISABLE:
			psConfigData->nCheck_IQA_UnderSize = VAL_CONFIGDLG_CHECK_IQ_UNDERSIZE_OFF;
			break;
		case MF_IQA_TEST_ENABLE:
			psConfigData->nCheck_IQA_UnderSize = VAL_CONFIGDLG_CHECK_IQ_UNDERSIZE_ON;
			break;
		default:
			ASSERT(0);
			break;
	}
	
	switch( pcIqaParam->GetOverSize() )
	{
		case MF_IQA_TEST_DISABLE:
			psConfigData->nCheck_IQA_OverSize = VAL_CONFIGDLG_CHECK_IQ_OVERSIZE_OFF;
			break;
		case MF_IQA_TEST_ENABLE:
			psConfigData->nCheck_IQA_OverSize = VAL_CONFIGDLG_CHECK_IQ_OVERSIZE_ON;
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( pcIqaParam->GetMinCompressed() )
	{
		case MF_IQA_TEST_DISABLE:
			psConfigData->nCheck_IQA_MinCompressed = VAL_CONFIGDLG_CHECK_IQ_MINCOMPRESSED_OFF;
			break;
		case MF_IQA_TEST_ENABLE:
			psConfigData->nCheck_IQA_MinCompressed = VAL_CONFIGDLG_CHECK_IQ_MINCOMPRESSED_ON;
			break;
		default:
			ASSERT(0);
			break;
	}
	
	switch( pcIqaParam->GetMaxCompressed() )
	{
		case MF_IQA_TEST_DISABLE:
			psConfigData->nCheck_IQA_MaxCompressed = VAL_CONFIGDLG_CHECK_IQ_MAXCOMPRESSED_OFF;
			break;
		case MF_IQA_TEST_ENABLE:
			psConfigData->nCheck_IQA_MaxCompressed = VAL_CONFIGDLG_CHECK_IQ_MAXCOMPRESSED_ON;
			break;
		default:
			ASSERT(0);
			break;
	}
	
	switch( pcIqaParam->GetFrontRearImageMismatch() )
	{
		case MF_IQA_TEST_DISABLE:
			psConfigData->nCheck_IQA_FrontRearMismatch = VAL_CONFIGDLG_CHECK_IQ_FRONTREARMISMATCH_OFF;
			break;
		case MF_IQA_TEST_ENABLE:
			psConfigData->nCheck_IQA_FrontRearMismatch = VAL_CONFIGDLG_CHECK_IQ_FRONTREARMISMATCH_ON;
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( pcIqaParam->GetImageTooLight() )
	{
		case MF_IQA_TEST_DISABLE:
			psConfigData->nCheck_IQA_TooLight = VAL_CONFIGDLG_CHECK_IQ_TOOLIGHT_OFF;
			break;
		case MF_IQA_TEST_ENABLE:
			psConfigData->nCheck_IQA_TooLight = VAL_CONFIGDLG_CHECK_IQ_TOOLIGHT_ON;
			break;
		default:
			ASSERT(0);
			break;
	}
	
	switch( pcIqaParam->GetImageTooDark() )
	{
		case MF_IQA_TEST_DISABLE:
			psConfigData->nCheck_IQA_TooDark = VAL_CONFIGDLG_CHECK_IQ_TOODARK_OFF;
			break;
		case MF_IQA_TEST_ENABLE:
			psConfigData->nCheck_IQA_TooDark = VAL_CONFIGDLG_CHECK_IQ_TOODARK_ON;
			break;
		default:
			ASSERT(0);
			break;
	}
	
	switch( pcIqaParam->GetHorizontalStreaksPresent() )
	{
		case MF_IQA_TEST_DISABLE:
			psConfigData->nCheck_IQA_HorizontalStreaks = VAL_CONFIGDLG_CHECK_IQ_HORIZONTALSTREAK_OFF;
			break;
		case MF_IQA_TEST_ENABLE:
			psConfigData->nCheck_IQA_HorizontalStreaks = VAL_CONFIGDLG_CHECK_IQ_HORIZONTALSTREAK_ON;
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( pcIqaParam->GetSpotNoise() )
	{
		case MF_IQA_TEST_DISABLE:
			psConfigData->nCheck_IQA_SpotNoise = VAL_CONFIGDLG_CHECK_IQ_SPOTNOISE_OFF;
			break;
		case MF_IQA_TEST_ENABLE:
			psConfigData->nCheck_IQA_SpotNoise = VAL_CONFIGDLG_CHECK_IQ_SPOTNOISE_ON;
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( pcIqaParam->GetOutOfFocus() )
	{
		case MF_IQA_TEST_DISABLE:
			psConfigData->nCheck_IQA_OutOfFocus = VAL_CONFIGDLG_CHECK_IQ_OUTOFFOCUS_OFF;
			break;
		case MF_IQA_TEST_ENABLE:
			psConfigData->nCheck_IQA_OutOfFocus = VAL_CONFIGDLG_CHECK_IQ_OUTOFFOCUS_ON;
			break;
		default:
			ASSERT(0);
			break;
	}
	
	switch( pcIqaParam->GetFoldedTornCorner() )
	{
		case MF_IQA_TEST_DISABLE:
			psConfigData->nCheck_IQA_DocCorners = VAL_CONFIGDLG_CHECK_IQ_DOCCORNER_OFF;
			break;
		case MF_IQA_TEST_ENABLE:
			psConfigData->nCheck_IQA_DocCorners = VAL_CONFIGDLG_CHECK_IQ_DOCCORNER_ON;
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( pcIqaParam->GetFoldedTornEdge() )
	{
		case MF_IQA_TEST_DISABLE:
			psConfigData->nCheck_IQA_DocEdges = VAL_CONFIGDLG_CHECK_IQ_DOCEDGE_OFF;
			break;
		case MF_IQA_TEST_ENABLE:
			psConfigData->nCheck_IQA_DocEdges = VAL_CONFIGDLG_CHECK_IQ_DOCEDGE_ON;
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( pcIqaParam->GetFramingError() )
	{
		case MF_IQA_TEST_DISABLE:
			psConfigData->nCheck_IQA_FramingError = VAL_CONFIGDLG_CHECK_IQ_FRAMINGERROR_OFF;
			break;
		case MF_IQA_TEST_ENABLE:
			psConfigData->nCheck_IQA_FramingError = VAL_CONFIGDLG_CHECK_IQ_FRAMINGERROR_ON;
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( pcIqaParam->GetExcessiveSkew() )
	{
		case MF_IQA_TEST_DISABLE:
			psConfigData->nCheck_IQA_Skew = VAL_CONFIGDLG_CHECK_IQ_SKEW_OFF;
			break;
		case MF_IQA_TEST_ENABLE:
			psConfigData->nCheck_IQA_Skew = VAL_CONFIGDLG_CHECK_IQ_SKEW_ON;
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( pcIqaParam->GetCarbonStripDetection() )
	{
		case MF_IQA_TEST_DISABLE:
			psConfigData->nCheck_IQA_CarbonStrip = VAL_CONFIGDLG_CHECK_IQ_CARBONSTRIP_OFF;
			break;
		case MF_IQA_TEST_ENABLE:
			psConfigData->nCheck_IQA_CarbonStrip = VAL_CONFIGDLG_CHECK_IQ_CARBONSTRIP_ON;
			break;
		default:
			ASSERT(0);
			break;
	}

	switch( pcIqaParam->GetPiggyback() )
	{
		case MF_IQA_TEST_DISABLE:
			psConfigData->nCheck_IQA_Piggyback = VAL_CONFIGDLG_CHECK_IQ_PIGGYBACK_OFF;
			break;
		case MF_IQA_TEST_ENABLE:
			psConfigData->nCheck_IQA_Piggyback = VAL_CONFIGDLG_CHECK_IQ_PIGGYBACK_ON;
			break;
		default:
			ASSERT(0);
			break;
	}
}

void CTMS_SampleDlg::ConvertOptionParamToConfigData( const COptionParam* pcOptionParam, CONFIGDATA* psConfigData ) const
{
	if( pcOptionParam == NULL || psConfigData == NULL )
	{
		ASSERT(0);
		return;
	}

	switch( pcOptionParam->GetWaterfall() )
	{
		case WATERFALL_MODE_DISABLE:
			psConfigData->nCombo_WaterfallMode = VAL_CONFIGDLG_COMBO_WM_DISABLE;
			break;
		case WATERFALL_MODE_STANDARD:
			psConfigData->nCombo_WaterfallMode = VAL_CONFIGDLG_COMBO_WM_STANDARD;
			break;
		case WATERFALL_MODE_INHERIT_POCKET:
			psConfigData->nCombo_WaterfallMode = VAL_CONFIGDLG_COMBO_WM_INHERIT;
			break;
		default:
			ASSERT(0);
			break;
	}

	// Step 7
	switch( pcOptionParam->GetActivation() )
	{
		case MF_ACTIVATE_MODE_HIGH_SPEED:
			psConfigData->nRadio_ActivationMode = VAL_CONFIGDLG_RADIO_AM_HIGHSPEED;
			break;
		case MF_ACTIVATE_MODE_CONFIRMATION:
			psConfigData->nRadio_ActivationMode = VAL_CONFIGDLG_RADIO_AM_CONFIRMATION;
			break;
		default:
			ASSERT(0);
			break;
	}
}
