////////////////
//// Step 8 ////
////////////////

#pragma once
#include "afxwin.h"

#define TWO_POCKET_MODEL	0x0002
#define SCAN_200DPM_MODEL	0x0010
#define SCAN_110DPM_MODEL	0x0008

// CDeviceInfoDlg dialog

class CDeviceInfoDlg : public CDialog
{
	DECLARE_DYNAMIC(CDeviceInfoDlg)

public:
	CDeviceInfoDlg(CWnd* pParent = NULL);   // Standard constractor
	virtual ~CDeviceInfoDlg(void);

	// Dialog resouce ID
	enum { IDD = IDD_DEVICEINFO_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

public:
	DECLARE_MESSAGE_MAP()
	virtual BOOL OnInitDialog(void);
	afx_msg void OnBnClickedClose(void);

// Control
protected:
	CButton	m_btnClose;

	CEdit m_edtDIDeviceName;
	CEdit m_edtDIFirmwareVersion;
	CEdit m_edtDIManufacture;
	CEdit m_edtDISerialNumber;
	CEdit m_edtDISpeed;
	CEdit m_edtDIPocket;
	CEdit m_edtMCScanedCheck;
	CEdit m_edtMCScanedCard;
	CEdit m_edtMCLineFeeds;         // S9000 only
	CEdit m_edtMCPumpOperation;
	CEdit m_edtMCMicrRead;
	CEdit m_edtMCHeadShotA;
	CEdit m_edtMCHeadShotB;
	CEdit m_edtMCHeadEnergization;  // S9000 only
	CEdit m_edtMCAsfSendingOff;
	CEdit m_edtMCHeadLineFeeds;     // S9000 only
	CEdit m_edtMCAutoCutter;        // S9000 only
	CEdit m_edtMCHopper;
	CEdit m_edtMCPocketSelect;
	CEdit m_edtMCDeviceOperationTime;

	CStatic m_stDIDeviceName;
	CStatic m_stDIFirmwareVersion;
	CStatic m_stDIManufacture;
	CStatic m_stDISerialNumber;
	CStatic m_stDISpeed;
	CStatic m_stDIPocket;
	CStatic m_stMCScanedCheck;
	CStatic m_stMCScanedCard;
	CStatic m_stMCLineFeeds;        // S9000 only
	CStatic m_stMCPumpOperation;
	CStatic m_stMCMicrRead;
	CStatic m_stMCHeadShotA;
	CStatic m_stMCHeadShotB;
	CStatic m_stMCHeadEnergization; // S9000 only
	CStatic m_stMCAsfSendingOff;
	CStatic m_stMCHeadLineFeeds;    // S9000 only
	CStatic m_stMCAutoCutter;       // S9000 only
	CStatic m_stMCHopper;
	CStatic m_stMCPocketSelect;
	CStatic m_stMCDeviceOperationTime;

	CStatic	m_stGroupDeviceInfo;
	CStatic	m_stGroupMaintenanceCounter;

public:
	void DisplayDeviceInfo( CDeviceInfo* pcDeviceInfo );
	void DisplayMaintenanceCounter( CMaintenanceCounter* pcMaintenanceCounter );

protected:
	void LoadResourceString(void);
	void DisplayDWORDOnEdit( CEdit& edit, DWORD dw );
};
