#include "stdafx.h"
#include "Info.h"

CInfo::CInfo(void)
{
	m_pCProperty = NULL;
}

CInfo::~CInfo(void)
{
}

int CInfo::Init(CProperty_1* pProperty)
{
	int nResult = SUCCESS;

	m_pCProperty = pProperty;

	GetAPIProcAddress();

	return nResult;
}

// Get device status
int CInfo::GetDeviceStatusFunction(CDeviceStatus *pDeviceStatus)
{
	int nResult		= SUCCESS;
	DWORD dwStatus	= 0;

	if(pDeviceStatus == NULL)
	{
		return -1;
	}

	nResult = BiGetStatus(m_pCProperty->GetHandle(), &dwStatus);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	// ASB_NO_RESPONSE
	if((dwStatus & ASB_NO_RESPONSE) == ASB_NO_RESPONSE)
	{
		pDeviceStatus->SetNoResponse(true);
	}
	else
	{
		pDeviceStatus->SetNoResponse(false);
	}

	// ASB_OFF_LINE
	if((dwStatus & ASB_OFF_LINE) == ASB_OFF_LINE)
	{
		pDeviceStatus->SetOffLine(true);
	}
	else
	{
		pDeviceStatus->SetOffLine(false);
	}

	// ASB_COVER_OPEN
	if((dwStatus & ASB_COVER_OPEN) == ASB_COVER_OPEN)
	{
		pDeviceStatus->SetCoverOpen(true);
	}
	else
	{
		pDeviceStatus->SetCoverOpen(false);
	}

	// ASB_WAIT_PEPRT_EJECT
	if((dwStatus & ASB_WAIT_PEPRT_EJECT) == ASB_WAIT_PEPRT_EJECT)
	{
		pDeviceStatus->SetWaitPaperEject(true);
	}
	else
	{
		pDeviceStatus->SetWaitPaperEject(false);
	}

	// ASB_MECHANICAL_ERR
	if((dwStatus & ASB_MECHANICAL_ERR) == ASB_MECHANICAL_ERR)
	{
		pDeviceStatus->SetMechanicalError(true);
	}
	else
	{
		pDeviceStatus->SetMechanicalError(false);
	}

	// ASB_UNRECOVER_ERR
	if((dwStatus & ASB_UNRECOVER_ERR) == ASB_UNRECOVER_ERR)
	{
		pDeviceStatus->SetUnrecoverError(true);
	}
	else
	{
		pDeviceStatus->SetUnrecoverError(false);
	}

	// ASB_PAPER_INTERMEDIATE
	if((dwStatus & ASB_PAPER_INTERMEDIATE) == ASB_PAPER_INTERMEDIATE)
	{
		pDeviceStatus->SetPaperInsermadiate(true);
	}
	else
	{
		pDeviceStatus->SetPaperInsermadiate(false);
	}

	// ASB_RECEIPT_NEAR_END
	if((dwStatus & ASB_RECEIPT_NEAR_END) == ASB_RECEIPT_NEAR_END)
	{
		// S9000 only
		pDeviceStatus->SetReceiptNearEnd(true);
	}
	else
	{
		pDeviceStatus->SetReceiptNearEnd(false);
	}

	// ASB_EJECT_SENSOR_NO_PAPER
	if((dwStatus & ASB_EJECT_SENSOR_NO_PAPER) == ASB_EJECT_SENSOR_NO_PAPER)
	{
		pDeviceStatus->SetEjectSensorPaper(true);
	}
	else
	{
		pDeviceStatus->SetEjectSensorPaper(false);
	}

	// ASB_RECEIPT_END
	if((dwStatus & ASB_RECEIPT_END) == ASB_RECEIPT_END)
	{
		// S9000 only
		pDeviceStatus->SetReceiptEnd(true);
	}
	else
	{
		pDeviceStatus->SetReceiptEnd(false);
	}

	// ASB_SLIP_PAPER_SIZE
	if((dwStatus & ASB_SLIP_PAPER_SIZE) == ASB_SLIP_PAPER_SIZE)
	{
		pDeviceStatus->SetSlipPaperSize(true);
	}
	else
	{
		pDeviceStatus->SetSlipPaperSize(false);
	}

	// ASB_ASF_PAPER
	if((dwStatus & ASB_ASF_PAPER) == ASB_ASF_PAPER)
	{
		pDeviceStatus->SetAsfPaper(true);
	}
	else
	{
		pDeviceStatus->SetAsfPaper(false);
	}

	// ASB_WAIT_INSERT
	if((dwStatus & ASB_WAIT_INSERT) == ASB_WAIT_INSERT)
	{
		pDeviceStatus->SetWaitInsert(true);
	}
	else
	{
		pDeviceStatus->SetWaitInsert(false);
	}

	// ASB_MAIN_POCKET_NEAR_FULL
	if((dwStatus & ASB_MAIN_POCKET_NEAR_FULL) == ASB_MAIN_POCKET_NEAR_FULL)
	{
		pDeviceStatus->SetMainPocketNearFull(true);
	}
	else
	{
		pDeviceStatus->SetMainPocketNearFull(false);
	}

	// ASB_SUB_POCKET_NEAR_FULL
	if((dwStatus & ASB_SUB_POCKET_NEAR_FULL) == ASB_SUB_POCKET_NEAR_FULL)
	{
		pDeviceStatus->SetSubPocketNearFull(true);
	}
	else
	{
		pDeviceStatus->SetSubPocketNearFull(false);
	}

	return nResult;
}

// Get ink status
int CInfo::GetInkStatusFunction(CInkStatus *pInkStatus)
{
	int		nResult		= SUCCESS;
	WORD	wStatus	= 0;

	if(pInkStatus == NULL)
	{
		return -1;
	}

	nResult = BiGetInkStatus(m_pCProperty->GetHandle(), &wStatus);
	ASSERT( nResult == SUCCESS );
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	if((wStatus & INK_ASB_NEAR_END) == INK_ASB_NEAR_END)
	{
		pInkStatus->SetInkNearEnd(true);
	}
	else
	{
		pInkStatus->SetInkNearEnd(false);
	}

	if((wStatus & INK_ASB_END) == INK_ASB_END)
	{
		pInkStatus->SetInkEnd(true);
	}
	else
	{
		pInkStatus->SetInkEnd(false);
	}

	if((wStatus & INK_ASB_NO_CARTRIDGE) == INK_ASB_NO_CARTRIDGE)
	{
		pInkStatus->SetInkNoCartridge(true);
	}
	else
	{
		pInkStatus->SetInkNoCartridge(false);
	}

	if((wStatus & INK_ASB_CLEANING) == INK_ASB_CLEANING)
	{
		pInkStatus->SetInkCleaning(true);
	}
	else
	{
		pInkStatus->SetInkCleaning(false);
	}

	return nResult;
}

// Get device information
int CInfo::GetDeviceInfoFunction(CDeviceInfo *pDeviceInfo)
{
	int		nResult								= SUCCESS;
	BYTE	DeviceSize							= MAX_DEVICE_INFO_SIZE;
	BYTE	DeviceInfo[MAX_DEVICE_INFO_SIZE]	= {0};

	if(pDeviceInfo == NULL)
	{
		return -1;
	}

	// Get device name
	nResult = BiGetPrnCapability(m_pCProperty->GetHandle(), INFO_DEVICE_NAME, &DeviceSize, DeviceInfo);
	ASSERT( nResult == SUCCESS );
	if(nResult == SUCCESS)
	{
		pDeviceInfo->SetDeviceName(DeviceInfo);
	}
	DeviceSize = MAX_DEVICE_INFO_SIZE;
	::ZeroMemory(DeviceInfo, sizeof(BYTE) * DeviceSize);

	// Get manufacturer
	nResult = BiGetPrnCapability(m_pCProperty->GetHandle(), INFO_MANUFACTURE, &DeviceSize, DeviceInfo);
	ASSERT( nResult == SUCCESS );
	if(nResult == SUCCESS)
	{
		pDeviceInfo->SetManufacture(DeviceInfo);
	}
	DeviceSize = MAX_DEVICE_INFO_SIZE;
	::ZeroMemory(DeviceInfo, sizeof(BYTE) * DeviceSize);

	// Get firmware version
	nResult = BiGetPrnCapability(m_pCProperty->GetHandle(), INFO_FIRM_VERSION, &DeviceSize, DeviceInfo);
	ASSERT( nResult == SUCCESS );
	if(nResult == SUCCESS)
	{
		pDeviceInfo->SetFirmVersion(DeviceInfo);
	}
	DeviceSize = MAX_DEVICE_INFO_SIZE;
	::ZeroMemory(DeviceInfo, sizeof(BYTE) * DeviceSize);

	// Get serial number
	nResult = BiGetPrnCapability(m_pCProperty->GetHandle(), INFO_SERIAL_NUMBER, &DeviceSize, DeviceInfo);
	ASSERT( nResult == SUCCESS );
	if(nResult == SUCCESS)
	{
		pDeviceInfo->SetSerialNumber(DeviceInfo);
	}
	DeviceSize = MAX_DEVICE_INFO_SIZE;
	::ZeroMemory(DeviceInfo, sizeof(BYTE) * DeviceSize);

	// Get number of pockets and document processing speed
	nResult = BiGetPrnCapability(m_pCProperty->GetHandle(), INFO_SPEED_POCKET, &DeviceSize, DeviceInfo);
	ASSERT( nResult == SUCCESS );
	if(nResult == SUCCESS)
	{
		pDeviceInfo->SetTypeIdB(DeviceInfo);
	}
	::ZeroMemory(DeviceInfo, sizeof(BYTE) * DeviceSize);

	return nResult;
}

// Get maintenance counter
int CInfo::GetMaintenanceCounterFunction(CMaintenanceCounter *pMaintenanceCounter)
{
	int  nResult	= SUCCESS;
	DWORD dwCounter	= 0;

	if(pMaintenanceCounter == NULL)
	{
		return -1;
	}

	// Lines fed (Roll paper)
	nResult = BiGetCounter(m_pCProperty->GetHandle(), COUNTER_LINE_FEEDS, &dwCounter);
	ASSERT( nResult == SUCCESS || nResult == ERR_PARAM );
	if(nResult == SUCCESS)
	{
		// S9000
		pMaintenanceCounter->SetLineFeeds(dwCounter);
	}
	else if (nResult == ERR_PARAM)
	{
		// S2000
		pMaintenanceCounter->SetLineFeeds(static_cast<DWORD>(-1));
	}
	else
	{
		return nResult;
	}

	// Lines fed (Thermal head)
	nResult = BiGetCounter(m_pCProperty->GetHandle(), COUNTER_HEAD_LINE_FEEDS, &dwCounter);
	ASSERT( nResult == SUCCESS || nResult == ERR_PARAM );
	if(nResult == SUCCESS)
	{
		// S9000
		pMaintenanceCounter->SetHeadLineFeeds(dwCounter);
	}
	else if (nResult == ERR_PARAM)
	{
		// S2000
		pMaintenanceCounter->SetHeadLineFeeds(static_cast<DWORD>(-1));
	}
	else
	{
		return nResult;
	}

	// Head shot A
	nResult = BiGetCounter(m_pCProperty->GetHandle(), COUNTER_HEAD_SHOT_A, &dwCounter);
	ASSERT( nResult == SUCCESS );
	if(nResult == SUCCESS)
	{
		pMaintenanceCounter->SetHeadShotA(dwCounter);
	}
	else
	{
		return nResult;
	}

	// Head shot B
	nResult = BiGetCounter(m_pCProperty->GetHandle(), COUNTER_HEAD_SHOT_B, &dwCounter);
	ASSERT( nResult == SUCCESS );
	if(nResult == SUCCESS)
	{
		pMaintenanceCounter->SetHeadShotB(dwCounter);
	}
	else
	{
		return nResult;
	}

	// Thermal head energization
	nResult = BiGetCounter(m_pCProperty->GetHandle(), COUNTER_HEAD_ENERGIZATION, &dwCounter);
	ASSERT( nResult == SUCCESS || nResult == ERR_PARAM );
	if(nResult == SUCCESS)
	{
		// S9000
		pMaintenanceCounter->SetHeadEnergization(dwCounter);
	}
	else if (nResult == ERR_PARAM)
	{
		// S2000
		pMaintenanceCounter->SetHeadEnergization(static_cast<DWORD>(-1));
	}
	else
	{
		return nResult;
	}

	// Pump operations
	nResult = BiGetCounter(m_pCProperty->GetHandle(), COUNTER_PUMP_OPERATION, &dwCounter);
	ASSERT( nResult == SUCCESS );
	if(nResult == SUCCESS)
	{
		pMaintenanceCounter->SetPumpOperation(dwCounter);
	}
	else
	{
		return nResult;
	}

	// Auto cutter drive
	nResult = BiGetCounter(m_pCProperty->GetHandle(), COUNTER_AUTO_CUTTER, &dwCounter);
	ASSERT( nResult == SUCCESS || nResult == ERR_PARAM );
	if(nResult == SUCCESS)
	{
		// S9000
		pMaintenanceCounter->SetAutoCutter(dwCounter);
	}
	else if (nResult == ERR_PARAM)
	{
		// S2000
		pMaintenanceCounter->SetAutoCutter(static_cast<DWORD>(-1));
	}
	else
	{
		return nResult;
	}

	// Check paper fed
	nResult = BiGetCounter(m_pCProperty->GetHandle(), COUNTER_ASF_SENDING_OFF, &dwCounter);
	ASSERT( nResult == SUCCESS );
	if(nResult == SUCCESS)
	{
		pMaintenanceCounter->SetAsfSendingOff(dwCounter);
	}
	else
	{
		return nResult;
	}

	// Check paper scanned
	nResult = BiGetCounter(m_pCProperty->GetHandle(), COUNTER_SCANNED_CHECK, &dwCounter);
	ASSERT( nResult == SUCCESS );
	if(nResult == SUCCESS)
	{
		pMaintenanceCounter->SetImageScannedCheckPaper(dwCounter);
	}
	else
	{
		return nResult;
	}

	// Card scanned
	nResult = BiGetCounter(m_pCProperty->GetHandle(), COUNTER_SCANNED_CARD, &dwCounter);
	ASSERT( nResult == SUCCESS );
	if(nResult == SUCCESS)
	{
		pMaintenanceCounter->SetImageScannedCard(dwCounter);
	}
	else
	{
		return nResult;
	}

	// MICR reads
	nResult = BiGetCounter(m_pCProperty->GetHandle(), COUNTER_MICR_READS, &dwCounter);
	ASSERT( nResult == SUCCESS );
	if(nResult == SUCCESS)
	{
		pMaintenanceCounter->SetMicrReads(dwCounter);
	}
	else
	{
		return nResult;
	}

	// Pocket switch
	nResult = BiGetCounter(m_pCProperty->GetHandle(), COUNTER_POCKET_SELECT, &dwCounter);
	ASSERT( nResult == SUCCESS );
	if(nResult == SUCCESS)
	{
		pMaintenanceCounter->SetPocketSelect(dwCounter);
	}
	else
	{
		return nResult;
	}

	// Hopper open/close
	nResult = BiGetCounter(m_pCProperty->GetHandle(), COUNTER_HOPPER, &dwCounter);
	ASSERT( nResult == SUCCESS );
	if(nResult == SUCCESS)
	{
		pMaintenanceCounter->SetHopper(dwCounter);
	}
	else
	{
		return nResult;
	}

	// Duration of product operation
	nResult = BiGetCounter(m_pCProperty->GetHandle(), COUNTER_DEVICE_OPERATION_TIME, &dwCounter);
	ASSERT( nResult == SUCCESS );
	if(nResult == SUCCESS)
	{
		pMaintenanceCounter->SetDeviceOperationTime(dwCounter);
	}
	else
	{
		return nResult;
	}

	return nResult;
}

// Get functions of the API
void CInfo::GetAPIProcAddress(void)
{
	HINSTANCE hLibrary = m_pCProperty->GetLibrary();

	BiGetCounter		= (DLL_BiGetCounter)		GetProcAddress(hLibrary, "BiGetCounter");
	BiGetStatus			= (DLL_BiGetStatus)			GetProcAddress(hLibrary, "BiGetStatus");
	BiGetInkStatus		= (DLL_BiGetInkStatus)		GetProcAddress(hLibrary, "BiGetInkStatus");
	BiGetPrnCapability	= (DLL_BiGetPrnCapability)	GetProcAddress(hLibrary, "BiGetPrnCapability");
}
