VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "App"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Dim m_CCProperty As Property_1
Dim m_CCScan As Scan
Dim m_CCMicr As Micr
Dim m_CCImage_01 As Image_01
Dim m_CCEndorse As Endorse
Dim m_CCProcess As Process
Dim m_lTransactionNumber As Long
Dim m_nMainStatus As Integer
Dim m_nSubStatus As Integer
Dim m_byExecType As Byte

Private Const EXEC_SCAN_CHECK As Byte = 0
Private Const EXEC_SCAN_CARD  As Byte = 1

Public Event GetImage()
Public Event GetMicr()
Public Event GetError(ByVal nError As Integer)
'//Step 4
Public Event SetPhysicalEndorseStart(ByVal TransactionNumber As Long)
Public Event SetElectronicEndorseStart()
Public Event SetEndorseEnd()

Private Sub Class_Initialize()

    Set m_CCProperty = New Property_1
    Set m_CCScan = New Scan
    Set m_CCMicr = New Micr
    Set m_CCImage_01 = New Image_01
    Set m_CCEndorse = New Endorse
    Set m_CCProcess = New Process
    m_byExecType = EXEC_SCAN_CHECK

End Sub


Private Sub Class_Terminate()

    Call ExitDevice

End Sub

'// Connect to the device
Public Function InitDevice() As Long

    Dim lHandle As Long
    Dim lResult As Long
    
    lHandle = SUCCESS
    lResult = SUCCESS
    
On Error GoTo LoadDllErr

    If (m_CCProperty.GetHandle() <= 0) Then
    
        '// Connect to the device
        lHandle = BiOpenMonPrinter(TYPE_PRINTER, "TM-S9000U,TM-S2000U")
        If (lHandle <= 0) Then
        
            InitDevice = lHandle
            Exit Function
            
        End If
        
        m_CCProperty.SetHandle (lHandle)
    
    End If

    '// Register callback functions for notification of the reading status
    lResult = BiSCNMICRSetStatusBackWnd(m_CCProperty.GetHandle(), m_CCProperty.GetScanStatusWnd, m_lTransactionNumber, m_nMainStatus, m_nSubStatus)
    If Not (lResult = SUCCESS) Then
    
        InitDevice = lResult
        Exit Function
        
    End If

    '// Register callback functions for notification of the endorsement data acceptance
    lResult = BiStartEndorsementSetStatusBackWnd(m_CCProperty.GetHandle(), m_CCProperty.GetEndorseStartWnd, m_lTransactionNumber)
    If Not (lResult = SUCCESS) Then
    
        InitDevice = lResult
        Exit Function
    
    End If

    '// Register callback functions for notification of the endorsement data close
    lResult = BiEndEndorsementSetStatusBackWnd(m_CCProperty.GetHandle(), m_CCProperty.GetEndorseEndWnd, m_lTransactionNumber)
    If Not (lResult = SUCCESS) Then
    
        InitDevice = lResult
        Exit Function
        
    End If
    
    InitDevice = lResult
    Exit Function
    
LoadDllErr:
    
    InitDevice = -1
    
End Function

'// Post process
Public Function ExitDevice() As Long

    Dim lResult As Long
    lResult = SUCCESS

    If (m_CCProperty.GetHandle() > 0) Then
    
        '// Cancel the reading status callback
        lResult = BiSCNMICRCancelStatusBack(m_CCProperty.GetHandle())
        If Not (lResult = SUCCESS) Then
        
            ExitDevice = lResult
            Exit Function
        
        End If

        '// Step4
        '// Cancel the endorsement data acceptance callback
        lResult = BiStartEndorsementCancelStatusBack(m_CCProperty.GetHandle())
        If Not (lResult = SUCCESS) Then
        
            ExitDevice = lResult
            Exit Function
        
        End If

        '// Cancel the endorsement data close callback
        lResult = BiEndEndorsementCancelStatusBack(m_CCProperty.GetHandle())
        If Not (lResult = SUCCESS) Then
        
            ExitDevice = lResult
            Exit Function
        
        End If

        '// Disconnect the device
        lResult = BiCloseMonPrinter(m_CCProperty.GetHandle())
        If Not (lResult = SUCCESS) Then
        
            ExitDevice = lResult
            Exit Function
        
        End If
        
        m_CCProperty.SetHandle (0)
    
    End If

    ExitDevice = lResult

End Function

Public Sub SetProperty()
    
    Call m_CCScan.SetProperty(m_CCProperty)
    Call m_CCMicr.SetProperty(m_CCProperty)
    Call m_CCImage_01.SetProperty(m_CCProperty)
    Call m_CCProcess.SetProperty(m_CCProperty)
    '// Step4
    Call m_CCEndorse.SetProperty(m_CCProperty)

End Sub

Friend Sub SetCallBackButtonWnd(ByRef psCallBackButton As CALLBACKBUTTON)

    Call m_CCProperty.SetScanStatusWnd(psCallBackButton.lScanStatusWnd)
    Call m_CCProperty.SetEndorseStartWnd(psCallBackButton.lEndorseStartWnd)
    Call m_CCProperty.SetEndorseEndWnd(psCallBackButton.lEndorseEndWnd)

End Sub

'// Set MICR settings
Public Sub SetMicrParam(ByRef pCCMicrParam As MicrParam)

    Call m_CCProperty.SetFont(pCCMicrParam.GetFont())
    Call m_CCProperty.SetParsing(pCCMicrParam.GetParsing())
    Call m_CCProperty.SetClearSpace(pCCMicrParam.GetClearSpace())

End Sub

'// Get MICR settings
Public Sub GetMicrParam(ByRef pCCMicrParam As MicrParam)

    Call pCCMicrParam.SetFont(m_CCProperty.GetFont())
    Call pCCMicrParam.SetParsing(m_CCProperty.GetParsing())
    Call pCCMicrParam.SetClearSpace(m_CCProperty.GetClearSpace())

End Sub

'// Set scanning parameters
Public Sub SetScanParam(ByRef pCCScanParam As ScanParam)

    Call m_CCProperty.SetScanMedia(pCCScanParam.GetScanMedia())
    Call m_CCProperty.SetImageChannel(pCCScanParam.GetImageChannel())
    Call m_CCProperty.SetRGBColorDepth(pCCScanParam.GetRGBColorDepth())
    Call m_CCProperty.SetIRColorDepth(pCCScanParam.GetIRColorDepth())
    Call m_CCProperty.SetResolution(pCCScanParam.GetResolution())

End Sub

'// Get scanning parameters
Public Sub GetScanParam(ByRef pCCScanParam As ScanParam)

    Call pCCScanParam.SetScanMedia(m_CCProperty.GetScanMedia())
    Call pCCScanParam.SetImageChannel(m_CCProperty.GetImageChannel())
    Call pCCScanParam.SetRGBColorDepth(m_CCProperty.GetRGBColorDepth())
    Call pCCScanParam.SetIRColorDepth(m_CCProperty.GetIRColorDepth())
    Call pCCScanParam.SetResolution(m_CCProperty.GetResolution())

End Sub

'// Check scanning process
Public Function ScanCheck() As Long

    Dim lResult As Long
    lResult = SUCCESS

    m_byExecType = EXEC_SCAN_CHECK

    '// Set MF_BASE01 structure
    lResult = m_CCScan.SetBaseSetting()
    If Not (lResult = SUCCESS) Then
    
        ScanCheck = lResult
        Exit Function
    
    End If

    '// Set scanning parameters for check scanning
    lResult = m_CCScan.SetScanSetting()
    If Not (lResult = SUCCESS) Then
    
        ScanCheck = lResult
        Exit Function
    
    End If

    '// Set MICR parameters
    lResult = m_CCMicr.SetMicrSetting()
    If Not (lResult = SUCCESS) Then
    
        ScanCheck = lResult
        Exit Function
    
    End If

    '// Set MF_PROCESS01 structure
    lResult = m_CCProcess.SetProcessSetting()
    If Not (lResult = SUCCESS) Then
    
        ScanCheck = lResult
        Exit Function
    
    End If
    
    '// Set endorsement type
    lResult = m_CCEndorse.SetEndorseStation
    If Not (lResult = SUCCESS) Then
    
        ScanCheck = lResult
        Exit Function
    
    End If
    
    '// Start check scanning
    lResult = m_CCScan.ScanFunction()
    If Not (lResult = SUCCESS) Then
    
        ScanCheck = lResult
        Exit Function
    
    End If

    ScanCheck = lResult

End Function

'// Card scanning process
Public Function ScanCard() As Long

    Dim lResult As Long
    nResul = SUCCESS

    m_byExecType = EXEC_SCAN_CARD
    
    '// Clear MF_MICR strucuture
    lResult = m_CCMicr.ClearMicrSetting()
    If Not (lResult = SUCCESS) Then
    
        ScanCard = lResult
        Exit Function
        
    End If

    '// Set MF_BASE01 strucuture
    lResult = m_CCScan.SetBaseSetting()
    If Not (lResult = SUCCESS) Then
    
        ScanCard = lResult
        Exit Function
    
    End If

    '// Set card scanning conditions
    lResult = m_CCScan.SetScanSetting()
    If Not (lResult = SUCCESS) Then
    
        ScanCard = lResult
        Exit Function
    
    End If

    '// Start card scanning
    lResult = m_CCScan.ScanFunction()
    If Not (lResult = SUCCESS) Then
    
        ScanCard = lResult
        Exit Function
    
    End If

    ScanCard = lResult

End Function

'// Get MICR data
Friend Function GetMicr(ByRef pCCMicrResult As MicrResult) As Long

    GetMicr = m_CCMicr.GetMicr(pCCMicrResult)

End Function

'// Get image data
Public Function GetScanImage(ByRef pCCImageResult As ImageResult) As Long

    GetScanImage = m_CCImage_01.GetScanImage(pCCImageResult)

End Function

'// Error recovery
Public Function CancelError() As Long

    CancelError = BiCancelError(m_CCProperty.GetHandle())
    
End Function

'// Get device status
Public Function GetDeviceStatus(ByRef plStatus As Long) As Long

    GetDeviceStatus = BiGetStatus(m_CCProperty.GetHandle(), plStatus)

End Function

'// Cancel scanning
Public Function CancelScan() As Long

    CancelScan = m_CCScan.CancelScan()

End Function

'// MICR head cleaning
Public Function CleaningMicr() As Long

    CleaningMicr = m_CCMicr.CleaningMicr()
    
End Function

'// Callback function for notifying scanning status
Public Sub ScanStatus()

    Dim lResult As Long
    Dim nSubStatus As Integer
    Dim lScanTransactionNumber As Long
    Dim dDpmResult As Double
    
    lResult = SUCCESS

    If Not (m_nSubStatus = SUCCESS) Then
    
        RaiseEvent GetError(m_nSubStatus)
    
    End If

    If (m_nMainStatus = MF_DATARECEIVE_DONE) Then
    
        m_CCProperty.SetTransactionNumber (m_lTransactionNumber)

        If (m_CCProperty.GetEndorseType() = MF_ST_E_ENDORSEMENT) Then
        
            If (m_CCProperty.GetPrintText() Or m_CCProperty.GetPrintImage()) Then
            
                '// Notify callback for endorsement
                 RaiseEvent SetElectronicEndorseStart
            
            End If
        
        End If

        If (m_byExecType = EXEC_SCAN_CHECK) Then
        
            '// Notify callback for MICR data
            RaiseEvent GetMicr
        
        End If
        
        '// Notify callback for image data
        RaiseEvent GetImage
    
    End If

End Sub

''////////////////
''//// Step 4
''////////////////

'// Set endorsement data
Public Sub SetEndorseParam(ByRef pCCEndorseParam As EndorseParam)

    Call m_CCProperty.SetEndorseType(pCCEndorseParam.GetEndorseType())
    Call m_CCProperty.SetPrintText(pCCEndorseParam.GetPrintText())
    Call m_CCProperty.SetPrintImage(pCCEndorseParam.GetPrintImage())

End Sub

'// Get endorsement data
Public Sub GetEndorseParam(ByRef pCCEndorseParam As EndorseParam)

    Call pCCEndorseParam.SetEndorseType(m_CCProperty.GetEndorseType())
    Call pCCEndorseParam.SetPrintText(m_CCProperty.GetPrintText())
    Call pCCEndorseParam.SetPrintImage(m_CCProperty.GetPrintImage())

End Sub

'// Set processing mode options
Public Sub SetProcessParam(ByRef pCCProcessParam As ProcessParam)
    
    Call m_CCProperty.SetPrnDataUnreceiveCancel(pCCProcessParam.GetPrnDataUnreceiveCancel())
    
End Sub

'// Get processing mode options
Public Sub GetProcessParam(ByRef pCCProcessParam As ProcessParam)
    
    Call pCCProcessParam.SetPrnDataUnreceiveCancel(m_CCProperty.GetPrnDataUnreceiveCancel())
    
End Sub

'// Reading endorsement data file
Public Function LoadEndorseFile()

    LoadEndorseFile = m_CCEndorse.LoadEndorseFile()
    
End Function

'// Set Physical Endorsement data
Public Function PhysicalEndorseFunction(ByVal lTransactionNumber As Long) As Long

    PhysicalEndorseFunction = m_CCEndorse.PhysicalEndorseFunction(lTransactionNumber)

End Function

'// Set Electronic Endorsement data
Public Function ElectronicEndorseFunction() As Long

    ElectronicEndorseFunction = m_CCEndorse.ElectronicEndorseFunction()

End Function

'// Callback function for notifying endorsement data acceptance
Public Sub StartEndorsement()


    If (m_CCProperty.GetEndorseType() = MF_ST_PHYSICAL_ENDORSEMENT) Then
    
        If (m_CCProperty.GetPrintText() Or m_CCProperty.GetPrintImage()) Then
        
            '// otifying endorsement data acceptance
            RaiseEvent SetPhysicalEndorseStart(m_lTransactionNumber)
        
        End If
    
    End If

End Sub

'// Callback function for notifying endorsement data close

Public Sub EndEndorsement()

    '/* After this callback is executed, all endorsement data is discarded */

End Sub

