VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "App"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Dim m_CCProperty As Property_1
Dim m_CCScan As Scan
Dim m_CCMicr As Micr
Dim m_CCProcess As Process
Dim m_CCImage_01 As Image_01
Dim m_lTransactionNumber As Long
Dim m_nMainStatus As Integer
Dim m_nSubStatus As Integer
Dim m_byExecType As Byte
'//Step 5
Dim m_CCPrint As Print_01

Private Const EXEC_SCAN_CHECK As Byte = 0
Private Const EXEC_SCAN_CARD  As Byte = 1
Private Const EXEC_PRINT_CAHSHERSCHECK As Byte = 2
Private Const EXEC_PRINT_RECEIPT As Byte = 3



Public Event GetImage()
Public Event GetMicr()
Public Event GetError(ByVal nError As Integer)
'//Step 5
Public Event SetCashierscheck()
Public Event SetReceipt()

Private Sub Class_Initialize()

    Set m_CCProperty = New Property_1
    Set m_CCScan = New Scan
    Set m_CCMicr = New Micr
    Set m_CCImage_01 = New Image_01
    Set m_CCProcess = New Process
    m_byExecType = EXEC_SCAN_CHECK
    '//Step 5
    Set m_CCPrint = New Print_01

End Sub


Private Sub Class_Terminate()

    Call ExitDevice

End Sub

'// Initialize
Public Function InitDevice() As Long

    Dim lHandle As Long
    Dim lResult As Long
    
    lHandle = SUCCESS
    lResult = SUCCESS
    
On Error GoTo LoadDllErr

    If (m_CCProperty.GetHandle() <= 0) Then
    
        '// Connect to the device
        lHandle = BiOpenMonPrinter(TYPE_PRINTER, "TM-S9000U,TM-S2000U")
        If (lHandle <= 0) Then
        
            InitDevice = lHandle
            Exit Function
            
        End If
        
        m_CCProperty.SetHandle (lHandle)
    
    End If

    '// Register callback functions for notification of the reading status
    lResult = BiSCNMICRSetStatusBackWnd(m_CCProperty.GetHandle(), m_CCProperty.GetScanStatusWnd, m_lTransactionNumber, m_nMainStatus, m_nSubStatus)
    If Not (lResult = SUCCESS) Then
    
        InitDevice = lResult
        Exit Function
        
    End If

    '// Register callback functions for notification of the endorsement data acceptance
    lResult = BiStartEndorsementSetStatusBackWnd(m_CCProperty.GetHandle(), m_CCProperty.GetEndorseStartWnd, m_lTransactionNumber)
    If Not (lResult = SUCCESS) Then
    
        InitDevice = lResult
        Exit Function
    
    End If

    '// Register callback functions for notification of the endorsement data close
    lResult = BiEndEndorsementSetStatusBackWnd(m_CCProperty.GetHandle(), m_CCProperty.GetEndorseEndWnd, m_lTransactionNumber)
    If Not (lResult = SUCCESS) Then
    
        InitDevice = lResult
        Exit Function
        
    End If
    
    InitDevice = lResult
    Exit Function
    
LoadDllErr:
    
    InitDevice = -1
    
End Function

'// Post process
Public Function ExitDevice() As Long

    Dim lResult As Long
    lResult = SUCCESS

    If (m_CCProperty.GetHandle() > 0) Then
    
        '// Cancel the reading status callback
        lResult = BiSCNMICRCancelStatusBack(m_CCProperty.GetHandle())
        If Not (lResult = SUCCESS) Then
        
            ExitDevice = lResult
            Exit Function
        
        End If

        '// Step5
        '// Cancel the endorsement data acceptance callback
        lResult = BiStartEndorsementCancelStatusBack(m_CCProperty.GetHandle())
        If Not (lResult = SUCCESS) Then
        
            ExitDevice = lResult
            Exit Function
        
        End If

        '// Cancel the endorsement data close callback
        lResult = BiEndEndorsementCancelStatusBack(m_CCProperty.GetHandle())
        If Not (lResult = SUCCESS) Then
        
            ExitDevice = lResult
            Exit Function
        
        End If

        '// Disconnect from device
        lResult = BiCloseMonPrinter(m_CCProperty.GetHandle())
        If Not (lResult = SUCCESS) Then
        
            ExitDevice = lResult
            Exit Function
        
        End If
        
        m_CCProperty.SetHandle (0)
    
    End If

    ExitDevice = lResult

End Function

Public Sub SetProperty()
    
    Call m_CCScan.SetProperty(m_CCProperty)
    Call m_CCMicr.SetProperty(m_CCProperty)
    Call m_CCPrint.SetProperty(m_CCProperty)
    Call m_CCImage_01.SetProperty(m_CCProperty)
    Call m_CCProcess.SetProperty(m_CCProperty)

End Sub

Friend Sub SetCallBackButtonWnd(ByRef psCallBackButton As CALLBACKBUTTON)

    Call m_CCProperty.SetScanStatusWnd(psCallBackButton.lScanStatusWnd)
    Call m_CCProperty.SetEndorseStartWnd(psCallBackButton.lEndorseStartWnd)
    Call m_CCProperty.SetEndorseEndWnd(psCallBackButton.lEndorseEndWnd)
    
End Sub

'// Set MICR settings
Public Sub SetMicrParam(ByRef pCCMicrParam As MicrParam)

    Call m_CCProperty.SetFont(pCCMicrParam.GetFont())
    Call m_CCProperty.SetParsing(pCCMicrParam.GetParsing())
    Call m_CCProperty.SetClearSpace(pCCMicrParam.GetClearSpace())

End Sub

'// Get MICR settings
Public Sub GetMicrParam(ByRef pCCMicrParam As MicrParam)

    Call pCCMicrParam.SetFont(m_CCProperty.GetFont())
    Call pCCMicrParam.SetParsing(m_CCProperty.GetParsing())
    Call pCCMicrParam.SetClearSpace(m_CCProperty.GetClearSpace())

End Sub

'// Set scanning parameters
Public Sub SetScanParam(ByRef pCCScanParam As ScanParam)

    Call m_CCProperty.SetScanMedia(pCCScanParam.GetScanMedia())
    Call m_CCProperty.SetImageChannel(pCCScanParam.GetImageChannel())
    Call m_CCProperty.SetRGBColorDepth(pCCScanParam.GetRGBColorDepth())
    Call m_CCProperty.SetIRColorDepth(pCCScanParam.GetIRColorDepth())
    Call m_CCProperty.SetResolution(pCCScanParam.GetResolution())

End Sub

'// Get scanning parameters
Public Sub GetScanParam(ByRef pCCScanParam As ScanParam)

    Call pCCScanParam.SetScanMedia(m_CCProperty.GetScanMedia())
    Call pCCScanParam.SetImageChannel(m_CCProperty.GetImageChannel())
    Call pCCScanParam.SetRGBColorDepth(m_CCProperty.GetRGBColorDepth())
    Call pCCScanParam.SetIRColorDepth(m_CCProperty.GetIRColorDepth())
    Call pCCScanParam.SetResolution(m_CCProperty.GetResolution())

End Sub

'// Check scanning process
Public Function ScanCheck() As Long

    Dim lResult As Long
    lResult = SUCCESS

    m_byExecType = EXEC_SCAN_CHECK

    '// Set MF_BASE01 structure
    lResult = m_CCScan.SetBaseSetting()
    If Not (lResult = SUCCESS) Then
    
        ScanCheck = lResult
        Exit Function
    
    End If

    '// Set scanning parameters for check scanning
    lResult = m_CCScan.SetScanSetting()
    If Not (lResult = SUCCESS) Then
    
        ScanCheck = lResult
        Exit Function
    
    End If

    '// Set MICR parameters
    lResult = m_CCMicr.SetMicrSetting()
    If Not (lResult = SUCCESS) Then
    
        ScanCheck = lResult
        Exit Function
    
    End If

    '// Set MF_PROCESS01 structure
    lResult = m_CCProcess.SetProcessSetting()
    If Not (lResult = SUCCESS) Then
    
        ScanCheck = lResult
        Exit Function
    
    End If

    '// Start check scanning
    lResult = m_CCScan.ScanFunction()
    If Not (lResult = SUCCESS) Then
    
        ScanCheck = lResult
        Exit Function
    
    End If

    ScanCheck = lResult

End Function

'// Card scanning process
Public Function ScanCard() As Long

    Dim lResult As Long
    nResul = SUCCESS

    m_byExecType = EXEC_SCAN_CARD
    
    '// Clear MF_MICR strucuture
    lResult = m_CCMicr.ClearMicrSetting()
    If Not (lResult = SUCCESS) Then
    
        ScanCard = lResult
        Exit Function
        
    End If

    '// Set MF_BASE01 strucuture
    lResult = m_CCScan.SetBaseSetting()
    If Not (lResult = SUCCESS) Then
    
        ScanCard = lResult
        Exit Function
    
    End If

    '// Set card scanning conditions
    lResult = m_CCScan.SetScanSetting()
    If Not (lResult = SUCCESS) Then
    
        ScanCard = lResult
        Exit Function
    
    End If

    '// Start card scanning
    lResult = m_CCScan.ScanFunction()
    If Not (lResult = SUCCESS) Then
    
        ScanCard = lResult
        Exit Function
    
    End If

    ScanCard = lResult

End Function

'// Get MICR data
Friend Function GetMicr(ByRef pCCMicrResult As MicrResult) As Long

    GetMicr = m_CCMicr.GetMicr(pCCMicrResult)

End Function

'// Get image data
Public Function GetScanImage(ByRef pCCImageResult As ImageResult) As Long

    GetScanImage = m_CCImage_01.GetScanImage(pCCImageResult)

End Function

'// Get scanned image of printed cashiers check
Public Function GetCashiersCheckImage(ByRef pCCImageResult As ImageResult) As Long

    GetCashiersCheckImage = m_CCImage_01.GetCashiersCheckImage(pCCImageResult)
    
End Function

'// Error recovery
Public Function CancelError() As Long

    CancelError = BiCancelError(m_CCProperty.GetHandle())
    
End Function

'// Get device status
Public Function GetDeviceStatus(ByRef plStatus As Long) As Long

    GetDeviceStatus = BiGetStatus(m_CCProperty.GetHandle(), plStatus)

End Function

'// Cancel scanning
Public Function CancelScan() As Long

    CancelScan = m_CCScan.CancelScan()

End Function

'// MICR head cleaning
Public Function CleaningMicr() As Long

    CleaningMicr = m_CCMicr.CleaningMicr()
    
End Function

'// Callback function for notifying scanning status
Public Sub ScanStatus()

    Dim lResult As Long
    Dim nSubStatus As Integer
    Dim lScanTransactionNumber As Long
    Dim dDpmResult As Double
    
    lResult = SUCCESS

    If Not (m_nSubStatus = SUCCESS) Then
    
        RaiseEvent GetError(m_nSubStatus)
    
    End If

    If (m_nMainStatus = MF_DATARECEIVE_DONE) Then
    
        m_CCProperty.SetTransactionNumber (m_lTransactionNumber)

        If (m_byExecType = EXEC_SCAN_CHECK) Then
        
            '// Notify callback for MICR data
            RaiseEvent GetMicr
        
        End If
        
        '// Notify callback for image data
        RaiseEvent GetImage
    
    End If

End Sub


'////////////////
'//// Step 5
'////////////////

'// Set printing parameters
Public Sub SetPrintParam(ByRef pCCPrintParam As PrintParam)

    Call m_CCProperty.SetAfterScanning(pCCPrintParam.GetAfterScanning())
    Call m_CCProperty.SetPrintingNumber(pCCPrintParam.GetPrintingNumber())

End Sub

'// Get printing parameters
Public Sub GetPrintParam(ByRef pCCPrintParam As PrintParam)

    Call pCCPrintParam.SetAfterScanning(m_CCProperty.GetAfterScanning())
    Call pCCPrintParam.SetPrintingNumber(m_CCProperty.GetPrintingNumber())
    
End Sub

'// Get ink status
Public Function GetInkStatus(ByRef plStatus As Long) As Long

    GetInkStatus = BiGetInkStatus(m_CCProperty.GetHandle(), plStatus)

End Function


'// Callback function for notifying endorsement data acceptance
Public Function StartEndorsement() As Long

    Dim lResult As Long
    lResult = SUCCESS

    If (m_byExecType = EXEC_PRINT_CAHSHERSCHECK) Then
    
        RaiseEvent SetCashierscheck
    
    ElseIf (m_byExecType = EXEC_PRINT_RECEIPT) Then
        
        RaiseEvent SetReceipt
        
    End If
    
    StartEndorsement = lResult

End Function

'// Printing on roll paper
Public Function PrintRollpaper() As Long

	'// S9000 only
    Dim lResult As Long
    lResult = SUCCESS

    lResult = m_CCPrint.PrintRollpaper()

    PrintRollpaper = lResult

End Function

'// Printing on cut sheet paper
Public Function PrintReceipt() As Long

    Dim lResult As Long
    lResult = SUCCESS

    m_byExecType = EXEC_PRINT_RECEIPT

    lResult = m_CCPrint.PrintReceipt()

    PrintReceipt = lResult

End Function

'// Set printing data on cut sheet paper
Public Function PrintReceiptFunction() As Long

    Dim lResult As Long
    lResult = SUCCESS
    
    lResult = m_CCPrint.PrintReceiptFunction()
    
    PrintReceiptFunction = lResult

End Function

'// Printing cashiers check
Public Function PrintCashierscheck() As Long

    Dim lResult As Long
    Dim bScanning As Boolean
    
    lResult = SUCCESS
    bScanning = True

    m_byExecType = EXEC_PRINT_CAHSHERSCHECK

    lResult = m_CCPrint.SetCashierscheckPrintSetting()
    If Not (lResult = SUCCESS) Then
    
        PrintCashierscheck = lResult
        Exit Function
    
    End If

    lResult = m_CCPrint.SetCashierscheckBaseSetting()
    If Not (lResult = SUCCESS) Then
    
        PrintCashierscheck = lResult
        Exit Function
    
    End If

    bScanning = m_CCProperty.GetAfterScanning()
    If (bScanning = BI_PRINTCUTSHEET_SCAN) Then
    
        lResult = m_CCPrint.SetCashierscheckScanSetting()
        If Not (lResult = SUCCESS) Then
        
            PrintCashierscheck = lResult
            Exit Function
        
        End If
        
    End If

    lResult = m_CCPrint.PrintCashierscheck()
    If Not (lResult = SUCCESS) Then
    
        PrintCashierscheck = lResult
        Exit Function
    
    End If

    PrintCashierscheck = lResult

End Function

'// Set print data for cashiers check
Public Function PrintCashierscheckFunction() As Long

    Dim lResult As Long
    lResult = SUCCESS
    
    lResult = m_CCPrint.PrintCashierscheckFunction()
    
    PrintCashierscheckFunction = lResult

End Function

'// Check if the roll paper is supported as print station.
Public Function IsRollPaperSupported() As Boolean
    
    IsRollPaperSupported = m_CCPrint.IsRollPaperSupported()

End Function
