VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Micr"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Private m_pCProperty As Property_1
Private m_mfMicr01 As MF_MICR01

Private Sub Class_Initialize()

    If (m_pCProperty Is Nothing) Then
        Set m_pCProperty = New Property_1
    End If

End Sub

Public Sub SetProperty(ByRef pCProperty As Property_1)

    Set m_pCProperty = pCProperty

End Sub

'// Set MICR reading conditions
Public Function SetMicrSetting() As Long

    Dim lResult As Long
    Dim bParsing As Boolean
    Dim byClearSpaces As Byte
    
    lResult = SUCCESS
    bParsing = False
    byClearSpaces = CLEAR_SPACE_DISABLE
    
    lResult = FunctionContinuouslyMicr(m_pCProperty.GetHandle(), m_mfMicr01, MF_GET_MICR_DEFAULT)
    If Not (lResult = SUCCESS) Then
    
        SetMicrSetting = lResult
        Exit Function
    
    End If
    
    Call CopyMemory(m_mfMicr01.iSize(1), CLng(LenB(m_mfMicr01)), 4)
    Call CopyMemory(m_mfMicr01.iVersion(1), MF_MICR_VERSION01, 4)
    
    m_mfMicr01.bFont = m_pCProperty.GetFont()
    If (m_pCProperty.GetParsing()) Then
    
        Call CopyMemory(m_mfMicr01.blParsing(1), True, 4)
        
    Else
    
        Call CopyMemory(m_mfMicr01.blParsing(1), False, 4)
    
    End If

    lResult = FunctionContinuouslyMicr(m_pCProperty.GetHandle(), m_mfMicr01, MF_SET_MICR_PARAM)
    If Not (lResult = SUCCESS) Then
    
        SetMicrSetting = lResult
        Exit Function
    
    End If
    
    Call m_pCProperty.SetMfMicr(m_mfMicr01)

    If (m_pCProperty.GetClearSpace()) Then
    
        byClearSpaces = CLEAR_SPACE_ENABLE
    
    End If
    lResult = BiMICRClearSpaces(m_pCProperty.GetHandle(), byClearSpaces)

    SetMicrSetting = lResult

End Function

'// Get MICR data
Friend Function GetMicr(ByRef pCCMicrResult As MicrResult) As Long

    Dim lResult As Long
    Dim stMicr  As MF_MICR01
    
    lResult = SUCCESS

    m_mfMicr01 = m_pCProperty.GetMfMicr
    LSet stMicr = m_mfMicr01
    
    lResult = BiGetMicrText(m_pCProperty.GetHandle(), m_pCProperty.GetTransactionNumber(), stMicr)
    If Not (lResult = SUCCESS) Then
    
        GetMicr = lResult
        Exit Function
        
    End If
    
    LSet m_mfMicr01 = stMicr
        
    Call pCCMicrResult.SetTransactionNumber(m_pCProperty.GetTransactionNumber())
    Call pCCMicrResult.SetResult(m_mfMicr01.iRet)
    Call pCCMicrResult.SetStatus(m_mfMicr01.bStatus)
    Call pCCMicrResult.SetDetail(m_mfMicr01.bDetail)
    Call pCCMicrResult.SetMicrStr(m_mfMicr01.szMicrStr)
    Call pCCMicrResult.SetAccountNumber(m_mfMicr01.szAccountNumber)
    Call pCCMicrResult.SetAmount(m_mfMicr01.szAmount)
    Call pCCMicrResult.SetBankNumber(m_mfMicr01.szBankNumber)
    Call pCCMicrResult.SetSerialNumber(m_mfMicr01.szSerialNumber)
    Call pCCMicrResult.SetEPC(m_mfMicr01.szEPC)
    Call pCCMicrResult.SetTransitNumber(m_mfMicr01.szTransitNumber)
    Call pCCMicrResult.SetOnUSField(m_mfMicr01.szOnUSField)
    Call pCCMicrResult.SetAuxiliatyOnUSField(m_mfMicr01.szAuxiliatyOnUsField)
    
    Call m_pCProperty.SetMfMicr(m_mfMicr01)
    
    GetMicr = lResult

End Function

'// MICR head cleaning
Public Function CleaningMicr() As Long

    CleaningMicr = BiMICRCleaning(m_pCProperty.GetHandle())

End Function

Public Function ClearMicrSetting() As Long

    m_mfMicr01 = m_pCProperty.GetMfMicr()
    ClearMicrSetting = FunctionContinuouslyMicr(m_pCProperty.GetHandle(), m_mfMicr01, MF_CLEAR_MICR_PARAM)

End Function



