Imports System.Diagnostics
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms

Namespace TMS_Sample
	Public Partial Class ConfigureForm
		Inherits Form
		Private m_objConfigData As StructByStep = Nothing

		Public Sub New()
			InitializeComponent()

			m_objConfigData = New StructByStep()
		End Sub

		Private Sub ConfigureForm_Load(sender As Object, e As EventArgs)
			LoadResourceString()

			SetControlData()

			UpdateControls()
		End Sub

		Public Sub SetConfigData(objConfigData As StructByStep)
			m_objConfigData.Copy(objConfigData)
		End Sub

		Public Sub GetConfigData(ByRef objConfigData As StructByStep)
			If objConfigData IsNot Nothing Then
				objConfigData.Copy(m_objConfigData)
			End If
		End Sub

		Private Sub LoadResourceString()
			'''/////////////
			'''/ Step 2 ////
			'''/////////////

			btnOK.Text = ConstComStr.STR_CONFIGDLG_BUTTON_OK
			btnCancel.Text = ConstComStr.STR_CONFIGDLG_BUTTON_CANCEL

			stGroupScanning.Text = ConstComStr.STR_CONFIGDLG_GROUP_SCANNING
			stGroupScanningMedia.Text = ConstComStr.STR_CONFIGDLG_GROUP_SCANNINGMEDIA
			stGroupLightSource.Text = ConstComStr.STR_CONFIGDLG_GROUP_LIGHTSOURCE
			stGroupRGBColorDepth.Text = ConstComStr.STR_CONFIGDLG_GROUP_RGBCOLORDEPTH
			stGroupIRColorDepth.Text = ConstComStr.STR_CONFIGDLG_GROUP_IRCOLORDEPTH

			stResolution.Text = ConstComStr.STR_CONFIGDLG_STATIC_RESOLUTION

			btnRadioSMCheckPaper.Text = ConstComStr.STR_CONFIGDLG_RADIO_SM_CHECKPAPER
			btnRadioSMCard.Text = ConstComStr.STR_CONFIGDLG_RADIO_SM_CARD
			btnRadioICRGB.Text = ConstComStr.STR_CONFIGDLG_RADIO_IC_RGB
			btnRadioICIR.Text = ConstComStr.STR_CONFIGDLG_RADIO_IC_IR
			btnRadioICRGBIR.Text = ConstComStr.STR_CONFIGDLG_RADIO_IC_RGBIR
			btnRadioCDRColor.Text = ConstComStr.STR_CONFIGDLG_RADIO_RGBCD_COLOR
			btnRadioCDRGray.Text = ConstComStr.STR_CONFIGDLG_RADIO_RGBCD_GRAY
			btnRadioCDRBW.Text = ConstComStr.STR_CONFIGDLG_RADIO_RGBCD_BW
			btnRadioCDIGray.Text = ConstComStr.STR_CONFIGDLG_RADIO_IRCD_GRAY
			btnRadioCDIBW.Text = ConstComStr.STR_CONFIGDLG_RADIO_IRCD_BW
			btnCheckSCSaveFile.Text = ConstComStr.STR_CONFIGDLG_CHECK_SC_SAVEFILE

			cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_600600)
			cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_300300)
			cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_240240)
			cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_200200)
			cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_120120)
			cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_100100)

			'''/////////////
			'''/ Step 3 ////
			'''/////////////

			stGroupMICR.Text = ConstComStr.STR_CONFIGDLG_GROUP_MICR
			stGroupMICRFont.Text = ConstComStr.STR_CONFIGDLG_GROUP_MICRFONT

			btnRadioMFE13B.Text = ConstComStr.STR_CONFIGDLG_RADIO_MF_E13B
			btnRadioMFCMC7.Text = ConstComStr.STR_CONFIGDLG_RADIO_MF_CMC7

			btnCheckMIClearSpace.Text = ConstComStr.STR_CONFIGDLG_CHECK_MI_CLEARSPACE
			btnCheckMISaveFile.Text = ConstComStr.STR_CONFIGDLG_CHECK_MI_SAVEFILE

			'''/////////////
			'''/ Step 7 ////
			'''/////////////

			stGroupActivation.Text = ConstComStr.STR_CONFIGDLG_GROUP_ACTIVATIONMODE
			stGroupACActivation.Text = ConstComStr.STR_CONFIGDLG_GROUP_AM_ACTIVATIONMODE
			btnRadioAMHighSpeed.Text = ConstComStr.STR_CONFIGDLG_RADIO_AM_HIGHSPEED
			btnRadioAMConfirmation.Text = ConstComStr.STR_CONFIGDLG_RADIO_AM_CONFIRMATION
			btnCheckACConfirmationByUser.Text = ConstComStr.STR_CONFIGDLG_CHECK_AM_ONEPIECE

			stGroupWaterfall.Text = ConstComStr.STR_CONFIGDLG_GROUP_WATERFALLMODE
			stWaterfall.Text = ConstComStr.STR_CONFIGDLG_STATIC_WATERFALLMODE
			cmbWaterfall.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_WM_DISABLE)
			cmbWaterfall.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_WM_STANDARD)
			cmbWaterfall.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_WM_INHERIT)

			'''/////////////
			'''/ Step 7 ////
			'''/////////////

			stGroupIQA.Text = ConstComStr.STR_CONFIGDLG_GROUP_IQA
			stEjectPocket.Text = ConstComStr.STR_CONFIGDLG_STATIC_EJECTPOCKET
			stColorDepth.Text = ConstComStr.STR_CONFIGDLG_STATIC_COLORDEPTH

			btnCheckIQADetect.Text = ConstComStr.STR_CONFIGDLG_CHECK_IQ_DETECT
			btnCheckIQCancel.Text = ConstComStr.STR_CONFIGDLG_CHECK_IQ_CANCEL
			btnCheckIQUnderSize.Text = ConstComStr.STR_CONFIGDLG_CHECK_IQ_UNDERSIZE
			btnCheckIQOverSize.Text = ConstComStr.STR_CONFIGDLG_CHECK_IQ_OVERSIZE
			btnCheckIQMinCompressed.Text = ConstComStr.STR_CONFIGDLG_CHECK_IQ_MINCOMPRESSED
			btnCheckIQMaxCompressed.Text = ConstComStr.STR_CONFIGDLG_CHECK_IQ_MAXCOMPRESSED
			btnCheckIQFrontRearMismatch.Text = ConstComStr.STR_CONFIGDLG_CHECK_IQ_FRONTREARMISMATCH
			btnCheckIQTooLight.Text = ConstComStr.STR_CONFIGDLG_CHECK_IQ_TOOLIGHT
			btnCheckIQTooDark.Text = ConstComStr.STR_CONFIGDLG_CHECK_IQ_TOODARK
			btnCheckIQHorizontalStreaks.Text = ConstComStr.STR_CONFIGDLG_CHECK_IQ_HORIZONTALSTREAKS
			btnCheckIQSpotNoise.Text = ConstComStr.STR_CONFIGDLG_CHECK_IQ_SPOTNOISE
			btnCheckIQOutOfFocus.Text = ConstComStr.STR_CONFIGDLG_CHECK_IQ_OUTOFFOCUS
			btnCheckIQDocCorners.Text = ConstComStr.STR_CONFIGDLG_CHECK_IQ_DOCCORNERS
			btnCheckIQDocEdges.Text = ConstComStr.STR_CONFIGDLG_CHECK_IQ_DOCEDGES
			btnCheckIQFramingError.Text = ConstComStr.STR_CONFIGDLG_CHECK_IQ_FRAMINGERROR
			btnCheckIQSkew.Text = ConstComStr.STR_CONFIGDLG_CHECK_IQ_SKEW
			btnCheckIQCarbonStrip.Text = ConstComStr.STR_CONFIGDLG_CHECK_IQ_CARBONSTRIP
			btnCheckIQPiggyback.Text = ConstComStr.STR_CONFIGDLG_CHECK_IQ_PIGGYBACK

			cmbColorDepth.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_CD_GRAY)
			cmbColorDepth.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_CD_BW)
			cmbEjectPocket.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_EP_MAINPOCKET)
			cmbEjectPocket.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_EP_SUBPOCKET)
			cmbEjectPocket.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_EP_NOEJECT)
		End Sub

		Private Sub SetControlData()
			'''/////////////
			'''/ Step 2 ////
			'''/////////////

			Select Case m_objConfigData.nRadio_ScanningMedia
				Case ConstComVal.VAL_CONFIGDLG_RADIO_SM_CHECKPAPER
					btnRadioSMCheckPaper.Checked = True
					btnRadioSMCard.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_SM_CARD
					btnRadioSMCheckPaper.Checked = False
					btnRadioSMCard.Checked = True
					Exit Select
				Case Else
					Debug.Assert(False)
					Exit Select
			End Select

			Select Case m_objConfigData.nRadio_LightSourceToScan
				Case ConstComVal.VAL_CONFIGDLG_RADIO_IC_RGB
					btnRadioICRGB.Checked = True
					btnRadioICIR.Checked = False
					btnRadioICRGBIR.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_IC_IR
					btnRadioICRGB.Checked = False
					btnRadioICIR.Checked = True
					btnRadioICRGBIR.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_IC_RGBIR
					btnRadioICRGB.Checked = False
					btnRadioICIR.Checked = False
					btnRadioICRGBIR.Checked = True
					Exit Select
				Case Else
					Debug.Assert(False)
					Exit Select
			End Select
			Select Case m_objConfigData.nRadio_RGBColorDepth
				Case ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_COLOR
					btnRadioCDRColor.Checked = True
					btnRadioCDRGray.Checked = False
					btnRadioCDRBW.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_GRAY
					btnRadioCDRColor.Checked = False
					btnRadioCDRGray.Checked = True
					btnRadioCDRBW.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_BW
					btnRadioCDRColor.Checked = False
					btnRadioCDRGray.Checked = False
					btnRadioCDRBW.Checked = True
					Exit Select
				Case Else
					Debug.Assert(False)
					Exit Select
			End Select
			Select Case m_objConfigData.nRadio_IRColorDepth
				Case ConstComVal.VAL_CONFIGDLG_RADIO_IRCD_GRAY
					btnRadioCDIGray.Checked = True
					btnRadioCDIBW.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_IRCD_BW
					btnRadioCDIGray.Checked = False
					btnRadioCDIBW.Checked = True
					Exit Select
				Case Else
					Debug.Assert(False)
					Exit Select
			End Select

			SetIndexResolutionCombobox(m_objConfigData.nCombo_Resolution)

			udNumberOfDocuments.Minimum = 0
			udNumberOfDocuments.Maximum = 255
			udNumberOfDocuments.Value = Convert.ToDecimal(m_objConfigData.byNumeric_NumberOfDocuments)

			btnCheckSCSaveFile.Checked = m_objConfigData.bCheck_Scan_SaveFile

			'''/////////////
			'''/ Step 3 ////
			'''/////////////

			Select Case m_objConfigData.nRadio_MICRFont
				Case ConstComVal.VAL_CONFIGDLG_RADIO_MF_E13B
					btnRadioMFE13B.Checked = True
					btnRadioMFCMC7.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_MF_CMC7
					btnRadioMFE13B.Checked = False
					btnRadioMFCMC7.Checked = True
					Exit Select
				Case Else
					Debug.Assert(False)
					Exit Select
			End Select

			btnCheckMIClearSpace.Checked = m_objConfigData.bCheck_MICR_ClearSpace
			btnCheckMISaveFile.Checked = m_objConfigData.bCheck_MICR_SaveFile

			'''/////////////
			'''/ Step 7 ////
			'''/////////////

			Select Case m_objConfigData.nRadio_ActivationMode
				Case ConstComVal.VAL_CONFIGDLG_RADIO_AM_HIGHSPEED
					btnRadioAMHighSpeed.Checked = True
					btnRadioAMConfirmation.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_AM_CONFIRMATION
					btnRadioAMHighSpeed.Checked = False
					btnRadioAMConfirmation.Checked = True
					Exit Select
				Case Else
					Exit Select
			End Select

			btnCheckACConfirmationByUser.Checked = m_objConfigData.bCheck_ConfirmationByUser
			cmbWaterfall.SelectedIndex = m_objConfigData.nCombo_WaterfallMode

			'''/////////////
			'''/ Step 7 ////
			'''/////////////

			btnCheckIQADetect.Checked = m_objConfigData.bCheck_IQA_Detect
			btnCheckIQCancel.Checked = m_objConfigData.bCheck_IQA_Cancel
			cmbEjectPocket.SelectedIndex = m_objConfigData.nCombo_IqaEjectPocket
			cmbColorDepth.SelectedIndex = m_objConfigData.nCombo_IqaColorDepth

			btnCheckIQUnderSize.Checked = m_objConfigData.bCheck_IQA_UnderSize
			btnCheckIQOverSize.Checked = m_objConfigData.bCheck_IQA_OverSize
			btnCheckIQMinCompressed.Checked = m_objConfigData.bCheck_IQA_MinCompressed
			btnCheckIQMaxCompressed.Checked = m_objConfigData.bCheck_IQA_MaxCompressed
			btnCheckIQFrontRearMismatch.Checked = m_objConfigData.bCheck_IQA_FrontRearMismatch
			btnCheckIQTooLight.Checked = m_objConfigData.bCheck_IQA_TooLight
			btnCheckIQTooDark.Checked = m_objConfigData.bCheck_IQA_TooDark
			btnCheckIQHorizontalStreaks.Checked = m_objConfigData.bCheck_IQA_HorizontalStreaks
			btnCheckIQSpotNoise.Checked = m_objConfigData.bCheck_IQA_SpotNoise
			btnCheckIQOutOfFocus.Checked = m_objConfigData.bCheck_IQA_OutOfFocus
			btnCheckIQDocCorners.Checked = m_objConfigData.bCheck_IQA_DocCorners
			btnCheckIQDocEdges.Checked = m_objConfigData.bCheck_IQA_DocEdges
			btnCheckIQFramingError.Checked = m_objConfigData.bCheck_IQA_FramingError
			btnCheckIQSkew.Checked = m_objConfigData.bCheck_IQA_Skew
			btnCheckIQCarbonStrip.Checked = m_objConfigData.bCheck_IQA_CarbonStrip
			btnCheckIQPiggyback.Checked = m_objConfigData.bCheck_IQA_Piggyback
		End Sub

		Private Sub GetControlData()
			'''/////////////
			'''/ Step 2 ////
			'''/////////////

			If btnRadioSMCheckPaper.Checked = True Then
				m_objConfigData.nRadio_ScanningMedia = ConstComVal.VAL_CONFIGDLG_RADIO_SM_CHECKPAPER
			ElseIf btnRadioSMCard.Checked = True Then
				m_objConfigData.nRadio_ScanningMedia = ConstComVal.VAL_CONFIGDLG_RADIO_SM_CARD
			Else
				Debug.Assert(False)
			End If

			If btnRadioICRGB.Checked = True Then
				m_objConfigData.nRadio_LightSourceToScan = ConstComVal.VAL_CONFIGDLG_RADIO_IC_RGB
			ElseIf btnRadioICIR.Checked = True Then
				m_objConfigData.nRadio_LightSourceToScan = ConstComVal.VAL_CONFIGDLG_RADIO_IC_IR
			ElseIf btnRadioICRGBIR.Checked = True Then
				m_objConfigData.nRadio_LightSourceToScan = ConstComVal.VAL_CONFIGDLG_RADIO_IC_RGBIR
			End If

			If btnRadioCDRColor.Checked = True Then
				m_objConfigData.nRadio_RGBColorDepth = ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_COLOR
			ElseIf btnRadioCDRGray.Checked = True Then
				m_objConfigData.nRadio_RGBColorDepth = ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_GRAY
			ElseIf btnRadioCDRBW.Checked = True Then
				m_objConfigData.nRadio_RGBColorDepth = ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_BW
			End If

			If btnRadioCDIGray.Checked = True Then
				m_objConfigData.nRadio_IRColorDepth = ConstComVal.VAL_CONFIGDLG_RADIO_IRCD_GRAY
			ElseIf btnRadioCDIBW.Checked = True Then
				m_objConfigData.nRadio_IRColorDepth = ConstComVal.VAL_CONFIGDLG_RADIO_IRCD_BW
			End If

			m_objConfigData.nCombo_Resolution = GetValueResolutionCombobox()

			m_objConfigData.byNumeric_NumberOfDocuments = Convert.ToByte(udNumberOfDocuments.Value)

			m_objConfigData.bCheck_Scan_SaveFile = btnCheckSCSaveFile.Checked

			'''/////////////
			'''/ Step 3 ////
			'''/////////////

			If btnRadioMFE13B.Checked = True Then
				m_objConfigData.nRadio_MICRFont = ConstComVal.VAL_CONFIGDLG_RADIO_MF_E13B
			ElseIf btnRadioMFCMC7.Checked = True Then
				m_objConfigData.nRadio_MICRFont = ConstComVal.VAL_CONFIGDLG_RADIO_MF_CMC7
			Else
				Debug.Assert(False)
			End If

			m_objConfigData.bCheck_MICR_ClearSpace = btnCheckMIClearSpace.Checked
			m_objConfigData.bCheck_MICR_SaveFile = btnCheckMISaveFile.Checked

			'''/////////////
			'''/ Step 7 ////
			'''/////////////

			If btnRadioAMHighSpeed.Checked = True Then
				m_objConfigData.nRadio_ActivationMode = ConstComVal.VAL_CONFIGDLG_RADIO_AM_HIGHSPEED
			ElseIf btnRadioAMConfirmation.Checked = True Then
				m_objConfigData.nRadio_ActivationMode = ConstComVal.VAL_CONFIGDLG_RADIO_AM_CONFIRMATION
			Else
				Debug.Assert(False)
			End If

			m_objConfigData.bCheck_ConfirmationByUser = btnCheckACConfirmationByUser.Checked
			m_objConfigData.nCombo_WaterfallMode = cmbWaterfall.SelectedIndex

			'''/////////////
			'''/ Step 7 ////
			'''/////////////

			m_objConfigData.bCheck_IQA_Detect = btnCheckIQADetect.Checked
			m_objConfigData.bCheck_IQA_Cancel = btnCheckIQCancel.Checked
			m_objConfigData.nCombo_IqaEjectPocket = cmbEjectPocket.SelectedIndex
			m_objConfigData.nCombo_IqaColorDepth = cmbColorDepth.SelectedIndex

			m_objConfigData.bCheck_IQA_UnderSize = btnCheckIQUnderSize.Checked
			m_objConfigData.bCheck_IQA_OverSize = btnCheckIQOverSize.Checked
			m_objConfigData.bCheck_IQA_MinCompressed = btnCheckIQMinCompressed.Checked
			m_objConfigData.bCheck_IQA_MaxCompressed = btnCheckIQMaxCompressed.Checked
			m_objConfigData.bCheck_IQA_FrontRearMismatch = btnCheckIQFrontRearMismatch.Checked
			m_objConfigData.bCheck_IQA_TooLight = btnCheckIQTooLight.Checked
			m_objConfigData.bCheck_IQA_TooDark = btnCheckIQTooDark.Checked
			m_objConfigData.bCheck_IQA_HorizontalStreaks = btnCheckIQHorizontalStreaks.Checked
			m_objConfigData.bCheck_IQA_SpotNoise = btnCheckIQSpotNoise.Checked
			m_objConfigData.bCheck_IQA_OutOfFocus = btnCheckIQOutOfFocus.Checked
			m_objConfigData.bCheck_IQA_DocCorners = btnCheckIQDocCorners.Checked
			m_objConfigData.bCheck_IQA_DocEdges = btnCheckIQDocEdges.Checked
			m_objConfigData.bCheck_IQA_FramingError = btnCheckIQFramingError.Checked
			m_objConfigData.bCheck_IQA_Skew = btnCheckIQSkew.Checked
			m_objConfigData.bCheck_IQA_CarbonStrip = btnCheckIQCarbonStrip.Checked
			m_objConfigData.bCheck_IQA_Piggyback = btnCheckIQPiggyback.Checked
		End Sub

		Private Sub UpdateControls()
			'''/////////////
			'''/ Step 2 ////
			'''/////////////

			' LightSource
			If btnRadioSMCard.Checked = True AndAlso m_objConfigData.bIsScanningCardIR1PassSupported = False Then
				btnRadioICRGBIR.Enabled = False

				If btnRadioICRGBIR.Checked = True Then
					btnRadioICIR.Checked = True
					btnRadioICRGBIR.Checked = False
				End If
			Else
				btnRadioICRGBIR.Enabled = True
			End If

			' RGB ColorDepth Color
			If btnRadioICIR.Checked = True Then
				btnRadioCDRColor.Enabled = False
			Else
				btnRadioCDRColor.Enabled = True
			End If

			' RGB ColorDepth Gray
			If btnRadioICIR.Checked = True Then
				btnRadioCDRGray.Enabled = False
			Else
				btnRadioCDRGray.Enabled = True
			End If

			' RGB ColorDepth B/W
			If btnRadioICIR.Checked = True OrElse btnRadioSMCard.Checked = True Then
				btnRadioCDRBW.Enabled = False
			Else
				btnRadioCDRBW.Enabled = True
			End If

			' IR ColorDepth Gray
			If btnRadioICRGB.Checked = True Then
				btnRadioCDIGray.Enabled = False
			Else
				btnRadioCDIGray.Enabled = True
			End If

			' IR ColorDepth B/W
			If btnRadioICRGB.Checked = True OrElse btnRadioSMCard.Checked = True Then
				btnRadioCDIBW.Enabled = False
			Else
				btnRadioCDIBW.Enabled = True
			End If

			If btnRadioCDRBW.Checked = True AndAlso btnRadioCDRGray.Enabled.Equals(True) AndAlso Not btnRadioCDRBW.Enabled.Equals(True) Then
				btnRadioCDRColor.Checked = False
				btnRadioCDRGray.Checked = True
				btnRadioCDRBW.Checked = False
			End If
			If btnRadioCDIBW.Checked = True AndAlso btnRadioCDIGray.Enabled.Equals(True) AndAlso Not btnRadioCDIBW.Enabled.Equals(True) Then
				btnRadioCDIGray.Checked = True
				btnRadioCDIBW.Checked = False
			End If

			' Updating resolution options for scanning unit
			Dim strResolution As String = cmbResolution.Text
			If btnRadioSMCheckPaper.Checked = True Then
				cmbResolution.Items.Clear()
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_300300)
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_240240)
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_200200)
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_120120)
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_100100)
				cmbResolution.SelectedIndex = 2
			ElseIf btnRadioSMCard.Checked = True Then
				cmbResolution.Items.Clear()
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_600600)
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_300300)
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_200200)
				cmbResolution.SelectedIndex = 1
			Else
				Debug.Assert(False)
			End If
			' restore the selection.
			Dim nIndex As Integer = cmbResolution.FindString(strResolution)
			If nIndex <> -1 Then
				cmbResolution.SelectedIndex = nIndex
			End If

			'''/////////////
			'''/ Step 3 ////
			'''/////////////

			If btnRadioSMCard.Checked = True Then
				btnRadioMFE13B.Enabled = False
				btnRadioMFCMC7.Enabled = False
				btnCheckMIClearSpace.Enabled = False
				btnCheckMISaveFile.Enabled = False
			ElseIf btnRadioSMCheckPaper.Checked = True Then
				btnRadioMFE13B.Enabled = True
				btnRadioMFCMC7.Enabled = True
				btnCheckMIClearSpace.Enabled = True
				btnCheckMISaveFile.Enabled = True
			Else
				Debug.Assert(False)
			End If

			'''/////////////
			'''/ Step 7 ////
			'''/////////////

			If btnRadioSMCard.Checked = True Then
				cmbWaterfall.Enabled = False
				stGroupIQA.Enabled = False
				btnCheckIQADetect.Enabled = False
				btnRadioAMHighSpeed.Enabled = False
				btnRadioAMConfirmation.Enabled = False
			ElseIf btnRadioSMCheckPaper.Checked = True Then
				cmbWaterfall.Enabled = True
				If btnRadioICIR.Checked = False AndAlso btnRadioCDRColor.Checked = False Then
					stGroupIQA.Enabled = True
					btnCheckIQADetect.Enabled = True
				Else
					stGroupIQA.Enabled = False
					btnCheckIQADetect.Enabled = False
				End If
				btnRadioAMHighSpeed.Enabled = True
				btnRadioAMConfirmation.Enabled = True
			Else
				Debug.Assert(False)
			End If

			If btnCheckIQADetect.Checked = True AndAlso btnRadioSMCheckPaper.Checked = True Then
				If cmbWaterfall.SelectedIndex = ConstComVal.VAL_CONFIGDLG_COMBO_WM_DISABLE Then
					btnCheckIQCancel.Enabled = True
					stEjectPocket.Enabled = True
					cmbEjectPocket.Enabled = True
				Else
					btnCheckIQCancel.Enabled = False
					stEjectPocket.Enabled = False
					cmbEjectPocket.Enabled = False
				End If

				stColorDepth.Enabled = True
				cmbColorDepth.Enabled = True

				btnCheckIQUnderSize.Enabled = True
				btnCheckIQOverSize.Enabled = True
				btnCheckIQMinCompressed.Enabled = True
				btnCheckIQMaxCompressed.Enabled = True
				btnCheckIQFrontRearMismatch.Enabled = True
				btnCheckIQTooLight.Enabled = True
				btnCheckIQTooDark.Enabled = True
				btnCheckIQHorizontalStreaks.Enabled = True
				btnCheckIQSpotNoise.Enabled = True
				btnCheckIQOutOfFocus.Enabled = True
				btnCheckIQDocCorners.Enabled = True
				btnCheckIQDocEdges.Enabled = True
				btnCheckIQFramingError.Enabled = True
				btnCheckIQSkew.Enabled = True
				btnCheckIQCarbonStrip.Enabled = True
				btnCheckIQPiggyback.Enabled = True
			Else
				btnCheckIQCancel.Enabled = False
				stEjectPocket.Enabled = False
				cmbEjectPocket.Enabled = False

				stColorDepth.Enabled = False
				cmbColorDepth.Enabled = False

				btnCheckIQUnderSize.Enabled = False
				btnCheckIQOverSize.Enabled = False
				btnCheckIQMinCompressed.Enabled = False
				btnCheckIQMaxCompressed.Enabled = False
				btnCheckIQFrontRearMismatch.Enabled = False
				btnCheckIQTooLight.Enabled = False
				btnCheckIQTooDark.Enabled = False
				btnCheckIQHorizontalStreaks.Enabled = False
				btnCheckIQSpotNoise.Enabled = False
				btnCheckIQOutOfFocus.Enabled = False
				btnCheckIQDocCorners.Enabled = False
				btnCheckIQDocEdges.Enabled = False
				btnCheckIQFramingError.Enabled = False
				btnCheckIQSkew.Enabled = False
				btnCheckIQCarbonStrip.Enabled = False
				btnCheckIQPiggyback.Enabled = False
			End If

			If btnRadioAMConfirmation.Checked = True AndAlso btnRadioAMConfirmation.Enabled = True AndAlso cmbWaterfall.SelectedIndex = ConstComVal.VAL_CONFIGDLG_COMBO_WM_DISABLE Then
				btnCheckACConfirmationByUser.Enabled = True
			Else
				btnCheckACConfirmationByUser.Enabled = False
			End If
		End Sub

		'''/////////////
		'''/ Step 2 ////
		'''/////////////

		Private Sub btnOK_Click(sender As Object, e As EventArgs)
			GetControlData()
			Close()
		End Sub

		Private Sub btnCancel_Click(sender As Object, e As EventArgs)
			Close()
		End Sub

		Private Sub OnChangeRadioScanningMedia(sender As Object, e As EventArgs)
			UpdateControls()
		End Sub

		Private Sub OnChangeRadioLightSource(sender As Object, e As EventArgs)
			UpdateControls()
		End Sub

		'''/////////////
		'''/ Step 7 ////
		'''/////////////

		Private Sub btnRadioAMHighSpeed_CheckedChanged(sender As Object, e As EventArgs)
			UpdateControls()
		End Sub

		Private Sub btnRadioAMConfirmation_CheckedChanged(sender As Object, e As EventArgs)
			UpdateControls()
		End Sub

		Private Sub btnCheckIQDetect_Click(sender As Object, e As EventArgs)
			UpdateControls()
		End Sub

		Private Sub OnChangeRadioRgbColorDepth(sender As Object, e As EventArgs)
			UpdateControls()
		End Sub

		Private Sub OnCbnSelchangeComboIQAColorDepth(sender As Object, e As EventArgs)
			UpdateControls()
		End Sub

		'''/////////////
		'''/ Step 2 ////
		'''/////////////

		Private Sub SetIndexResolutionCombobox(nResolution As Integer)
			Dim strResolution As String = ""
			Select Case nResolution
				Case ConstComVal.VAL_CONFIGDLG_COMBO_RE_600600
					strResolution = ConstComStr.STR_CONFIGDLG_COMBO_RE_600600
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_COMBO_RE_300300
					strResolution = ConstComStr.STR_CONFIGDLG_COMBO_RE_300300
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_COMBO_RE_240240
					strResolution = ConstComStr.STR_CONFIGDLG_COMBO_RE_240240
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_COMBO_RE_200200
					strResolution = ConstComStr.STR_CONFIGDLG_COMBO_RE_200200
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_COMBO_RE_120120
					strResolution = ConstComStr.STR_CONFIGDLG_COMBO_RE_120120
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_COMBO_RE_100100
					strResolution = ConstComStr.STR_CONFIGDLG_COMBO_RE_100100
					Exit Select
				Case Else
					Debug.Assert(False)
					Return
			End Select
			Dim nIndex As Integer = cmbResolution.FindString(strResolution)
			If nIndex <> -1 Then
				cmbResolution.SelectedIndex = nIndex
			Else
				cmbResolution.SelectedIndex = 0
			End If
		End Sub

		Private Function GetValueResolutionCombobox() As Integer
			Select Case cmbResolution.SelectedItem.ToString()
				Case ConstComStr.STR_CONFIGDLG_COMBO_RE_600600
					Return ConstComVal.VAL_CONFIGDLG_COMBO_RE_600600
				Case ConstComStr.STR_CONFIGDLG_COMBO_RE_300300
					Return ConstComVal.VAL_CONFIGDLG_COMBO_RE_300300
				Case ConstComStr.STR_CONFIGDLG_COMBO_RE_240240
					Return ConstComVal.VAL_CONFIGDLG_COMBO_RE_240240
				Case ConstComStr.STR_CONFIGDLG_COMBO_RE_200200
					Return ConstComVal.VAL_CONFIGDLG_COMBO_RE_200200
				Case ConstComStr.STR_CONFIGDLG_COMBO_RE_120120
					Return ConstComVal.VAL_CONFIGDLG_COMBO_RE_120120
				Case ConstComStr.STR_CONFIGDLG_COMBO_RE_100100
					Return ConstComVal.VAL_CONFIGDLG_COMBO_RE_100100
				Case Else
					Debug.Assert(False)
					Return -1
			End Select
		End Function
	End Class
End Namespace
