Imports System.Diagnostics
Imports com.epson.bank.driver

Namespace TMS_Sample
	Class CIqa
		Private m_objProperty As CProperty_1 = Nothing

		Public Sub New()
		End Sub

		Public Function Init(objProperty As CProperty_1) As ErrorCode
			Dim errResult As ErrorCode = ErrorCode.SUCCESS
			m_objProperty = objProperty

			Return errResult
		End Function

		' Set IQA test conditions
		Public Function SetIqaSetting() As ErrorCode
			Dim errResult As ErrorCode = ErrorCode.SUCCESS

			errResult = m_objProperty.GetMfDevice().SCNMICRFunctionContinuously(m_objProperty.GetMfIqa(), FunctionType.MF_GET_IQA_DEFAULT)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			m_objProperty.GetMfIqa().ErrorSelect = m_objProperty.GetIqaDetect()
			m_objProperty.GetMfIqa().ErrorEject = m_objProperty.GetIqaEjectPocket()
			m_objProperty.GetMfIqa().Resolution = m_objProperty.GetResolution()

			If m_objProperty.GetIqaDetect() = MfErrorSelect.MF_ERROR_SELECT_DETECT Then
				m_objProperty.GetMfIqa().Cancel = m_objProperty.GetIqaCancel()
				m_objProperty.GetMfIqa().Undersize = m_objProperty.GetUnderSize()
				m_objProperty.GetMfIqa().Oversize = m_objProperty.GetOverSize()
				m_objProperty.GetMfIqa().Mincompressed = m_objProperty.GetMinCompressed()
				m_objProperty.GetMfIqa().Maxcompressed = m_objProperty.GetMaxCompressed()
				m_objProperty.GetMfIqa().Front_rear = m_objProperty.GetFrontRearImageMismatch()
				m_objProperty.GetMfIqa().Toolight = m_objProperty.GetImageTooLight()
				m_objProperty.GetMfIqa().Toodark = m_objProperty.GetImageTooDark()
				m_objProperty.GetMfIqa().Streaks = m_objProperty.GetHorizontalStreaksPresent()
				m_objProperty.GetMfIqa().Noise = m_objProperty.GetSpotNoise()
				m_objProperty.GetMfIqa().Focus = m_objProperty.GetOutOfFocus()
				m_objProperty.GetMfIqa().Corners = m_objProperty.GetFoldedTornCorner()
				m_objProperty.GetMfIqa().Edges = m_objProperty.GetFoldedTornEdge()
				m_objProperty.GetMfIqa().Framing = m_objProperty.GetFramingError()
				m_objProperty.GetMfIqa().Skew = m_objProperty.GetExcessiveSkew()
				m_objProperty.GetMfIqa().Carbon = m_objProperty.GetCarbonStripDetection()
				m_objProperty.GetMfIqa().Piggyback = m_objProperty.GetPiggyback()

				If m_objProperty.GetIqaColorDepth() = ColorDepth.EPS_BI_SCN_1BIT Then
					m_objProperty.GetMfIqa().ImageFormat = Format.EPS_BI_SCN_TIFF
				Else
					m_objProperty.GetMfIqa().ImageFormat = Format.EPS_BI_SCN_JPEGNORMAL
				End If
			End If

			errResult = m_objProperty.GetMfDevice().SCNMICRFunctionContinuously(m_objProperty.GetMfIqa(), FunctionType.MF_SET_IQA_PARAM)
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			Return errResult
		End Function

		' Obtain IQA test result
		Public Function GetIqaResult(ByRef objIqaResult As CIqaResult) As ErrorCode
			If objIqaResult Is Nothing Then
				Return ErrorCode.ERR_UNKNOWN
			End If

			Dim errResult As ErrorCode = ErrorCode.SUCCESS

			errResult = m_objProperty.GetMfDevice().GetIqaResult(m_objProperty.GetTransactionNumber(), m_objProperty.GetMfIqaResult())
			Debug.Assert(errResult = ErrorCode.SUCCESS)
			If errResult <> ErrorCode.SUCCESS Then
				Return errResult
			End If

			objIqaResult.SetUnderSize(m_objProperty.GetMfIqaResult().UndersizeImage.Result)
			objIqaResult.SetOverSize(m_objProperty.GetMfIqaResult().OversizeImage.Result)
			objIqaResult.SetMinCompressed(m_objProperty.GetMfIqaResult().MinCompressedImageSize.Result)
			objIqaResult.SetMaxCompressed(m_objProperty.GetMfIqaResult().MaxCompressedImageSize.Result)
			objIqaResult.SetFrontRearImageMismatch(m_objProperty.GetMfIqaResult().FrontRearImageMismatch.Result)
			objIqaResult.SetImageTooLight(m_objProperty.GetMfIqaResult().ImageTooLight.Result)
			objIqaResult.SetImageTooDark(m_objProperty.GetMfIqaResult().ImageTooDark.Result)
			objIqaResult.SetHorizontalStreaksPresent(m_objProperty.GetMfIqaResult().HorizontalStreaksPresent.Result)
			objIqaResult.SetSpotNosise(m_objProperty.GetMfIqaResult().ExcessiveSpotNoise.Result)
			objIqaResult.SetOutOfFocus(m_objProperty.GetMfIqaResult().ImageOutOfFocus.Result)
			objIqaResult.SetFoldedTornCorner(m_objProperty.GetMfIqaResult().FoldedTornDocCorners.Result)
			objIqaResult.SetFoldedTornEdge(m_objProperty.GetMfIqaResult().FoldedTornDocEdges.Result)
			objIqaResult.SetFramingError(m_objProperty.GetMfIqaResult().DocFramingError.Result)
			objIqaResult.SetExcessiveSkew(m_objProperty.GetMfIqaResult().ExcessiveDocSkew.Result)
			objIqaResult.SetCarbonStripDetection(m_objProperty.GetMfIqaResult().CarbonStripDetection.Result)
			objIqaResult.SetPiggyback(m_objProperty.GetMfIqaResult().Piggyback.Result)

			Return errResult
		End Function
	End Class
End Namespace
